/*******************************************************************
 *
 * COPYRIGHT (c) 1994,1995 Matrox Electronic Systems Ltd.
 * All Rights Reserved
 *
 *******************************************************************/

/*******************************************************************
 *
 * Synopsis:         This file contains few examples of Genesis
 *                   C-Bindings usage.
 *
 * Last modified:    Nov 4, 1996
 *
 * Notes:
 *
 *******************************************************************/

// #define TEST_GRAB_INT


/** include files      **/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <malloc.h>
#include <math.h>


#if defined(_IM_HOST_OS_NT)
#include <windows.h>
#endif

#include <imapi.h>         /* Genesis C-Binding API prototypes and defines */

#if defined(TEST_GRAB_INT)
#include <image2.h>        /* For DTK users only */
#endif

/** local definitions  **/

/** default settings   **/

/** external functions **/

/** external data      **/

/** internal functions **/

/** public data        **/

/** private data       **/
#if defined(TEST_GRAB_INT)
static int testGrabInt  = 0;
#endif
static int testDevAlloc = 0;
static int testInquire  = 0;
static int keepTextMode = 0;
static int sleepActive  = 0;


static int HaltProcess = 0;


static char *NameBase[] =
   {
      "earth4.tif",
      "logo3.tif",
      "hwteam.tif",
      "im2team.tif",
      "lifein4.tif",
      "fido2.tif",
      "genesis.tif"
   };


enum {
   EARTH4 = 0,
   LOGO3,
   HWTEAM,
   IM2TEAM,
   LIFEIN4,
   FIDO2,
   GENESIS
};

static long BufImg[sizeof(NameBase) / sizeof(char *)];


#define F   0xff

static short  LutLife[] =
{
   0, 0, 0, 0, 0, 0, 0, F, 0, 0, 0, F, 0, F, F, 0,
   0, 0, 0, F, 0, F, F, 0, 0, F, F, 0, F, 0, 0, 0,
   0, 0, 0, F, 0, F, F, 0, 0, F, F, 0, F, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, F, 0, F, F, 0, 0, F, F, 0, F, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, F, 0, F, F, 0, 0, F, F, 0, F, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, F, 0, F, F, F, 0, F, F, F, F, F, F, 0,
   0, F, F, F, F, F, F, 0, F, F, F, 0, F, 0, 0, 0,
   0, F, F, F, F, F, F, 0, F, F, F, 0, F, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   0, F, F, F, F, F, F, 0, F, F, F, 0, F, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, F, F, F, F, F, F, 0, F, F, F, 0, F, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   F, F, F, 0, F, 0, 0, 0, F, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   F, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

#undef F

static long GenesisFbDestination = IM_DISP_MONO;
static long GenesisDisplayMode   = IM_DISP_MONO;

static long Xres, Yres;


/** public functions   **/

/** private functions  **/
static void GameOfLife(long Thread, int Index);
static void Skeleton(long Thread, int Index);
static void Process(long Thread);
static void TempFilter(long Thread);
static void WarpSub(long Thread, int Index);
static void CopyPCI(long Thread, int Index, int userCount);

static void Sphere(long Thread, short * XData, short * YData);
static void Sphere_GenXY(short *XPtr, short *YPtr);
static void Genesis(long Thread);
static void LcOperations(long Thread1, long Thread2);

static void PrintHdr(void);
static void MyHalt(int SigNo);
static void CleanKeyboard(void);
static void OSsleep(double sleepTime);

/* Prototype for error handler function */
void ErrHandler(void *Param);
IM_EXTC TIME_TYPE IM_FTYPE mp_time_clock(TIME_TYPE StartTime);

#if defined(TEST_GRAB_INT)
static unsigned long EogCount = 0;

static long IM_FTYPE TestHandler(PGENESIS_HOOK_LIST pHookList)
{
   EogCount++;

#if defined(_IM_HOST_OS_NT)

   printf("%06ld\b\b\b\b\b\b", EogCount);

   HANDLE hEvent = GenesisGetHandleEvent(GenesisGetNextHookFunction(pHookList, NULL));

   if (hEvent != 0)
      SetEvent(hEvent);

#elif defined(_IM_HOST_OS_DOS)


#endif

   return(0);

}  /* TestHandler() */
#endif


/*---------------------------------------------------------------------------
 *
 * Name:          main()
 *
 * Synopsis:      Main demo program
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    none
 *
 * Returns:       none
 *
 */

void main( int argc, char *argv[] )
{

   long  Device1 = 0, Device2 = 0,
         Thread1 = 0, Thread2 = 0, MainThreadControl, Thread,
         ImageIndex;
   long  DisplayControl;
   long  ThisDisp;
   int   ii;
   short * XData = NULL,
         * YData = NULL;
   long  vgaMode;
   long  DispID = 0;
   char  msg[IM_ERR_SIZE] = "";
   int   NbOfDevice = 1;

   for( ii = 1; ii < argc; ++ii )
   {
      if (strcmp(argv[ii], "?") == 0)
      {
         printf("Usage: play [GREEN|RED|COLOR] [-grabint] [-devalloc] [-inquire] [-textonly]\n");
         printf("       [COLOR|GREEN|RED] : COLOR to start display in COLOR mode with BLUE as\n");
         printf("                           default color plane.\n");
         printf("                           GREEN color plane.\n");
         printf("                           RED color plane.\n");
#if defined(TEST_GRAB_INT)
         printf("       [-grabint]        : Test Interrupt Hook\n");
#endif
         printf("       [-devalloc]       : Test DevAlloc/DevFree loop\n");
         printf("       [-inquire]        : Test board inquire\n");
         printf("       [-textonly]       : Text only mode\n");
         printf("       [-sleepon]        : Active various sleep in demo to slowdown\n");

         exit(0);
      }

      if (strcmp(argv[ii], "GREEN") == 0)
         GenesisFbDestination = IM_DISP_GREEN;

      if (strcmp(argv[ii], "RED") == 0)
         GenesisFbDestination = IM_DISP_RED;

      if (strcmp(argv[ii], "COLOR") == 0)
      {
         GenesisFbDestination = IM_DISP_BLUE;
         GenesisDisplayMode = IM_DISP_COLOR;
      }

#if defined(TEST_GRAB_INT)
      if (strcmp(argv[ii], "-grabint") == 0)
         testGrabInt = 1;
#endif

      if (strcmp(argv[ii], "-devalloc") == 0)
         testDevAlloc = 1;

      if (strcmp(argv[ii], "-inquire") == 0)
         testInquire  = 1;

      if (strcmp(argv[ii], "-textonly") == 0)
         keepTextMode = 1;

      if (strcmp(argv[ii], "-sleepon") == 0)
         sleepActive = 1;
   }

   PrintHdr();

   signal(SIGBREAK,  MyHalt);     /* Catch Ctrl-Break */

   if (testDevAlloc)
   {
      CleanKeyboard();

      for (int kk=0; !kbhit(); kk++)
      {
         /* Allocate Genesis Board */
         //int numSys = imSysInquire(0, IM_SYS_NUM_SYSTEMS, NULL);

         printf("+\b");

         imDevAlloc(0, 0, NULL, IM_DEFAULT, &Device1);
         imDevFree(Device1);

         //numSys = imSysInquire(0, IM_SYS_NUM_SYSTEMS, NULL);

         printf("-%05d\b\b\b\b\b\b", kk);

         OSsleep(2.0);
      }
   }


   /* install the error handler */
   imAppCatchError(IM_DEFAULT, ErrHandler, NULL);

   /* Allocate Genesis Board */
   imDevAlloc(0, 0, NULL, IM_DEFAULT, &Device1);

   if (imSysInquire(0, IM_SYS_NUM_NODES, NULL) > 1)
      imDevAlloc(0, 1, NULL, IM_DEFAULT, &Device2);

   else if (imSysInquire(0, IM_SYS_NUM_SYSTEMS, NULL) > 1)
      imDevAlloc(1, 0, NULL, IM_DEFAULT, &Device2);


   if (!Device1 && !Device2)
      printf("No device found.\n");

   else if (!Device1 && Device2)
   {
      Device1 = Device2;   /* Device 2 will be the Device 1 for the demo */
      printf("Device 1 not available. Use Device 2 as default.\n");
   }

   else if (Device1 && !Device2)
   {
      Device2 = Device1;   /* Device 1 will be the Device 2 for the demo */
      printf("Device 2 not available. Use Device 1 as default.\n");
   }

   else
   {
      printf("Both devices available for the demo.\n");
   }


   if (Device2 != Device1)
   {
      NbOfDevice = 2;
      imThrAlloc(Device2, 0, &Thread2);
   }

   if (Device1)
   {
#if defined(TEST_GRAB_INT)
      if (testGrabInt)
      {
         // GenesisHookInterruptFunction(0x11, TestHandler, MP_PVIA_INTLVL_EOGINT, NULL, NULL);
         GenesisHookInterruptFunction(0x11, TestHandler, MP_DVIA_INTLVL_EOGINT, NULL, NULL);
      }
#endif


      if (testInquire)
      {
         unsigned long InqVal;

         imDevInquire(Device1, IM_DEV_CUSTOMER_PRODUCT_ID, &InqVal);
         imDevInquire(Device1, IM_DEV_PRODUCT_SERIAL_NUMBER, &InqVal);
         imDevInquire(Device1, IM_DEV_FREE_MEM_PROC, &InqVal);
         imDevInquire(Device1, IM_DEV_FREE_MEM_DISP, &InqVal);

         imDevInquire(Device1, IM_DEV_MSG_FREE, &InqVal);

         imSysInquire(0, IM_SYS_NUM_DIGITIZERS, &InqVal);
         imSysInquire(0, IM_SYS_NUM_DISPLAYS, &InqVal);

         imSysInquire(0, IM_SYS_PRODUCT_LIST, &InqVal);

         IM_SYS_PRODUCT_LIST_ST *ProductList = (IM_SYS_PRODUCT_LIST_ST *)InqVal;
         IM_SYS_PRODUCT_LIST_ST *thisProductList = ProductList;

         while (thisProductList && thisProductList->NodeId)
         {
            printf("NodeId=0x%02lx ProductId=%lx ExtModuleType=%lx\n", thisProductList->NodeId, thisProductList->ProductId, thisProductList->ExtModuleType);
            thisProductList++;
         }

         if (ProductList)
            free(ProductList);
      }

      /* Allocate new thread on the MVP */
      imThrAlloc(Device1, 0, &Thread1);

      Thread = (NbOfDevice == 2) ? Thread2 : Thread1;

      for (ii=NbOfDevice; ii>0; ii--)
      {
         unsigned long ThisDevice, ProductId;

         imThrInquire(Thread, IM_THR_OWNER_ID, &ThisDevice);

         imDevInquire(ThisDevice, IM_DEV_PRODUCT_ID, &ProductId);

         imDispInquire(Thread, 0, IM_DISP_VGA_MODE, &vgaMode);

         if ((vgaMode != IM_NONE) && (ProductId != IM_DEV_GENESIS_PRO))
         {
            /* Preserve which thread that has allocated HOST buffers and has control
             * over Display keying. So when they are freed, it will be by the same
             * thread Id.
             * this is required when running with two boards since at the end of the
             * while() loop we permute both thread Id to run same demo on the other
             * Node.
             */
            MainThreadControl = Thread;

#if defined(_IM_HOST_OS_DOS)
            if ((vgaMode == IM_SINGLE_SCREEN) /* && (NbOfDevice == 1) */)
               imDispAlloc(MainThreadControl, 0, 0, NULL, IM_DEFAULT, &DispID);
#endif

            imDispInquire(MainThreadControl, 0, IM_DISP_RESOLUTION_X, &Xres);
            imDispInquire(MainThreadControl, 0, IM_DISP_RESOLUTION_Y, &Yres);

            if ((GenesisFbDestination == IM_DISP_BLUE) || (GenesisFbDestination == IM_DISP_MONO))
            {
               imBufChild(Thread, GenesisDisplayMode, 0, 0, Xres, Yres, &ThisDisp);
               imBufClear(Thread, ThisDisp, 0.0, NULL);
               imBufFree(Thread, ThisDisp);

               imBufAllocControl(MainThreadControl, &DisplayControl);

               if (vgaMode == IM_DUAL_SCREEN)
               {
                  imBufChild(Thread, IM_DISP_OVERLAY, 0, 0, Xres, Yres, &ThisDisp);
                  imBufClear(Thread, ThisDisp, 0.0, NULL);
                  imBufFree(Thread, ThisDisp);

                  /* By default imDevAlloc() do a DispAlloc and keying is set
                   * automatically to IM_KEY_ALWAYS.
                   */
               }

               else
               {
#if defined(_IM_HOST_OS_NT)

                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_MODE, IM_KEY_IN_RANGE);
                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_LOW,  6);
                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_HIGH, 6);

#elif defined(_IM_HOST_OS_QNX4)
                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_MODE, IM_KEY_IN_RANGE);
                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_LOW,  2);
                  imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_HIGH, 2);

#elif defined(_IM_HOST_OS_DOS)

                  if (Yres > 400)
                  {
                     /* Probably not in character mode */
                     imBufChild(Thread, IM_DISP_OVERLAY, 0, 0, Xres, Yres, &ThisDisp);
                     imBufClear(Thread, ThisDisp, 0.0, NULL);
                     imBufFree(Thread, ThisDisp);

                     imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_MODE, IM_KEY_ALWAYS);
                  }
#endif
               }

               imBufPutField(MainThreadControl, DisplayControl, IM_DISP_MODE, GenesisDisplayMode);
               imDispControl(MainThreadControl, 0, DisplayControl, IM_NOW);

               if ((NbOfDevice == 2) && (NbOfDevice == ii))
                  imBufFree(MainThreadControl, DisplayControl);
            }
         }

         Thread = Thread1;
      }


      if (keepTextMode)
      {
         imBufPutField(MainThreadControl, DisplayControl, IM_DISP_MODE, IM_DISP_TEXT);
         imDispControl(MainThreadControl, 0, DisplayControl, IM_NOW);
      }


      /* Allocate and load images in HOST memory */
      printf("Load default TIFF image in HOST buffers:\n");
      memset(BufImg, 0, sizeof(BufImg));
      for (ImageIndex=0; ImageIndex < (sizeof(NameBase)/sizeof(char *)); ImageIndex++ )
      {
         if (NameBase[ImageIndex])
         {
            printf("Loading %13s....\n", NameBase[ImageIndex]);
            imBufRestore(MainThreadControl, NameBase[ImageIndex], IM_TIFF, IM_HOST, &BufImg[ImageIndex]);
         }
      }

      printf("done!\n");

      /* Allocate the X and Y buffers that generate the lut for the sphere */
      if( (XData = (short *) malloc(sizeof(short) * 512 * 480)) == NULL )
      {
         printf("Can not allocate Host memory\n");
         return;
      }

      if( (YData = (short *) malloc(sizeof(short) * 512 * 480)) == NULL )
      {
         printf(" Can not allocate Host memory \n");
         free(XData);
         return;
      }  /* end if */

      /* Generate the lut buffers */
      Sphere_GenXY(XData, YData);


      /* Loop forever, only a Ctrl-Break will stop sequence */
      while (!HaltProcess)
      {
         if (imThrGetError(Thread1, IM_ERR_MSG_FUNC + IM_ERR_RESET, msg) || imAppGetError(IM_ERR_MSG_FUNC + IM_ERR_RESET, msg)) break;

         PrintHdr();

         if (imDevInquire(imThrInquire(Thread1, IM_THR_OWNER_ID, 0), IM_DEV_MVP, 0))
         {
            if (!HaltProcess)
            {
               printf("Warp Lut operations ...\n\n");
               Genesis(Thread1);
            }


            if (!HaltProcess)
            {
               printf("Warp Lut operations ...\n\n");
               Sphere(Thread1, XData, YData);
            }


            if (!HaltProcess)
            {
               printf("Connect map operations using the game of life LUT...\n\n");
               GameOfLife(Thread1, LIFEIN4);
            }


            if (!HaltProcess)
            {
               printf("Binary morphic operations, L-Skeleton option applied on:\n");
               printf(" - Fido & Rex\n");
               Skeleton(Thread1, FIDO2);
            }


            if (!HaltProcess)
            {
               printf(" - Genesis Software team\n");
               Skeleton(Thread1, IM2TEAM);
            }


            if (!HaltProcess)
            {
               printf(" - Matrox logo\n\n");
               Skeleton(Thread1, LOGO3);
            }


            if (!HaltProcess)
            {
               printf("Multiple operations (from left to right, up to down):\n");
               printf("  - Integer dyadic operations performed on Image with itself\n");
               printf("    (ADD and SATURATE), (NOR)\n");
               printf("  - Projection, histogram, histogram equalize\n");
               printf("  - Convolve (SHARPEN), flip, convolve (Edge Detector),\n");
               printf("    FFT performed on 256x256 image\n\n");
               Process(Thread1);
            }

            if (imThrGetError(Thread1, IM_ERR_MSG_FUNC + IM_ERR_RESET, msg) || imAppGetError(IM_ERR_MSG_FUNC + IM_ERR_RESET, msg)) break;

            if (!HaltProcess)
            {
               printf("Temporal filter operation performed on result from histogram equalize ...\n\n");
               TempFilter(Thread1);
            }

            if (imThrGetError(Thread1, IM_ERR_MSG_FUNC + IM_ERR_RESET, msg) || imAppGetError(IM_ERR_MSG_FUNC + IM_ERR_RESET, msg)) break;

            if (!HaltProcess)
            {
               printf("Genesis Hardware team, zoomed, warped, subsampled...\n\n");
               WarpSub(Thread1, HWTEAM);
            }


            if (!HaltProcess && (vgaMode != IM_NONE))
            {
               printf("Copy buffer from SDRAM to WRAM with imBufCopy()...\n\n");
               CopyPCI(Thread1, IM2TEAM, 1000);
            }

            if (imThrGetError(Thread1, IM_ERR_MSG_FUNC + IM_ERR_RESET, msg) || imAppGetError(IM_ERR_MSG_FUNC + IM_ERR_RESET, msg)) break;

            if (Thread2 && !HaltProcess)
            {
               printf("Permute both hwteam & im2team TIFF. Controled by threadId 0x%x\n", Thread1);
               OSsleep(1.0);

               long TmpBuf1, TmpBuf2;
               imBufAlloc2d(Thread1, 512, 480, IM_BYTE, IM_PROC, &TmpBuf1);
               imBufAlloc2d(Thread1, 512, 480, IM_BYTE, IM_PROC, &TmpBuf2);

               imBufCopy(Thread1, BufImg[HWTEAM],  TmpBuf1,          0, 0);
               imBufCopy(Thread1, BufImg[IM2TEAM], TmpBuf2,          0, 0);
               imBufCopy(Thread1, TmpBuf1,         BufImg[IM2TEAM],  0, 0);
               imBufCopy(Thread1, TmpBuf2,         BufImg[HWTEAM],   0, 0);

               imBufFree(Thread1, TmpBuf2);
               imBufFree(Thread1, TmpBuf1);

               long tmp = Thread1;  /* Permute thread id */
               Thread1 = Thread2;
               Thread2 = tmp;
            }
         }

         else if (!HaltProcess)
         {
            printf("Loop of Grab on Genesis LC ...\n\n");
            LcOperations(Thread1, Thread2);

            if (Thread2 && !HaltProcess)
            {
               printf("Switch to second Genesis LC\n");
               OSsleep(1.0);

               long tmp = Thread1;  /* Permute thread id */
               Thread1 = Thread2;
               Thread2 = tmp;
            }

         }


         if (Thread2 && (Thread1 != Thread2))
         {
            if (!HaltProcess)
            {
               printf("\nRun same demo on the other available Node. threadId 0x%x\n\n", Thread1);
               OSsleep(1.0);
            }

            else if (MainThreadControl != Thread1)
            {
               /* Restore original Thread1 and Thread2 Id */
               long tmp = Thread1;  /* Permute thread id */
               Thread1 = Thread2;
               Thread2 = tmp;
            }
         }

      }  /* end while */

      if (msg[0] != '\0')
         printf("%s\n", msg);


      if (Device1)
      {
         if ((GenesisFbDestination == IM_DISP_BLUE) || (GenesisFbDestination == IM_DISP_MONO))
         {
            if ((vgaMode == IM_SINGLE_SCREEN) || (vgaMode == IM_DUAL_HEAD))
            {
               imBufPutField(MainThreadControl, DisplayControl, IM_DISP_KEY_MODE, IM_KEY_OFF);
               imDispControl(MainThreadControl, 0, DisplayControl, IM_NOW);
               imBufFree(MainThreadControl, DisplayControl);
            }
         }

#if defined(_IM_HOST_OS_DOS)
         if (DispID)
            imDispFree(MainThreadControl, DispID);
#endif

         for (ImageIndex=0; ImageIndex < (sizeof(NameBase)/sizeof(char *)); ImageIndex++ )
         {
            if (BufImg[ImageIndex])
            {
               imBufFree(MainThreadControl, BufImg[ImageIndex]);
               BufImg[ImageIndex] = 0;
            }
         }
      }

      if (Device2 && (Device1 != Device2))
      {
         /* Free the Thread2 */
         imThrFree(Thread2);
         printf("Thread 2 freed\n");

         /* Free the Genesis device */
         imDevFree(Device2);
         printf("Device 2 freed\n");

      }

      if (Device1)
      {
         /* Free the Thread1 */
         imThrFree(Thread1);
         printf("Thread 1 freed\n");

         /* Free the Genesis device */
         imDevFree(Device1);
         printf("Device 1 freed\n");
      }

      if (XData)
         free(XData);

      if (YData)
         free(YData);

      printf("Genesis closed!\n");

#if defined(TEST_GRAB_INT)
      if (testGrabInt)
         printf("EogCount = %ld\n", EogCount);
#endif
   }

}  /* main() */



/*---------------------------------------------------------------------------
 *
 * Name:          GameOfLife()
 *
 * Synopsis:      Game of life demo.
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    Thread   Thread ID
 *                Index    Index in TIFF image table.
 *
 * Returns:       none
 *
 */

static void GameOfLife(long Thread, int Index)
{

#define SIZE_X       48
#define SIZE_Y       40
#define NZOOMX       16
#define NZOOMY       16
#define SIZE_X_ZOOM  (SIZE_X*NZOOMX)
#define SIZE_Y_ZOOM  (SIZE_Y*NZOOMY)
#define NUM_TIMES    85


   long  DstZoom, SrcMap, DstMap, tmp, ControlBuffer;
   long  LutIdLife, MonoDisp, TextBuf, DispText;
   long  DispWindow;
   int   ii;

   /* Allocate buffers */
   imBufAlloc(Thread, 512, 1, 1, IM_SHORT, IM_PROC, &LutIdLife);
   imBufAlloc(Thread, SIZE_X_ZOOM, SIZE_Y_ZOOM, 1, IM_UBYTE, IM_PROC, &DstZoom);
   imBufAlloc(Thread, 300, 20, 1, IM_UBYTE, IM_PROC, &TextBuf);

   imBufChild(Thread, GenesisFbDestination, 0, 0, Xres, Yres, &MonoDisp);
   imBufChild(Thread, GenesisFbDestination, 128, 64, SIZE_X_ZOOM, SIZE_Y_ZOOM, &DispWindow);
   imBufChild(Thread, GenesisFbDestination, 420, 10, 300, 20, &DispText);

   imBufAlloc(Thread, SIZE_X, SIZE_Y, 1, IM_UBYTE, IM_PROC, &SrcMap);
   imBufAlloc(Thread, SIZE_X, SIZE_Y, 1, IM_UBYTE, IM_PROC, &DstMap);

   imBufPut(Thread, LutIdLife, LutLife);

   /* Control original source definition */
   imBufAllocControl(Thread, &ControlBuffer);
   imBufPutField(Thread, ControlBuffer, IM_CTL_RESAMPLE, IM_NO_INTERPOLATE);
   imBufPutField(Thread, ControlBuffer, IM_CTL_OVERSCAN, IM_REPLACE);
   imBufPutField(Thread, ControlBuffer, IM_CTL_OVERSCAN_VAL, 0);
   imBufPutField(Thread, ControlBuffer, IM_GRA_BACK_MODE, IM_TRANSPARENT);
   imBufPutField(Thread, ControlBuffer, IM_GRA_FONT, IM_FONT_MEDIUM);

   imBufClear(Thread, TextBuf, 64.0, NULL);
   imGraText(Thread, ControlBuffer, TextBuf, 0, 0, "CONNECT MAP");

   /* Clear buffers */
   imBufClear(Thread, DstZoom, 0.0, NULL);
   imBufClear(Thread, MonoDisp, 64.0, NULL);
   imBufCopy(Thread, TextBuf, DispText, 0, 0);

   /* Copy Tiff image   */
   imBufCopy(Thread, BufImg[Index], SrcMap, 0, 0);

   CleanKeyboard();

   for (ii=0;ii < NUM_TIMES && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); ii++ )
   {
      imIntConnectMap(Thread, SrcMap, DstMap, LutIdLife, ControlBuffer, NULL);
      imIntZoom(Thread, DstMap, DstZoom, NZOOMX, NZOOMY, ControlBuffer, 0);
      imBufCopy(Thread, DstZoom, DispWindow, NULL, 0);

      tmp = DstMap;
      DstMap = SrcMap;
      SrcMap = tmp;

   }  /* end for */

   imBufFree(Thread, TextBuf);
   imBufFree(Thread, DispText);
   imBufFree(Thread, ControlBuffer);
   imBufFree(Thread, SrcMap);
   imBufFree(Thread, DstMap);
   imBufFree(Thread, MonoDisp);
   imBufFree(Thread, DispWindow);
   imBufFree(Thread, DstZoom);
   imBufFree(Thread, LutIdLife);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

}  /* GameOfLife() */



/*---------------------------------------------------------------------------
 *
 * Name:          Skeleton()
 *
 * Synopsis:      Skeleton demo
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    Thread   Thread ID
 *                Index    Index in TIFF image table.
 *
 * Returns:       none
 *
 */

static void Skeleton(long Thread, int Index)
{

#define  SRCSIZE_X         512
#define  SRCSIZE_Y         480
#define  SRCSUBSAMPLING_X  2
#define  SRCSUBSAMPLING_Y  2
#define  KER_XSIZE         3
#define  KER_YSIZE         3
#define  KER_BANDS         8
#define  KERN_PROCESS      IM_THIN

   static short Kernel[8][9]=
   {
      0, 0, 0, 2, 1, 2, 1, 1, 1,
      2, 1, 2, 1, 1, 0, 2, 0, 0,
      1, 2, 0, 1, 1, 0, 1, 2, 0,
      2, 1, 2, 0, 1, 1, 0, 0, 2,
      1, 1, 1, 2, 1, 2, 0, 0, 0,
      0, 0, 2, 0, 1, 1, 2, 1, 2,
      0, 2, 1, 0, 1, 1, 0, 2, 1,
      2, 0, 0, 1, 1, 0, 2, 1, 2
   };


   long  ii, tmp, Idempotence=0;

   long  MonoDisp, ChildLcorner, ChildRcorner, ChildOutDispId;
   long  SrcMorph, DstMorph, InMorph, OutMorph, CtrlBuf;
   long  KernId, SubSampledSrc, TextBuf, DispText;

   /* Allocate buffers */
   imBufAlloc(Thread, KER_XSIZE, KER_YSIZE, KER_BANDS, IM_SHORT, IM_PROC, &KernId);
   imBufAlloc(Thread, SRCSIZE_X/SRCSUBSAMPLING_X, SRCSIZE_Y/SRCSUBSAMPLING_Y, 1, IM_UBYTE, IM_PROC, &SubSampledSrc);
   imBufAlloc(Thread, SRCSIZE_X, SRCSIZE_Y, 1, IM_BINARY, IM_PROC, &SrcMorph);
   imBufAlloc(Thread, SRCSIZE_X, SRCSIZE_Y, 1, IM_BINARY, IM_PROC, &DstMorph);
   imBufAlloc(Thread, SRCSIZE_X, SRCSIZE_Y, 1, IM_UBYTE,  IM_PROC, &InMorph);
   imBufAlloc(Thread, SRCSIZE_X, SRCSIZE_Y, 1, IM_UBYTE,  IM_PROC, &OutMorph);
   imBufAlloc(Thread, 300, 20, 1, IM_UBYTE, IM_PROC, &TextBuf);
   imBufAllocControl(Thread, &CtrlBuf);

   /* Display childs */
   imBufChild(Thread,GenesisFbDestination,   0,   0, Xres, Yres, &MonoDisp);
   imBufChild(Thread,GenesisFbDestination,   0,   0,  256,  240, &ChildLcorner);
   imBufChild(Thread,GenesisFbDestination, 768,   0,  256,  240, &ChildRcorner);
   imBufChild(Thread,GenesisFbDestination, 256, 240,  512,  480, &ChildOutDispId);
   imBufChild(Thread,GenesisFbDestination, 420,  10,  300,   20, &DispText);

   /* Initialize kernel */
   imBufPut(Thread, KernId, Kernel);
   imBufPutField(Thread, KernId, IM_CTL_OVERSCAN, IM_REPLACE);
   imBufPutField(Thread, KernId, IM_CTL_OVERSCAN_VAL, 0);
   imBufPutField(Thread, CtrlBuf, IM_GRA_BACK_MODE, IM_TRANSPARENT);
   imBufPutField(Thread, CtrlBuf, IM_GRA_FONT, IM_FONT_MEDIUM);

   imBufClear(Thread, TextBuf, 64.0, NULL);

   /* Initialize the display */
   imBufCopy(Thread, BufImg[Index], InMorph, 0, 0);
   imIntSubsample(Thread, InMorph, SubSampledSrc, SRCSUBSAMPLING_X, SRCSUBSAMPLING_Y, 0, 0);
   imBufClear(Thread, MonoDisp, 64.0, 0);
   imGraText(Thread, CtrlBuf, TextBuf, 0, 0, "BINARY MORPHOLOGY");
   imBufCopy(Thread, TextBuf, DispText, 0, 0);
   imBufCopy(Thread, SubSampledSrc, ChildLcorner, NULL, 0);
   imBufCopy(Thread, SubSampledSrc, ChildRcorner, NULL, 0);
   imBufCopy(Thread, BufImg[Index], ChildOutDispId, NULL, 0);

   OSsleep(1.0);

   CleanKeyboard();

   for (ii= 0; ii < 2 && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); ii++)
   {
      imBinConvert(Thread, InMorph, SrcMorph, IM_GREATER_OR_EQUAL, 128, 0, NULL);

      CleanKeyboard();

      do
      {
         imBinMorphic(Thread, SrcMorph, DstMorph, KernId, KERN_PROCESS, 2, KernId, NULL);
         imBinConvert(Thread, DstMorph, OutMorph, IM_DEFAULT, 0, 255, 0);

         imBufGetField(Thread, DstMorph, IM_RES_IDEMPOTENCE, &Idempotence);

         imBufCopy(Thread, OutMorph, ChildOutDispId, NULL, 0);

         tmp = DstMorph;
         DstMorph = SrcMorph;
         SrcMorph = tmp;
      }
      while( !Idempotence && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL));

   } /* end for */

   imBufFree(Thread, TextBuf);
   imBufFree(Thread, DispText);
   imBufFree(Thread, MonoDisp);
   imBufFree(Thread, ChildLcorner);
   imBufFree(Thread, ChildRcorner);
   imBufFree(Thread, ChildOutDispId);
   imBufFree(Thread, SrcMorph);
   imBufFree(Thread, DstMorph);
   imBufFree(Thread, InMorph);
   imBufFree(Thread, OutMorph);
   imBufFree(Thread, CtrlBuf);
   imBufFree(Thread, SubSampledSrc);
   imBufFree(Thread, KernId);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

}  /* Skeleton() */



/*---------------------------------------------------------------------------
 *
 * Name:          Process()
 *
 * Synopsis:      Multiple processing operations.
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    Thread   Thread ID
 *
 * Returns:       none
 *
 */

static void Process(long Thread)
{
   int LoopCnt = 0;

   long MainBuf, LongBuf, CamId;

   long KernelIdshrp, CtrlBuf;

   long BufB1, BufL1, BufL2, XBuf;

   long BufProc1, BufProc2, BufProc3, BufProc3a, BufProc4,
        BufProc5, BufProc6, BufProc7, BufProc8,  BufProc9,
        BufProc10, BufProc11, BufProc12, Display, DispWin,
        GrabChild, maxval;

   static short KernSharpen[] =
      {
         -1, -1, -1,
         -1,  9, -1,
         -1, -1, -1
      };

   double Coef[2] = {0.0, 1.0};

   /* Load DCF file */
   imCamAlloc(Thread, NULL, IM_DEFAULT, &CamId);

   /* Allocate buffers */
   imBufAllocControl(Thread, &CtrlBuf);

   imBufAlloc(Thread, 3, 3, 1, IM_SHORT, IM_PROC, &KernelIdshrp);

   imBufAlloc(Thread, 1024, 1024, 1, IM_UBYTE, IM_PROC, &MainBuf );
   imBufAlloc(Thread,  256, 1024, 1, IM_LONG,  IM_PROC, &LongBuf );

   imBufAlloc(Thread,  256, 1, 1, IM_LONG, IM_PROC, &XBuf);

   imBufChild(Thread, GenesisFbDestination, 0, 0, 512,  480, &GrabChild);
   imBufChild(Thread, GenesisFbDestination, 0, 0, Xres, Yres, &DispWin);

   imBufChild(Thread, LongBuf,  0,   0, 5, 5, &BufL1);
   imBufChild(Thread, LongBuf,  0, 512, 5, 5, &BufL2);

   imBufChild(Thread, MainBuf,   0,   0, 1024,720, &Display);
   imBufChild(Thread, MainBuf,   0,   0, 512, 480, &BufB1);
   imBufChild(Thread, MainBuf, 512,   0, 256, 240, &BufProc1 );
   imBufChild(Thread, MainBuf, 768,   0, 256, 240, &BufProc2 );
   imBufChild(Thread, MainBuf, 512, 240, 256, 120, &BufProc3 );
   imBufChild(Thread, MainBuf, 512, 360, 256, 120, &BufProc3a);
   imBufChild(Thread, MainBuf, 768, 240, 256, 240, &BufProc4 );
   imBufChild(Thread, MainBuf,   0, 480, 256, 240, &BufProc5 );
   imBufChild(Thread, MainBuf, 256, 480, 256, 240, &BufProc6 );
   imBufChild(Thread, MainBuf, 512, 480, 256, 240, &BufProc7 );
   imBufChild(Thread, MainBuf, 768, 480, 256, 240, &BufProc8 );
   imBufChild(Thread, MainBuf,   0, 720, 256, 240, &BufProc9 );
   imBufChild(Thread, MainBuf, 256, 720, 256, 240, &BufProc10);
   imBufChild(Thread, MainBuf, 512, 720, 256, 240, &BufProc11);
   imBufChild(Thread, MainBuf, 768, 720, 256, 240, &BufProc12);

   /* Initialize fields */
   imBufPutField(Thread, CtrlBuf, IM_CTL_RESAMPLE, IM_INTERPOLATE);
   imBufPutField(Thread, CtrlBuf, IM_GRA_OFFSET_Y, 120 - 1);
   imBufPutField(Thread, CtrlBuf, IM_GRA_COLOR, 255);
   imBufPutField(Thread, CtrlBuf, IM_GRA_PLOT_MODE, IM_PLOT_DOTS);

   imBufPutField(Thread, KernelIdshrp, IM_KER_CLIP,     IM_ENABLE);
   imBufPutField(Thread, KernelIdshrp, IM_KER_ABSOLUTE, IM_ENABLE);

   /* Initialize kernels */
   imBufPut(Thread, KernelIdshrp, KernSharpen);

   /* X values are just sequential numbers */
   imGen1d(Thread, XBuf, IM_POLYNOMIAL, 0, 255, 2, Coef, 0);

   imBufClear(Thread, MainBuf,  0.0, 0);
   imBufClear(Thread, DispWin, 0.0, 0);

   LoopCnt = 0;

   CleanKeyboard();

   while (!kbhit() && !HaltProcess && (LoopCnt < 150) && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      imDigGrab(Thread, 0, CamId, BufB1, 1, 0, 0);

      imBufChildMove(Thread, BufL1,   0,   0, 256,   1);

      imIntSubsample(Thread, BufB1, BufProc9, 2, 2, CtrlBuf, NULL);

      imIntDyadic(Thread, BufProc9, BufProc9, BufProc1, IM_ADD_SAT, NULL);

      imIntDyadic(Thread, BufProc9, BufProc9, BufProc2, IM_NOR, NULL);

      /* Calculate the projection and draw it */
      imIntProject(Thread, BufProc9, BufL1, 0.0, IM_DEFAULT, NULL);

      /* Scale the histogram to fit the image size */
      imIntFindExtreme(Thread, BufL1, BufL1, IM_MAX_PIXEL, 0);
      imBufGetField(Thread, BufL1, IM_RES_MAX_PIXEL, &maxval);
      imBufPutField(Thread, CtrlBuf, IM_GRA_SCALE_Y, (double) - (120 - 1) / maxval);

      /* Draw projection */
      imBufClear(Thread, BufProc3, 0.0, 0);
      imGraLine(Thread, 0, BufProc3, 0,   0,   0, 119);
      imGraLine(Thread, 0, BufProc3, 0, 119, 255, 119);
      imGraPlot(Thread, CtrlBuf, BufProc3, XBuf, BufL1, 256);

      /* Calculate the histogram and draw */
      imIntHistogram(Thread, BufProc9, BufL1, IM_DEFAULT, NULL);

      /* Scale the histogram to fit the image size */
      imIntFindExtreme(Thread, BufL1, BufL1, IM_MAX_PIXEL, 0);
      imBufGetField(Thread, BufL1, IM_RES_MAX_PIXEL, &maxval);
      imBufPutField(Thread, CtrlBuf, IM_GRA_SCALE_Y, (double) - (120 - 1) / maxval);

      /* Draw histogram */
      imBufClear(Thread, BufProc3a, 0.0, 0);
      imGraLine(Thread, 0, BufProc3a, 0, 0, 0, 119);
      imGraLine(Thread, 0, BufProc3a, 0, 119, 255, 119);
      imGraPlot(Thread, CtrlBuf, BufProc3a, XBuf, BufL1, 256);

      imIntHistogramEqualize(Thread, BufProc9, BufProc4, 256, IM_UNIFORM, 0.0, 1, 255, IM_DEFAULT, NULL);

      imIntConvolve(Thread, BufProc9, BufProc5, KernelIdshrp, 0, NULL);

      imIntConvolve(Thread, BufProc9, BufProc7, IM_SOBEL_EDGE, 0, NULL);

      imIntFlip(Thread, BufProc9, BufProc6, IM_ROTATE_90, IM_DEFAULT, NULL);

      /* FFT */
      imBufChildMove(Thread, BufL1,      0,   0, 256, 256);
      imBufChildMove(Thread, BufL2,      0,   0, 256, 256);
      imBufChildMove(Thread, BufProc9,   0,   0, 256, 256);

      /* Conversion 8->32 bits */
      imIntConvert(Thread, BufProc9, BufL1, IM_DEFAULT, NULL);
      imBufChildMove(Thread, BufProc9,   0,   0, 256, 240);

      /* shift to add bits of precision */
      imIntMonadic(Thread, BufL1, 15, BufL1, IM_SHIFT, 0);

      /* Clear buffer for imaginary */
      imBufClear(Thread, BufL2, 0.0, NULL);

      imBufPutField(Thread, BufL1, IM_CTL_NORMALIZE, IM_ENABLE);

      imIntFFT(Thread, BufL1, BufL2, BufL1, BufL2, BufL1, NULL);

      /* shift back to visual space */
      imIntMonadic(Thread, BufL1, -4, BufL1, IM_SHIFT, 0);

      imBufChildMove(Thread, BufProc8,   0,   0, 256, 256);

      /* conversion from 32 to 8 bits, real part */
      imIntConvert(Thread, BufL1, BufProc8, IM_ABS_CLIP, NULL);

      /* Display result of GRAB image: processing memory to Display memory */
      imBufCopy(Thread, Display, DispWin, NULL, 0);
      LoopCnt++;
   }

   imCamFree(Thread, CamId);
   imBufFree(Thread, GrabChild);
   imBufFree(Thread, BufProc1 );
   imBufFree(Thread, BufProc2 );
   imBufFree(Thread, BufProc3 );
   imBufFree(Thread, BufProc3a);
   imBufFree(Thread, BufProc4 );
   imBufFree(Thread, BufProc5 );
   imBufFree(Thread, BufProc6 );
   imBufFree(Thread, BufProc7 );
   imBufFree(Thread, BufProc8 );
   imBufFree(Thread, BufProc9 );
   imBufFree(Thread, BufProc10);
   imBufFree(Thread, BufProc11);
   imBufFree(Thread, BufProc12);
   imBufFree(Thread, BufB1);
   imBufFree(Thread, BufL1);
   imBufFree(Thread, BufL2);
   imBufFree(Thread, Display);
   imBufFree(Thread, DispWin);
   imBufFree(Thread, KernelIdshrp);
   imBufFree(Thread, XBuf);
   imBufFree(Thread, MainBuf );
   imBufFree(Thread, LongBuf );
   imBufFree(Thread, CtrlBuf);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

}  /* Process() */


/*---------------------------------------------------------------------------
 *
 * Name:          WarpSub()
 *
 * Synopsis:      First order warping followed by subsample demo
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    Thread   Thread ID
 *                Index    Index in TIFF image table.
 *
 * Returns:       none
 *
 */

static void WarpSub(long Thread, int Index)
{

#define  DONT_CARE   0
#define  SIZEX       768
#define  SIZEY       720


   long  Rotkk;

   double Scalekk;

   long  Xtrans, Ytrans, Xoff, Yoff;

   int   FirstLoop=0,ii, Decrease;

   long  SizeX = SIZEX, SizeY = SIZEY;

   long  SrcWarp, DstWarp, ChildSrcWarp, ChildDstWarp;
   long  ControlBufID, CoefBufID, CtrlBuf, TextBuf, DispText;
   long  DispWindow, DispSrc, DispWarp;


   /* allocate a control buffer */
   imBufAllocControl(Thread, &ControlBufID);
   imBufAllocControl(Thread, &CtrlBuf);

   /* Allocate the coefficient buffer */
   imBufAlloc(Thread, 3, 2, 1, IM_FLOAT, IM_PROC, &CoefBufID);

   /* The processing buffer */
   imBufAlloc(Thread, SizeX, SizeY, 1, IM_UBYTE, IM_PROC, &SrcWarp);
   imBufAlloc(Thread, SizeX, SizeY, 1, IM_UBYTE, IM_PROC, &DstWarp);
   imBufAlloc(Thread, 300, 20, 1, IM_UBYTE, IM_PROC, &TextBuf);

   imBufChild(Thread, SrcWarp,  0,   0, 512, 480, &ChildSrcWarp);

   imBufChild(Thread, GenesisFbDestination,   0,   0, Xres, Yres, &DispWindow);
   imBufChild(Thread, GenesisFbDestination, 256, 128,  512,  480, &DispSrc);
   imBufChild(Thread, GenesisFbDestination, 128,  24,  SizeX,  SizeY, &DispWarp);
   imBufChild(Thread, GenesisFbDestination, 420, 0, 300, 20, &DispText);

   imBufPutField(Thread, ControlBufID, IM_CTL_RESAMPLE, IM_BILINEAR);
   imBufPutField(Thread, ControlBufID, IM_CTL_OVERSCAN, IM_TRANSPARENT);
   imBufPutField(Thread, CtrlBuf, IM_CTL_RESAMPLE, IM_INTERPOLATE);
   imBufPutField(Thread, CtrlBuf, IM_GRA_BACK_MODE, IM_TRANSPARENT);
   imBufPutField(Thread, CtrlBuf, IM_GRA_FONT, IM_FONT_MEDIUM);

   imBufClear(Thread, TextBuf, 0.0, NULL);
   imGraText(Thread, CtrlBuf, TextBuf, 0, 0, "WARP ZOOM SUBSAMPLE");

   /* clear main buf */
   imBufClear(Thread, DispWindow, 0.0, 0);

   imBufCopy(Thread, TextBuf, DispText, 0, 0);
   imBufCopy(Thread, BufImg[Index], ChildSrcWarp, NULL, 0);
   imBufCopy(Thread, BufImg[Index], DispSrc, NULL, 0);

   OSsleep(1.0);

   Rotkk  = 0;
   Xtrans = 256;
   Ytrans = 240;
   Scalekk = 2.7;

   CleanKeyboard();

   while(!FirstLoop && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      /* GenWarp1stOrder */
      imGenWarp1stOrder(Thread, CoefBufID, IM_TRANSLATE, -Xtrans, -Ytrans, IM_CLEAR, 0);
      imGenWarp1stOrder(Thread, CoefBufID, IM_SCALE, Scalekk, Scalekk, IM_NO_CLEAR, 0);
      imGenWarp1stOrder(Thread, CoefBufID, IM_ROTATE, Rotkk, DONT_CARE, IM_NO_CLEAR, 0);
      imGenWarp1stOrder(Thread, CoefBufID, IM_TRANSLATE, Xtrans, Ytrans, IM_NO_CLEAR, 0);

      if (Rotkk < -177 )
         FirstLoop = 1;

      else if (!FirstLoop)
      {
         Rotkk -= 2;
         if (Scalekk >= 5 )
            Decrease = 1;

         if (Scalekk <= 2.7)
            Decrease = 0;

         if (Decrease)
            Scalekk -= 0.05;

         else
            Scalekk += 0.05;
      }

      /* Warp1stOrder... */
      imIntWarpPolynomial(Thread, ChildSrcWarp, DstWarp, CoefBufID, ControlBufID, 0);
      imBufCopy(Thread, DstWarp, DispWarp, NULL, 0);

   }  /* end while */

   imBufCopy(Thread, DstWarp, SrcWarp, NULL, 0);
   imBufChild(Thread, DstWarp, 0, 0, SizeX, SizeY, &ChildDstWarp);

   CleanKeyboard();

   /* Subsample image */
   for (ii= 2; ii < 16 && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); ii++)
   {
      Xoff  = SizeX/2 - (SIZEX/ii)/2;
      Yoff  = SizeY/2 - (SIZEY/ii)/2;
      SizeX = SIZEX / ii;
      SizeY = SIZEY / ii;

      imBufClear(Thread, DstWarp, 0.0, 0);
      imBufChildMove(Thread, ChildDstWarp, Xoff, Yoff, SizeX, SizeY);
      imIntSubsample(Thread, SrcWarp, ChildDstWarp, ii, ii, CtrlBuf, 0);

      imBufCopy(Thread, DstWarp, DispWarp, NULL, 0);
   }

   OSsleep(2.0);

   /* Free buffers */

   imBufFree(Thread, DispWarp);
   imBufFree(Thread, DispSrc);
   imBufFree(Thread, DispWindow);
   imBufFree(Thread, ChildSrcWarp);
   imBufFree(Thread, ChildDstWarp);
   imBufFree(Thread, SrcWarp);
   imBufFree(Thread, DstWarp);
   imBufFree(Thread, CoefBufID);
   imBufFree(Thread, CtrlBuf);
   imBufFree(Thread, DispText);
   imBufFree(Thread, TextBuf);
   imBufFree(Thread, ControlBufID);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

}  /* WarpSub() */



/*---------------------------------------------------------------------------
 *
 * Name:          TempFilter()
 *
 * Synopsis:      Temporal filter demo
 *
 * Reviewed:      May 10, 1995
 *
 * Parameters:    Thread   Thread ID
 *
 * Returns:       none
 *
 */

static void TempFilter(long Thread)
{
   int   LoopCnt = 0;
   long  SrcHisto, DstHisto, CumulateHisto;
   long  MonoDisp, GrabDisp, HistoDisp;
   long  CamId;


   /* Load DCF file */
   imCamAlloc(Thread, NULL, IM_DEFAULT, &CamId);

   /* Allocate processing buffers */
   imBufAlloc(Thread,  512,  480, 1, IM_UBYTE,  IM_PROC, &SrcHisto);
   imBufAlloc(Thread,  512,  480, 1, IM_UBYTE,  IM_PROC, &DstHisto);
   imBufAlloc(Thread,  512,  480, 1, IM_UBYTE,  IM_PROC, &CumulateHisto);

   imBufChild(Thread, GenesisFbDestination,    0,   0, Xres, Yres, &MonoDisp);
   imBufChild(Thread, GenesisFbDestination,    0,   0,  512,  480, &GrabDisp);
   imBufChild(Thread, GenesisFbDestination,  512, 256,  512,  480, &HistoDisp);


   /* Put a background */
   imBufClear(Thread, MonoDisp, 64.0, 0);

   imBufClear(Thread, CumulateHisto, 0.0, 0);

   CleanKeyboard();

   for (LoopCnt=0; LoopCnt < 50 && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); LoopCnt++)
   {
      imDigGrab(Thread, 0, CamId, SrcHisto, 1, 0, 0);
      imDigGrab(Thread, 0, CamId, GrabDisp, 1, 0, 0);

      imIntHistogramEqualize(Thread, SrcHisto, DstHisto, 256, IM_UNIFORM, 0.0, 1, 255, IM_DEFAULT, NULL);
      imIntMac2(Thread, DstHisto, CumulateHisto, CumulateHisto, 64, 192, 8, NULL);

      /* Display result of GRAB image: processing memory to Display memory */
      imBufCopy(Thread, CumulateHisto, HistoDisp, NULL, 0);
   }

   imCamFree(Thread, CamId);
   imBufFree(Thread, MonoDisp);
   imBufFree(Thread, GrabDisp);
   imBufFree(Thread, HistoDisp);
   imBufFree(Thread, SrcHisto);
   imBufFree(Thread, DstHisto);
   imBufFree(Thread, CumulateHisto);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

}  /* TempFilter() */


#define  XSIZE            512
#define  YSIZE            480
#define  DEFAULT_XPOS     511
#define  DEFAULT_YPOS     480

/*---------------------------------------------------------------------------
 *
 * Name:          Sphere()
 *
 * Synopsis:      Sphere demo
 *
 * Reviewed:      Nov 20, 1995
 *
 * Parameters:    Thread   Thread ID
 *                XData    Pointer to the host X lut buffer
 *                YData    Pointer to the host Y lut buffer
 *
 * Returns:       none
 *
 */

static void Sphere(long Thread, short * XData, short * YData)
{
   int         ii, jj;
   long        SrcBuf, SrcSeeBuf, XLutBuf, YLutBuf, DstBuf,
               DispDstBuf, DispMono, DispText , TextBuf,
               SubSampledSrc, CtrlBuf, ParentBuf, SrcBuf2;
   long        XOff, Delta, increment, NbIterations;
   char        *String;


   /* Allocate buffers */
   imBufAlloc(Thread, 2 * XSIZE, YSIZE + 5, 1, IM_UBYTE, IM_PROC, &ParentBuf);
   imBufAlloc(Thread, XSIZE, YSIZE , 1, IM_UBYTE, IM_PROC, &DstBuf);
   imBufAlloc(Thread, 300,  20, 1, IM_UBYTE, IM_PROC, &TextBuf);
   imBufAlloc(Thread, 128, 120, 1, IM_UBYTE, IM_PROC, &SubSampledSrc);
   imBufAllocControl(Thread, &CtrlBuf);

   /* Allocate the Lut Buffers */
   imBufAlloc(Thread, XSIZE, YSIZE, 1, IM_SHORT, IM_PROC, &XLutBuf);
   imBufAlloc(Thread, XSIZE, YSIZE, 1, IM_SHORT, IM_PROC, &YLutBuf);

   /* Allocate child buffers */
   imBufChild(Thread, GenesisFbDestination, 0  , 0  , 1024 , 768  , &DispMono);
   imBufChild(Thread, GenesisFbDestination, 256, 128, XSIZE, YSIZE, &DispDstBuf);
   imBufChild(Thread, DispMono,     425, 10,    300, 20,    &DispText);

   imBufChild(Thread, ParentBuf, 0,   0, XSIZE/2,  YSIZE,     &SrcSeeBuf);
   imBufChild(Thread, ParentBuf, 0,   0, XSIZE,    YSIZE + 5, &SrcBuf);
   imBufChild(Thread, ParentBuf, 512, 0, XSIZE,    YSIZE + 5, &SrcBuf2);

   /* Clear buffers */
   imBufClear(Thread, DispMono, 0.0, 0);
   imBufClear(Thread, ParentBuf, 0.0, 0);
   imBufClear(Thread, DstBuf, 0.0, 0);

   /* Put The X, Y Data into local buffers */
   imBufPut(Thread, XLutBuf, XData);
   imBufPut(Thread, YLutBuf, YData);

   imBufPutField(Thread, CtrlBuf, IM_CTL_RESAMPLE, IM_INTERPOLATE);
   imBufPutField(Thread, CtrlBuf, IM_GRA_BACK_MODE, IM_TRANSPARENT);
   imBufPutField(Thread, CtrlBuf, IM_GRA_FONT, IM_FONT_MEDIUM);

   CleanKeyboard();


   for (jj = 0; (jj < 5) && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); jj++)
   {

      if (jj & 0x01)
      {

         NbIterations = 32;
         imBufClear(Thread, SubSampledSrc, 0.0, 0);
         imBufClear(Thread, DispMono, 0.0, 0);
         imBufClear(Thread, TextBuf, 0.0, 0);

         imBufCopy(Thread, BufImg[(jj+1)/2 + 1], SrcBuf, NULL, 0);
         imBufCopy(Thread, SrcBuf, SrcBuf2, NULL, 0);
         imIntSubsample(Thread, SrcBuf, SubSampledSrc, 4, 4, CtrlBuf, 0);
         imBufCopy(Thread, SubSampledSrc, DispMono, 0, 0);

         if (jj == 1)
            String = "GENESIS HW TEAM";

         else if (jj == 3)
            String = "GENESIS SW TEAM";

         imGraText(Thread, CtrlBuf, TextBuf, 0, 0, String);
         imBufCopy(Thread, TextBuf, DispText, 0, 0);

      }

      else
      {
         if (jj == 0)
            NbIterations = 32;

         else
            NbIterations = 16;

         imBufClear(Thread, DispMono, 0.0, 0);
         imBufClear(Thread, SubSampledSrc, 0.0, 0);
         imBufClear(Thread, TextBuf,  0.0, 0);
         imBufCopy(Thread, BufImg[EARTH4], SrcBuf, NULL, 0);
         imBufCopy(Thread, SrcBuf, SrcBuf2, NULL, 0);

      }

      increment = 16;
      Delta = increment;
      XOff = (3 * XSIZE)/2 ;

      imBufChildMove(Thread, SrcSeeBuf, XOff, 0, IM_NO_CHANGE, IM_NO_CHANGE);

      /* Spin counter clockwise */
      for (ii= 0; ii < NbIterations && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL); ii++)
      {
         /* Send the Lut Command */
         imIntWarpLut(Thread, SrcSeeBuf, DstBuf, XLutBuf, YLutBuf, 0x0, 0x0);

         /* Display the Image */
         imBufCopy(Thread, DstBuf, DispDstBuf, 0, 0);

         if (XOff > (XSIZE / 2))
         {
            /* Move the child window around counter clockwise */
            imBufChildMove(Thread, SrcSeeBuf, -Delta, 0, IM_NO_CHANGE, IM_NO_CHANGE);
            XOff = XOff - Delta;
         }

         else
         {
            /* Move the child to upper half of the source buffer */
            imBufChildMove(Thread, SrcSeeBuf, ((3 * XSIZE) / 2 - XOff) , 0, IM_NO_CHANGE, IM_NO_CHANGE);
            XOff = (3 * XSIZE) / 2 - XOff;
         }


      } /* end for */

      /* Remove the child to its initial position */
      imBufChildMove(Thread, SrcSeeBuf, -XOff, 0, IM_NO_CHANGE, IM_NO_CHANGE);

   } /* end for */

   /* clean up */
   imBufFree(Thread, SrcBuf);
   imBufFree(Thread, SrcBuf2);
   imBufFree(Thread, SrcSeeBuf);
   imBufFree(Thread, DispDstBuf);
   imBufFree(Thread, DispMono);
   imBufFree(Thread, DispText);
   imBufFree(Thread, TextBuf);
   imBufFree(Thread, CtrlBuf);
   imBufFree(Thread, XLutBuf);
   imBufFree(Thread, YLutBuf);
   imBufFree(Thread, DstBuf);
   imBufFree(Thread, ParentBuf);
   imBufFree(Thread, SubSampledSrc);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

} /* Sphere */

/*
 *
 *  Generate the XY Data For a sphere
 *
 */

static void Sphere_GenXY(short *XPtr, short *YPtr)
{
   register int ii, jj, kk;
   double utmp, vtmp;
   double Radius = 200.0;         /* Set the radius of the sphere */

   printf("Generate the XY Data For a sphere (may be long, please wait ...)\n");

   /* Generate the X and Y Buffers */
   for (jj=0; jj < YSIZE; jj++ )
   {
      kk = jj*XSIZE;

      if (fabs( vtmp = ((double)(jj - (YSIZE/2)) / Radius) ) < 1.0)
      {
         vtmp = acos( -vtmp );
         if(vtmp == 0.0)
            vtmp=0.0000001;

         short v = (short)((vtmp/3.1415926) * (double)(YSIZE - 1) + 0.5);

         double tmp = Radius*sin(vtmp);

         for (ii=0; ii < XSIZE; ii++ )
         {
            if ( fabs(utmp = ((double)(ii - (XSIZE/2)) / tmp)) < 1.0 )
            {
               utmp = acos( -utmp);
               XPtr[ii + kk] = (short)((utmp/3.1415926) * (double)((XSIZE/2) - 1) + 0.5);
               YPtr[ii + kk] = (short)v;
            }  /* endif */

            else
            {
               XPtr[ii + kk] = (short)DEFAULT_XPOS;
               YPtr[ii + kk] = (short)DEFAULT_YPOS;
            }  /* end else */
         } /* end for */
      }

      else
      {
         for (ii=0; ii < XSIZE ;ii++ )
         {
            XPtr[ii + kk] = (short)DEFAULT_XPOS;
            YPtr[ii + kk] = (short)DEFAULT_YPOS;
         } /* end for */
      }
   }  /* end for */

}  /* Sphere_GenXY */


/*---------------------------------------------------------------------------
 *
 * Name:          Genesis()
 *
 * Synopsis:      Genesis logo demo
 *
 * Reviewed:      Nov 20, 1995
 *
 * Parameters:    Thread   Thread ID
 *
 * Returns:       none
 *
 */


static void Genesis(long Thread)
{

#define  XSIZE_GEN    512
#define  YSIZE_GEN    512


   long        LutBuf, XlutBuf, YlutBuf, CoefBuf;
   long        P_DstBuf, DstBuf, DispDstBuf;
   long        P_SrcBuf,SrcBuf,SrcBuf2, DispMono,
               SrcBuf3, SrcBuf4;
   double      ii=0;
   double      X0, Y0, X1, Y1;
   double      X2, Y2, X3, Y3;
   double      Xstart, Ystart;
   double      Xend, Yend;
   long        Mode=0, domore=1;
   long        NewXSize=200, NewYSize=180;
   double      Xdelta = 1.0, Ydelta = 1.0;
   long        Zoom_X=1, Zoom_Y=1, Frac =0;
   long        Iteration, NbIter;

   /* allocate  buffers */
   imBufAlloc(Thread, 1024, 512, 1, IM_SHORT, IM_PROC, &LutBuf);
   imBufAlloc(Thread, 512, 2048, 1, IM_UBYTE, IM_PROC, &P_SrcBuf);
   imBufAlloc(Thread, 512, 512, 1, IM_UBYTE, IM_PROC, &P_DstBuf);
   imBufAlloc(Thread, 3, 3, 1, IM_FLOAT, IM_PROC, &CoefBuf);

   imBufChild(Thread, LutBuf,   0, 0, 512, 512, &XlutBuf);
   imBufChild(Thread, LutBuf, 512, 0, 512, 512, &YlutBuf);
   imBufChild(Thread, P_SrcBuf, 0, 0, 512, 512, &SrcBuf);
   imBufChild(Thread, P_SrcBuf, 0, 512, 512, 512, &SrcBuf2);
   imBufChild(Thread, P_SrcBuf, 0, 1024, 512, 512, &SrcBuf3);
   imBufChild(Thread, P_SrcBuf, 0, 1536, 512, 512, &SrcBuf4);
   imBufChild(Thread, P_DstBuf, 0, 0, 512, 512, &DstBuf);
   imBufChild(Thread, GenesisFbDestination, 256, 128, XSIZE_GEN, YSIZE_GEN, &DispDstBuf);
   imBufChild(Thread, GenesisFbDestination, 0, 0, Xres, Yres, &DispMono);

   /* Use the Dst Buffer as the Control Buffer */
   imBufPutField(Thread, CoefBuf, IM_CTL_OVERSCAN, IM_REPLACE);
   imBufPutField(Thread, CoefBuf, IM_CTL_OVERSCAN_X, 511);
   imBufPutField(Thread, CoefBuf, IM_CTL_OVERSCAN_Y, 511);
   imBufPutField(Thread, CoefBuf, IM_CTL_SRC_SIZE_X, XSIZE_GEN);
   imBufPutField(Thread, CoefBuf, IM_CTL_SRC_SIZE_Y, YSIZE_GEN);
   imBufPutField(Thread, CoefBuf, IM_CTL_ZOOM_X, 1);
   imBufPutField(Thread, CoefBuf, IM_CTL_ZOOM_Y, 1);
   imBufPutField(Thread, CoefBuf, IM_CTL_PRECISION, 6);
   imBufPutField(Thread, CoefBuf, IM_CTL_RESAMPLE, IM_BILINEAR);

   /* Clear buffers */
   imBufClear(Thread, P_SrcBuf, 0.0, 0);
   imBufClear(Thread, DstBuf, 0.0, 0);
   imBufClear(Thread, XlutBuf, 0.0, 0);
   imBufClear(Thread, YlutBuf, 0.0, 0);
   imBufClear(Thread, DispMono, 0.0, 0);

   /* set parameters */
   X0 = -1300.0;  Y0 = 0.0;   X1 = 1812.0; Y1 = 0.0;
   X3 = 150.0;  Y3 = 480.0;   X2 = 362.0; Y2 = 480.0;

   Xstart = 0.0;
   Ystart = 0.0;
   Xend = 512.0;
   Yend = 480.0;

   /* Four corner coeffgen function */
   imGenWarp4Corner(Thread, CoefBuf,
                    X0, Y0, X1, Y1, X2, Y2, X3, Y3,
                    (long)Xstart, (long)Ystart, (long)Xend, (long)Yend, Mode, 0);
   imGenWarpLutMatrix(Thread, XlutBuf, YlutBuf, CoefBuf, CoefBuf, 0);

   CleanKeyboard();

   /* load the tiff file */
   imBufCopy(Thread, BufImg[LOGO3],  SrcBuf2, NULL, 0);
   imBufChildMove(Thread, SrcBuf, 0, 850, IM_NO_CHANGE, IM_NO_CHANGE);

   imBufCopy(Thread, BufImg[GENESIS], SrcBuf, NULL, 0);
   imBufChildMove(Thread, SrcBuf, 0, -850, IM_NO_CHANGE, IM_NO_CHANGE);

   ii = 150;
   Iteration = 0;
   NbIter = 810;
   imBufChildMove(Thread, SrcBuf, 0, (long)ii, IM_NO_CHANGE, IM_NO_CHANGE);


   while ((Iteration < 1) && !kbhit() && !HaltProcess && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {

      imIntWarpLut(Thread, SrcBuf, DstBuf, XlutBuf, YlutBuf, CoefBuf, 0);
      imBufCopy(Thread, DstBuf, DispDstBuf, 0, 0);

      if ((ii < NbIter) && !kbhit() && !HaltProcess)
      {
         imBufChildMove(Thread, SrcBuf, 0,  4, IM_NO_CHANGE, IM_NO_CHANGE);
         ii += 4;
      }
      else
      {
         imBufChildMove(Thread, SrcBuf, 0, (long)-ii, IM_NO_CHANGE, IM_NO_CHANGE);
         Iteration++;
      }

   }

   OSsleep(1.0);

   /* clean up */
   imBufFree(Thread, XlutBuf);
   imBufFree(Thread, YlutBuf);
   imBufFree(Thread, SrcBuf);
   imBufFree(Thread, SrcBuf2);
   imBufFree(Thread, SrcBuf3);
   imBufFree(Thread, SrcBuf4);
   imBufFree(Thread, DstBuf);
   imBufFree(Thread, DispDstBuf);
   imBufFree(Thread, DispMono);
   imBufFree(Thread, LutBuf);
   imBufFree(Thread, P_SrcBuf);
   imBufFree(Thread, P_DstBuf);
   imBufFree(Thread, CoefBuf);

   imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL);

} /* Genesis */



/*---------------------------------------------------------------------------
 *
 * Name:          CopyPCI()
 *
 * Synopsis:
 *
 * Reviewed:
 *
 * Parameters:
 *
 * Returns:
 *
 */

static void CopyPCI(long Thread, int Index, int userCount)
{
   long procBuf, dispBuf;
   long xsize, ysize, ii, xoff, yoff, displayX, displayY, maxX, maxY;


   imDispInquire(Thread, 0, IM_DISP_RESOLUTION_X, &displayX);
   imDispInquire(Thread, 0, IM_DISP_RESOLUTION_Y, &displayY);

   maxX = (displayX > 512) ? 512 : displayX;
   maxY = (displayY > 480) ? 480 : displayY;

   imBufAlloc(Thread, maxX, maxY, 1, IM_UBYTE, IM_PROC, &procBuf);
   imBufCopy(Thread, BufImg[Index], procBuf, NULL, 0);

   ii = 0;
   srand(0);

   CleanKeyboard();

   while( !kbhit() && !HaltProcess && (ii++ < userCount) && !imThrGetError(Thread, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      xsize = rand() % maxX;
      ysize = rand() % maxY;

      if (xsize < 32)
         xsize = 32;

      if (!ysize)
         ysize = 1;

      xoff = rand() % (displayX - xsize);
      yoff = rand() % (displayY - ysize);

      imBufChild(Thread, GenesisFbDestination, xoff, yoff, xsize, ysize, &dispBuf);

      imBufCopy(Thread, procBuf, dispBuf, 0, 0);

      imBufFree(Thread, dispBuf);
   }

   imBufFree(Thread, procBuf);

}  /* CopyPCI() */


static void LcOperations(long Thread1, long Thread2)
{
   long GrabChild, CamId;
   double sleepTime = 5.0;
   int iteration;
   long OSB, GrabControl;
   long DispChild[2] = {0, 0};

   imBufChild(Thread1, GenesisFbDestination, 0, 0, 512, 480, &GrabChild);

   if (Thread2)
   {
      imBufChild(Thread1, GenesisFbDestination, 512, 0, 512, 480, &DispChild[0]);
      imBufChild(Thread2, GenesisFbDestination,   0, 0, 512, 480, &DispChild[1]);
   }

   imSyncAlloc(Thread1, &OSB);
   imBufAllocControl(Thread1, &GrabControl);

   /* Load DCF file */
   imCamAlloc(Thread1, NULL, IM_DOWNLOAD, &CamId);    /* IM_DEFAULT */

   CleanKeyboard();
   printf("  - Synchronous Snapshot\n");
   imBufPutField(Thread1, GrabControl, IM_CTL_GRAB_MODE, IM_SYNCHRONOUS);

   iteration = (int)sleepTime * 15;
   while( iteration-- && !kbhit() && !HaltProcess && !imThrGetError(Thread1, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      imDigGrab(Thread1, 0, CamId, GrabChild, 1, GrabControl, 0);

      if (Thread2 && DispChild[0] && DispChild[1])
      {
         imBufCopy(Thread1,    GrabChild, DispChild[1], 0, 0);
         imBufCopy(Thread1, DispChild[1], DispChild[0], 0, 0);
      }

      imSyncHost(Thread1, 0, IM_COMPLETED);
   }

   printf("  - Asynchronous Snapshot\n");
   imBufPutField(Thread1, GrabControl, IM_CTL_GRAB_MODE, IM_ASYNCHRONOUS);

   iteration = (int)sleepTime * 15;
   while( iteration-- && !kbhit() && !HaltProcess && !imThrGetError(Thread1, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      imDigGrab(Thread1, 0, CamId, GrabChild, 1, GrabControl, OSB);

      imSyncHost(Thread1, OSB, IM_COMPLETED);

      if (Thread2 && DispChild[0] && DispChild[1])
      {
         imBufCopy(Thread2,    GrabChild, DispChild[1], 0, 0);
         imBufCopy(Thread2, DispChild[1], DispChild[0], 0, 0);
      }

      if (Thread2)
         imSyncHost(Thread2, 0, IM_COMPLETED);
   }

   CleanKeyboard();
   printf("  - Continuous: ");
   imBufPutField(Thread1, GrabControl, IM_CTL_GRAB_MODE, IM_ASYNCHRONOUS);

   if ( !kbhit() && !HaltProcess && !imThrGetError(Thread1, IM_ERR_CODE+IM_ERR_RESET, NULL))
   {
      imDigGrab(Thread1, 0, CamId, GrabChild, IM_CONTINUOUS, GrabControl, OSB);

      imSyncHost(Thread1, OSB, IM_STARTED);

      printf("for %2.0f seconds\n", sleepTime);

#if defined(_IM_HOST_OS_DOS)
      sleep(sleepTime);
#elif defined(_IM_HOST_OS_NT)
      Sleep((unsigned long)(sleepTime * 1000.0));
#endif

      printf("ThrHalt ...");

      imThrHalt(Thread1, IM_FRAME);

      imSyncHost(Thread1, OSB, IM_COMPLETED);

      printf("Grab halted\n");
   }

   imSyncHost(Thread1, 0, IM_COMPLETED);

   if (Thread2)
      imSyncHost(Thread2, 0, IM_COMPLETED);

   imSyncFree(Thread1, OSB);
   imBufFree(Thread1, GrabControl);

   imCamFree(Thread1, CamId);
   imBufFree(Thread1, GrabChild);

   if (Thread2 && DispChild[0] && DispChild[1])
   {
      imBufFree(Thread1, DispChild[0]);
      imBufFree(Thread2, DispChild[1]);
   }

   sleepTime = 1.0;
#if defined(_IM_HOST_OS_DOS)
   sleep(sleepTime);
#elif defined(_IM_HOST_OS_NT)
   Sleep((unsigned long)(sleepTime * 1000.0));
#endif

}




/*---------------------------------------------------------------------------
 *
 * Name:          PrintHdr()
 *
 * Synopsis:      Print a default header
 *
 * Parameters:    none
 *
 * Returns:       none
 *
 */

static void PrintHdr(void)
{
   printf("\nMatrox Genesis C-Binding demonstration\n");
   printf("\n     Press Ctrl-Break to end loop nicely.");
   printf("\n     Press Ctrl-Break 2 times quickly to abort.");
   printf("\n     Press any key at any time to pass to next demo.\n\n");
   OSsleep(1.0);

}  /* PrintHdr() */



/*---------------------------------------------------------------------------
 *
 * Name:          MyHalt()
 *
 * Synopsis:      This function is called when Ctrl+Break is pressed
 *                (if handler was installed with signal()
 *
 * Parameters:    SigNo    Signal ID
 *
 * Returns:       none
 *
 */

static void MyHalt(int SigNo)
{
   SigNo = SigNo;

   HaltProcess++;

}  /* MyHalt() */



/*---------------------------------------------------------------------------
 *
 * Name:          CleanKeyboard()
 *
 * Synopsis:      Just clean keyboard buffer in case a key was pressed before
 *                entering in a loop.
 *
 * Parameters:    none
 *
 * Returns:       none
 *
 */

static void CleanKeyboard(void)
{
   int c;

   if (kbhit() && !HaltProcess)
   {
      c = getch();

      if ((c == 'q') || (c == 'Q'))
         HaltProcess++;
   }

}  /* CleanKeyboard() */



/*---------------------------------------------------------------------------
 *
 * Name:          OSsleep()
 *
 * Synopsis:      Do a sleep on that OS.
 *
 * Parameters:    sleepTime in seconds
 *
 * Returns:
 *
 */

static void OSsleep(double sleepTime)
{
   if (sleepActive)
   {
#if defined(_IM_HOST_OS_DOS)
      sleep(sleepTime);
#elif defined(_IM_HOST_OS_NT)
      Sleep((unsigned long)(sleepTime * 1000.0));
#else
      sleepTime = sleepTime;
#endif
   }

}  /* OSsleep() */



void ErrHandler(void *Param)
{
   char errmsg[IM_ERR_MSG_SIZE], errfunc[IM_ERR_MSG_SIZE];

   Param = Param;

   /*
    * Get the error messsage and print it.
    */
   imAppGetError(IM_ERR_MSG, errmsg);

   imAppGetError(IM_ERR_FUNC + IM_ERR_RESET, errfunc);

   printf("Error in %s(): <%s>\n", errfunc, errmsg);

} /* ErrHandler */

