; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        This script shows how to verify if any errors
; *                  occur in previous operation and retrieve the
; *                  error message.
; *
; *                  It intentionally generates an error, and 
; *                  get the error message.
; *
; * Used Functions:  imThrGetError
; *
; * Designed:        bfournie
; *
; * Date:            17/05/95
; *
; *
; * Notes:           It exists a special command list to check for
; *                  error using the imThrGetError. It is called 
; *                  test_err.cl. 
; *                  If any errors occur, it displays the function 
; *                  name that cause error and the error message.
; *
; *
; *******************************************************************



      ; Declare internal variables

      long dev
      long thread

      long Src_buf
      long Result_buf
      
      
      ; Allocate the device and thread
      imDevAlloc 0 0 null IM_DEFAULT &dev
      imThrAlloc dev 0 &thread



      ; Allocate Source processing buffer
      imBufAlloc thread 512 512 1 IM_UBYTE IM_PROC &Src_buf
      
      
      ; Allocate Result buffer 
      imBufAlloc thread 512 512 1 IM_SHORT IM_PROC &Result_buf
      
      
      
      ; Call the Projection operation
      ; (error: Projection does not accept 2D result buffer)
      
      imIntProject thread Src_buf Result_buf 0.0 IM_DEFAULT 0      
      

      ; Verify that no error occurs
      execcl "test_err.cl" thread   
      
      
      

      ;
      ; Free up all buffers threads and deallocate the device
      ;
      imBufFree thread Src_buf
      imBufFree thread Result_buf
      
      imThrFree thread
      imDevFree dev
      
      
      
      ; free all used variables
      freedev
      freethread
      
      freeSrc_buf
      freeResult_buf
