; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        This script will perform warp operations
; *
; * Used Functions:  imIntConnectMap
; *
; * Designed:        ETAPUCU
; *
; * Date:            Tue May 16 14:27:34 1995
; *
; * Notes:
; *
; *******************************************************************

   ; VARIABLE DECLARATIONS
   long    DevId
   long    ThrId

   long    SrcBuf
   long    DstBuf

   long    DispBuf
   long    DispBuf_TMP

   long    Coef
   long    KeyInput
   long    AccMode

   ; LOAD STANDARD ERROR SCRIPT FILE
   long    errorNum
   setstr  errorMsg  "                                                             "
   setstr  errorFunc "                                                            "
   
   ; 
   setstr ImageName "im2team.tif"
   
   ; ALLOCATE AND SET SIZING VARIABLES
   long    X_Size
   long    Y_Size
   long    X_Offset
   long    Y_Offset
   setX_Size                  612
   setY_Size                  580
   setX_Offset                50
   setY_Offset                50   
   

   ; ALLOCATE AND SET CONTROL VARIALES
   double X_TransIndex
   double Y_TransIndex
   double X_ScaleIndex
   double Y_ScaleIndex
   double X_ShearIndex
   double Y_ShearIndex
   double RotateIndex

   double X_TransStep
   double Y_TransStep
   double X_ScaleStep
   double Y_ScaleStep
   double X_ShearStep
   double Y_ShearStep
   double RotateStep

   setX_TransIndex             0.0
   setY_TransIndex             0.0
   setX_ScaleIndex             1.0
   setY_ScaleIndex             1.0
   setX_ShearIndex             0.0
   setY_ShearIndex             0.0
   setRotateIndex              0.0

   setX_TransStep              10.0
   setY_TransStep              10.0
   setX_ScaleStep              0.25
   setY_ScaleStep              0.25
   setX_ShearStep              0.25
   setY_ShearStep              0.25
   setRotateStep               5.0


   ; ALLOCATE THE DEVICE AND THREAD
   imdevalloc 0 0 null im_default &DevId
   imthralloc DevId 0 &ThrId


   ; ALLOC THE BUFFERS
   imbufalloc ThrId X_Size Y_Size 1 im_ubyte im_proc &SrcBuf
   imbufalloc ThrId X_Size Y_Size 1 im_ubyte im_proc &DstBuf
   imbufclear ThrId SrcBuf 0 0
   imbufclear ThrId DstBuf 0 0

   
   ; ALLOC THE COEFICIENTS BUFFER AND USE AS CONTROL BUFFER
   imbufalloc2d ThrId 3 2 im_float im_proc &Coef
   imbufclear ThrId Coef 0 0
   ;imbufputfield ThrId Coef IM_CTL_RESAMPLE IM_NEAREST_NEIGHBOR
   imbufputfield ThrId Coef IM_CTL_RESAMPLE IM_BILINEAR
   imbufputfield ThrId Coef IM_CTL_OVERSCAN IM_REPLACE


   ; ALLOC THE DISPLAY CHILD
   imbufchild ThrId im_disp_red 0 0 Y_Size Y_Size  &DispBuf
   imbufalloc ThrId X_Size Y_Size 1 im_ubyte im_proc &DispBuf_TMP
   imbufclear ThrId DispBuf 0 0
   imbufclear ThrId DispBuf_TMP 0 0


   ; LOAD THE IMAGE
   imbufload ThrId [getstr ImageName] im_tiff SrcBuf
   imGenWarp1stOrder ThrId Coef IM_TRANSLATE X_Offset Y_Offset IM_CLEAR 0
   imIntWarpPolynomial ThrId SrcBuf DstBuf Coef Coef 0
   imbufcopy ThrId DstBuf SrcBuf 0 0
   imintconvert ThrId SrcBuf DispBuf_TMP im_default 0
   imbufcopy ThrId DispBuf_TMP DispBuf 0 0

   ; CHECK AND DISPLAY ANY ERRORS WHICH HAVE OCCURED
   execcl "test_err.cl" ThrId


while([getKeyInput] != 27)
{
   echo "Current Index Settings"
   echo "----------------------"
   echo ""
   echoln "X Translate (Pixel Units): "
   echo [dbltostr X_TransIndex 10]
   echoln "Y Translate (Pixel Units): "
   echo [dbltostr Y_TransIndex 10]
   echoln "X Scale (Ratio)          : "
   echo [dbltostr X_ScaleIndex 10]
   echoln "Y Scale (Ratio)          : "
   echo [dbltostr Y_ScaleIndex 10]
   echoln "X Shear ()               : "
   echo [dbltostr X_ShearIndex 10]
   echoln "Y Shear ()               : "
   echo [dbltostr Y_ShearIndex 10]
   echoln "Rotate Angle (Degree)    : "
   echo [dbltostr RotateIndex 10]
   echoln "Key Code Pressed (ASCII) : "
   echo [dbltostr KeyInput 10]
   echo ""
   echo ""
   echo "Main Warp Demo Menu"
   echo "-------------------"
   echo ""
   echo "R  Rotate      +ve             Ctrl-R Rotate        -ve"
   echo "T  Translate   +ve             Ctrl-T Translate     -ve"
   echo "L  Scale       +ve             Ctrl-L Scale         -ve"
   echo "H  Shear       +ve             Ctrl-H Shear         -ve"
   echo ""
   echoln "A  Toggle Accumulative Mode: "
   if( [getAccMode] == IM_NO_CLEAR)
   {
      echo "ON"
   }
   else
   {
      echo "OFF"
   }
   echo ""
   echo "ESC - To Quit!"
   echo ""
   
   setKeyInput [inkey]
   clearhost
   
   if([getKeyInput] == 97)
   {
      if( [getAccMode] == IM_NO_CLEAR)
      {
         setAccMode IM_CLEAR
      }
      else
      {
         setAccMode IM_NO_CLEAR
      }
   }
   
   if([getKeyInput] != 27)
   {
      if([getKeyInput] == 114)
      {
         echo "POSITIVE ROTATION"

         setRotateIndex ([getRotateIndex] + [getRotateStep])

         imGenWarp1stOrder ThrId Coef IM_TRANSLATE ([getX_Size]/(-2)) ([getY_Size]/(-2)) [getAccMode] 0
         imGenWarp1stOrder ThrId Coef IM_ROTATE [getRotateIndex] 0 IM_NO_CLEAR 0
         imGenWarp1stOrder ThrId Coef IM_TRANSLATE ([getX_Size]/2) ([getY_Size]/2) IM_NO_CLEAR 0
      }
      else
      {
         if([getKeyInput] == 116)
         {
            echo "POSITIVE TRANSLATION"

            setX_TransIndex ([getX_TransIndex] + [getX_TransStep])
            setY_TransIndex ([getY_TransIndex] + [getY_TransStep])

            imGenWarp1stOrder ThrId Coef IM_TRANSLATE [getX_TransIndex] [getY_TransIndex] [getAccMode] 0
         }
         else
         {
            if([getKeyInput] == 108)
            {
               echo "POSITIVE SCALING"

               setX_ScaleIndex ([getX_ScaleIndex] + [getX_ScaleStep])
               setY_ScaleIndex ([getY_ScaleIndex] + [getY_ScaleStep])

               imGenWarp1stOrder ThrId Coef IM_SCALE [getX_ScaleIndex] [getY_ScaleIndex] [getAccMode] 0
            }
            else
            {
               if([getKeyInput] == 104)
               {
                  echo "POSITIVE SHEARING"

                  setX_ShearIndex ([getX_ShearIndex] + [getX_ShearStep])
                  setY_ShearIndex ([getY_ShearIndex] + [getY_ShearStep])

                  imGenWarp1stOrder ThrId Coef IM_SHEAR_X [getX_ShearIndex] 0 [getAccMode] 0
                  imGenWarp1stOrder ThrId Coef IM_SHEAR_Y [getY_ShearIndex] 0 IM_NO_CLEAR 0
               }
            }
         }
      }
   }


   if([getKeyInput] != 27)
   {
      if([getKeyInput] == 18)
      {
         echo "NEGATIVE ROTATION"

         setRotateIndex ([getRotateIndex] - [getRotateStep])

         imGenWarp1stOrder ThrId Coef IM_TRANSLATE ([getX_Size]/(-2)) ([getY_Size]/(-2)) [getAccMode] 0
         imGenWarp1stOrder ThrId Coef IM_ROTATE [getRotateIndex] 0 IM_NO_CLEAR 0
         imGenWarp1stOrder ThrId Coef IM_TRANSLATE ([getX_Size]/2) ([getY_Size]/2) IM_NO_CLEAR 0
      }
      else
      {
         if([getKeyInput] == 20)
         {
            echo "NEGATIVE TRANSLATION"

            setX_TransIndex ([getX_TransIndex] - [getX_TransStep])
            setY_TransIndex ([getY_TransIndex] - [getY_TransStep])

            imGenWarp1stOrder ThrId Coef IM_TRANSLATE [getX_TransIndex] [getY_TransIndex] [getAccMode] 0
         }
         else
         {
            if([getKeyInput] == 12)
            {
               echo "NEGATIVE SCALING"

               setX_ScaleIndex ([getX_ScaleIndex] - [getX_ScaleStep])
               setY_ScaleIndex ([getY_ScaleIndex] - [getY_ScaleStep])

               if(([getX_ScaleIndex] <= 0.0 ) | ([getY_ScaleIndex] <= 0.0) )
               {
                  setX_ScaleIndex 0.1
                  setY_ScaleIndex 0.1
               }

               imGenWarp1stOrder ThrId Coef IM_SCALE [getX_ScaleIndex] [getY_ScaleIndex] [getAccMode] 0
            }
            else
            {
               if([getKeyInput] == 8)
               {
                  echo "NEGATIVE SHEARING"

                  setX_ShearIndex ([getX_ShearIndex] - [getX_ShearStep])
                  setY_ShearIndex ([getY_ShearIndex] - [getY_ShearStep])

                  imGenWarp1stOrder ThrId Coef IM_SHEAR_X [getX_ShearIndex] 0 [getAccMode] 0
                  imGenWarp1stOrder ThrId Coef IM_SHEAR_Y [getY_ShearIndex] 0 IM_NO_CLEAR 0
                }
            }
         }
      }
   }

   ; CHECK AND DISPLAY ANY ERRORS WHICH HAVE OCCURED
   execcl "test_err.cl" ThrId

   ; PERFORMED THE WARP OPERATION
   imIntWarpPolynomial ThrId SrcBuf DstBuf Coef Coef 0
   imintconvert ThrId DstBuf DispBuf_TMP im_default 0
   imbufcopy ThrId DispBuf_TMP DispBuf 0 0

   ; CHECK AND DISPLAY ANY ERRORS WHICH HAVE OCCURED
   execcl "test_err.cl" ThrId
}

   ;
   ; Free up all buffers threads and deallocate the device
   ;
   imbuffree ThrId DispBuf
   imbuffree ThrId DispBuf_TMP
   imbuffree ThrId SrcBuf
   imbuffree ThrId DstBuf
   imbuffree ThrId Coef
   imthrfree ThrId
   imdevfree DevId


   ; free all used variables
   freeDevId
   freeThrId
   freeSrcBuf
   freeDispBuf
   freeDispBuf_TMP
   freeDstBuf
   freeCoef
   freeKeyInput
   freeerrorNum
   clearstr errorMsg
   clearstr errorFunc

