# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}


# --------------------------------------------------------------------------
function ChkInclude(cur_drive, PathInc, toOutput)
{
   if (ifexist(cur_drive""PathInc"\\*.h") == 1)
      {
      if (IncludeDependStr != "")
         {
         printf "%s", IncludeDependStr >toOutput
         IncludeDependStr = ""
         printf "\\\n%s\\*.h", PathInc >toOutput
         }
      else if (PathInc != "." && PathInc != ".\\")
         printf " \\\n%s\\*.h", PathInc >toOutput
      }

   if (ifexist(cur_drive""PathInc"\\*.inc") == 1)
      {
      if (IncludeDependStr != "")
         {
         printf "%s", IncludeDependStr >toOutput
         IncludeDependStr = ""
         printf "\\\n%s\\*.inc", PathInc >toOutput
         }
      else if (PathInc != "." && PathInc != ".\\")
         printf " \\\n%s\\*.inc", PathInc >toOutput
      }
}

# --------------------------------------------------------------------------
function ChkFile(cur_drive, fname, extension, toOutput)
{
   fileName = fname""extension

   if (ifexist(cur_drive""fileName) == 1)
      {
      printFname(fileName, toOutput)
      return 1
      }
   else
      {
      return 0
      }
}

# --------------------------------------------------------------------------
function printFname(fname, toOutput)
{
   fname = tolower(fname)

   if (FNAMESTR != "")
      {
      printf "%s", FNAMESTR >toOutput
      FNAMESTR = ""
      printf "\\\n$(SRCDIR)\\%s", fname >toOutput
      }
   else
      printf " \\\n$(SRCDIR)\\%s", fname >toOutput

   fileNameTable[fileNameNdx++] = fname

   # Check if file is duplicated in another side directory
   if (GetEnviron("CHECKINF") == "YES")
      {
      infFile = CWD""LogFile"\\srcfile.inf"

      nbf = split(CurrentWorkingDir"\\"fname, tmpstr, "\\")

      srchFile = tmpstr[nbf-1]"\\"tmpstr[nbf]

      while(validLine = getline<infFile > 0)
         {
         if (index($0, "\\"fname) != 0)
            {
            if (index($0, srchFile) != 0)
               break       # Source match srcfile.inf
            else
               exit 3      # Error, source exist in another directory
            }
         }

      close(infFile)

      # Add file to infFile if not found in srcfile.inf
      if (validLine <= 0)
         {
         printf "%s\n", srchFile >>infFile
         close(infFile)
         }
      }
}



# --------------------------------------------------------------------------
BEGIN {
   if (ARGC < 3)
      {
      printf "gawk -f chkfile.awk [ALL|filename_with_ext|filename_no_ext] [output_to]\n"
      exit 0
      }

   targetName = ARGV[1]
   ARGV[1] = ""

   allfile = ARGV[2]
   ARGV[2] = ""

   FNAMESTR = "FNAME\="
   IncludeDependStr = "H_DEP\="

   fileNameNdx = 0
   fileNameTable[0] = ""

   CurrentWorkingDir = tolower(getcwd())

   split(CurrentWorkingDir, curWorkDir, ":")
   CWD = curWorkDir[1]":"

   split(GetEnviron("RAMDRIVE"), curWorkDir, ":")
   RAMDRIVE = curWorkDir[1]":"

   for (ii in curWorkDir)
      delete curWorkDir[ii]

   printf "\n" >allfile

   printf "TMPDRIVE=%s\n\n", RAMDRIVE >allfile

   printf "CWD=%s\n\n", CurrentWorkingDir >allfile

   if (ifexist(CWD".\\make\\.") == 0)
      {
      # OK We are in a source directory now.

      if (GetEnviron("LOGFILEPATH") != "")
         {
         LogFile = tolower(GetEnviron("LOGFILEPATH"))
         gsub(/\\$/, "", LogFile)
         }
      else
         LogFile = "..\\log"

      if (ifexist(CWD""LogFile) == 0)
         {
         # But there is no valid logging directory.
         printf "ERR5: Logging directory %s inexistant. Please create one.\n", CWD""LogFile
         exit 2      # Special error
         }

      printf "LOGFILE=%s\n\n", LogFile >allfile
      }


   ObjDirPath[1] = "OBJDIR"
   ObjDirPath[2] = "."

   SrcDirPath[1] = "SRCDIR"
   SrcDirPath[2] = "."

   DigDirPath[1] = "DIG_ID"
   DigDirPath[2] = ""

   RevDirPath[1] = "REVISION"
   RevDirPath[2] = ""

   # First use ENVIRON variable for {Obj|Src|Rev}DirPath[2]
   if (GetEnviron("OBJDIR") != "")
      ObjDirPath[2] = tolower(GetEnviron("OBJDIR"))

   if (GetEnviron("SRCDIR") != "")
      SrcDirPath[2] = tolower(GetEnviron("SRCDIR"))

   if (GetEnviron("DIG_ID") != "")
      DigDirPath[2] = tolower(GetEnviron("DIG_ID"))

   if (GetEnviron("REVISION") != "")
      RevDirPath[2] = tolower(GetEnviron("REVISION"))

   # Second read rule.mak and if exist force {Obj|Src|Rev}DirPath to proper value.
   # rule.mak is created from imcc options.
   rule_mak = GetEnviron("RAMDRIVE")"obj\\"GetEnviron("OBJDIR")"\\rule.mak"
   if (ifexist(rule_mak) == 1)
      {
      while(getline<rule_mak > 0)
         {
         line_in = toupper($0)

         if (index(line_in, "OBJDIR") != 0)
            split(line_in, ObjDirPath, "=")

         if (index(line_in, "SRCDIR") != 0)
            split(line_in, SrcDirPath, "=")

         if (index(line_in, "DIG_ID") != 0)
            split(line_in, DigDirPath, "=")

         if (index(line_in, "REVISION") != 0)
            split(line_in, RevDirPath, "=")
         }

      close(rule_mak)
      }

   # Third read objpath.rul and if exist force {Obj|Src}DirPath to proper value.
   objpath_rul = CWD".\\objpath.rul"
   if (ifexist(objpath_rul) == 1)
      {
      while(getline<objpath_rul > 0)
         {
         line_in = toupper($0)
         if (index(line_in, "$(OBJDIR.DIG_ID)") != 0)
            {
            gsub(/\$\(OBJDIR\.DIG_ID\)/, ObjDirPath[2], line_in)
            line_in = toupper(line_in)
            gsub(/\\OBJ\\/, "\\OBJ.$(DIG_ID)\\", line_in)
            }

         if (index(line_in, "$(OBJDIR)") != 0)
            gsub(/\$\(OBJDIR\)/, ObjDirPath[2], line_in)

         if (index(line_in, "OBJDIR") != 0)
            split(line_in, ObjDirPath, "=")
         else if (index(line_in, "SRCDIR") != 0)
            split(line_in, SrcDirPath, "=")
         else
            printf "%s\n\n", line_in >allfile
         }

      close(objpath_rul)
      }

   gsub(/ /,   "", ObjDirPath[2])
   gsub(/ /,   "", SrcDirPath[2])
   gsub(/ /,   "", DigDirPath[2])
   gsub(/ /,   "", RevDirPath[2])

   gsub(/\\$/, "", ObjDirPath[2])
   gsub(/\\$/, "", SrcDirPath[2])
   ObjDirPath[2] = tolower(ObjDirPath[2])
   SrcDirPath[2] = tolower(SrcDirPath[2])

   if (DigDirPath[2] != "" && index(ObjDirPath[2], "$(dig_id)") != 0)
      {
      gsub(/\\$/, "", DigDirPath[2])
      gsub(/\$\(dig_id\)/, DigDirPath[2], ObjDirPath[2])
      }

   else if (DigDirPath[2] == "" && index(ObjDirPath[2], "$(dig_id)") != 0)
      gsub(/\$\(dig_id\)/, "gen", ObjDirPath[2])   # Default digitizer directory for Genesis

   if (RevDirPath[2] != "")
      {
      gsub(/\\$/, "", RevDirPath[2])
      ObjDirPath[2] = ObjDirPath[2]"\\"tolower(RevDirPath[2])
      }

   if (ifexist(CWD".\\make\\.") == 0 && ifexist(CWD""ObjDirPath[2]) == 0)
      {
      # OK We are in a source directory, but there is no object directory.

      printf "ERR6: Object directory '%s' inexistant. Please create one.\n", CWD""ObjDirPath[2]
      exit 2      # Special error
      }

   printf "%s=%s\n\n", ObjDirPath[1], ObjDirPath[2] >allfile
   printf "%s=%s\n\n", SrcDirPath[1], SrcDirPath[2] >allfile


   libname_rul = CWD""ObjDirPath[2]"\\libname.rul"
   if (ifexist(libname_rul) == 1)
      {
      printf "!undef LIBNAME\n\n", $0 >allfile

      while(getline<libname_rul > 0)
         printf "%s\n\n", $0 >allfile

      close(libname_rul)
      }

   for (ii in ObjDirPath)
      delete ObjDirPath[ii]

   for (ii in SrcDirPath)
      delete SrcDirPath[ii]

   for (ii in DigDirPath)
      delete DigDirPath[ii]

   for (ii in RevDirPath)
      delete RevDirPath[ii]


   # COMP_ID is used in compiler.typ to identify which compiler is used
   extraObjToLib = ""
   SrcType[0] = 0    # C
   SrcType[1] = 0    # CPP
   SrcType[2] = 0    # PPC
   SrcType[3] = 0    # ASM
   SrcType[4] = 0    # S
   SrcType[5] = 0    # RC

   if ((index(toupper(GetEnviron("COMP_NAME")), "MICROSOFT")   != 0) ||
       (index(toupper(GetEnviron("COMP_NAME")), "VC++")        != 0))
      {
      printf "COMP_ID=VC++\n\n" >allfile
      replaceMacro = ""
      extraObjToLib = "*.lib"
      SrcType[0] = 1    # C
      SrcType[1] = 1    # CPP
      SrcType[3] = 1    # ASM
      SrcType[5] = 1    # RC
      }
   else if (index(toupper(GetEnviron("COMP_NAME")), "WATCOM")   != 0)
      {
      printf "COMP_ID=WATCOM\n\n" >allfile
      replaceMacro = "-+"
      SrcType[0] = 1    # C
      SrcType[1] = 2    # CPP
      }
   else if ((index(toupper(GetEnviron("COMP_NAME")), "MVP")      != 0) ||
            (index(toupper(GetEnviron("COMP_NAME")), "C80")      != 0))
      {
      printf "COMP_ID=C80\n\n" >allfile
      replaceMacro = ""
      SrcType[0] = 1    # C
      SrcType[2] = 1    # PPC
      SrcType[3] = 1    # ASM
      SrcType[4] = 1    # S
      }
   else if (index(toupper(GetEnviron("COMP_NAME")), "PPC")      != 0)
      {
      printf "COMP_ID=PPC\n\n" >allfile
      replaceMacro = ""
      SrcType[0] = 1    # C
      SrcType[1] = 1    # CPP
      SrcType[3] = 1    # ASM
      SrcType[4] = 1    # S
      }
   else if (index(toupper(GetEnviron("COMP_NAME")), "METAWARE")      != 0)
      {
      printf "COMP_ID=MWPPC\n\n" >allfile
      replaceMacro = ""
      SrcType[0] = 1    # C
      SrcType[1] = 1    # CPP
      SrcType[3] = 1    # ASM
      SrcType[4] = 1    # S
      }
   else if (index(toupper(GetEnviron("COMP_NAME")), "BC45++") != 0)
      {
      printf "COMP_ID=BC45++\n\n" >allfile
      replaceMacro = "-+"
      SrcType[0] = 1    # C
      SrcType[1] = 1    # CPP
      }
   else if (index(toupper(GetEnviron("COMP_NAME")), "BC++")   != 0)
      {
      printf "COMP_ID=BC++\n\n" >allfile
      replaceMacro = "-+"
      SrcType[0] = 1    # C
      SrcType[1] = 1    # CPP
      }
   else
      {
      printf "COMP_ID=\n\n" >allfile
      }

   # Handle optional response file if any.
   option_rsp = CWD".\\option.rsp"

   tmp_rsp_file = "TMP_RSP_FILE = "

   if (GetEnviron("RSPFILE") != "" || ifexist(option_rsp) == 1)
      {
      tmp_rsp_file = tmp_rsp_file"copy "

      if (GetEnviron("RSPFILE") != "")
         tmp_rsp_file = tmp_rsp_file""GetEnviron("RAMDRIVE")""GetEnviron("RSPFILE")

      if (GetEnviron("RSPFILE") != "" && ifexist(option_rsp) == 1)
         tmp_rsp_file = tmp_rsp_file" + "

      if (ifexist(option_rsp) == 1)
         tmp_rsp_file = tmp_rsp_file""option_rsp

      tmp_rsp_file = tmp_rsp_file" "RAMDRIVE"tmp.rsp >NUL"
      }
   else
      {
      tmp_rsp_file = tmp_rsp_file"echo No default response file! >NUL"
      }

   printf "%s\n\n", tmp_rsp_file >allfile



   # Check for headers in current directory
   ChkInclude(CWD, ".", allfile)

   if ((PathForInclude = GetEnviron("INCLUDE")) == "")
      PathForInclude = GetEnviron("C_DIR")


   if (PathForInclude != "")
      {
      IncNdx = split(PathForInclude, include, ";")

      for (ii=1; ii<IncNdx; ii++)
         {
         if (include[ii] < "A" || include[ii] > "Z")
            ChkInclude("", include[ii], allfile)
         }

      for (ii in include)
         delete include[ii]
      }

   printf "\n\n" >allfile

   if (tolower(targetName) == "all" || match(targetName, /[\*\?]/) != 0)
      {
      # Do for all available sources
      sysCmd = "dir /B /L /On "CWD
      if (tolower(targetName) == "all")
         {
         printf "DOALL=YES\n\n" >allfile
         }
      else
         sysCmd = sysCmd""targetName

      PipeSrcFile = RAMDRIVE"srcfile.pip"
      system(sysCmd">"PipeSrcFile)

      while (getline<PipeSrcFile > 0)
         {
         targetName = $0
         split($0, extension, "\.")

         if      (extension[2] == "c"   && SrcType[0])
            printFname(targetName, allfile)
         else if (extension[2] == "cpp" && SrcType[1])
            printFname(targetName, allfile)
         else if (extension[2] == "ppc" && SrcType[2])
            printFname(targetName, allfile)
         else if (extension[2] == "asm" && SrcType[3])
            printFname(targetName, allfile)
         else if (extension[2] == "s"   && SrcType[4])
            printFname(targetName, allfile)
         else if (extension[2] == "rc"  && SrcType[5])
            printFname(targetName, allfile)
         }

      for (ii in extension)
         delete extension[ii]

      close(PipeSrcFile)
      system("del "PipeSrcFile">NUL")

      printf "\n\n" >allfile
      }
   else
      {
      # File name supplied

      if (index(targetName, "\\") != 0)
         {
         nbf = split(targetName, srcdir, "\\")

         targetName = srcdir[nbf]

         printf "SRCDIR=" >allfile
         for (ndx=1; ndx<nbf-1; ndx++)
            printf "%s\\", srcdir[ndx] >allfile

         printf "%s\n\n", srcdir[ndx] >allfile

         nbf = split(srcdir[1], tmpstr, ":")

         cur_drv = tmpstr[1]":"

         for (ii in srcdir)
            delete srcdir[ii]

         for (ii in tmpstr)
            delete tmpstr[ii]
         }
      else
         cur_drv = CWD

      if (ChkFile(cur_drv, targetName, "", allfile) == 0)
         {
         # No extension specified
         ChkFile(cur_drv, targetName, ".c",   allfile)

         if (HostSrc)
            ChkFile(cur_drv, targetName, ".cpp", allfile)

         if (!HostSrc)
            ChkFile(cur_drv, targetName, ".ppc", allfile)

         ChkFile(cur_drv, targetName, ".asm", allfile)

         if (!HostSrc)
            ChkFile(cur_drv, targetName, ".s",   allfile)

         if (HostSrc && RcFile)
            ChkFile(cur_drv, targetName, ".rc",  allfile)
         }

      printf "\n\n" >allfile
      }


   for (ndx=0; ndx<fileNameNdx; ndx++)
      {
      gsub(/\.cpp/, ".obj", fileNameTable[ndx])
      gsub(/\.c/,   ".obj", fileNameTable[ndx])
      gsub(/\.asm/, ".obj", fileNameTable[ndx])
      gsub(/\.ppc/, ".o",   fileNameTable[ndx])
      gsub(/\.s/,   ".o",   fileNameTable[ndx])
      gsub(/\.rc/,  ".res", fileNameTable[ndx])
      }

   for (ndx=0; ndx<fileNameNdx; ndx++)
      {
      if (ndx == 0)
         printf "OBJNAME=\\\n$(OBJDIR)\\%s", fileNameTable[ndx] >allfile
      else
         printf " \\\n$(OBJDIR)\\%s", fileNameTable[ndx] >allfile
      }

   printf "\n\n" >allfile

   if (extraObjToLib != "")
      fileNameTable[fileNameNdx++] = extraObjToLib


   for (ndx=0; ndx<fileNameNdx; ndx++)
      {
      if (ndx == 0)
         printf "OBJNAMEINLIB=\\\n%s%s", replaceMacro, fileNameTable[ndx] >allfile
      else
         printf " \\\n%s%s", replaceMacro, fileNameTable[ndx] >allfile
      }

   printf "\n\n" >allfile


   close(allfile)
}
