# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}

# --------------------------------------------------------------------------
function isSourceInDirectory(curDir)
{
   if (ifexist(curDir"\\*.c")   == 1 ||
       ifexist(curDir"\\*.s")   == 1 ||
       ifexist(curDir"\\*.ppc") == 1 ||
       ifexist(curDir"\\*.asm") == 1 ||
       ifexist(curDir"\\*.cpp") == 1 ||
       ifexist(curDir"\\*.rc")  == 1   )
      return(1);
   else
      return(0);
}

# --------------------------------------------------------------------------
function createMakeFile(curDir)
{
   if (isSourceInDirectory(curDir) == 1)
      {
      printf "WARNING: Source(s) in same directory as the make.\n"
      printf "         Move source(s) to a directory below.\n"
      printf "         For directory:\n"
      }

   printf "%s\n", curDir > "CON"

   i = 0
   MakeFile = RAMDRIVE"makefile.tmp"

   skipDir = 0

   PipeTmp1 = RAMDRIVE"cmkfile1.pip"
   system("dir /B /AD /L /On "curDir">"PipeTmp1)

   digitizerDir = 0

   while (getline<PipeTmp1 > 0)
      {
      if (match($0, /dos|winnt|nt|obj|exe|log|make|headers|\.|\.\./) != 1)
         {
         directoryName = tolower($1)

         thisDir = curDir"\\"directoryName

         if ((isSourceInDirectory(thisDir) == 1) || (ifexist(thisDir"\\make\\.")  == 1))
            dirList[i++] = toupper(directoryName)
         else
            {
            skipDir++
            printf "%s\n", thisDir > skipDirList
            }
         }

      if (match($0, /obj\.gen|obj\.mac/) == 1)
         digitizerDir = 1
      }

   close(PipeTmp1)
   system("del "PipeTmp1">NUL")


   printf "# Makefile for a nested make created by cmkfile.bat\n\n" >MakeFile

   if (i > 0)
      {
      printf "DIR2DO = " >MakeFile

      for (j=0; j<i; j++)
         printf "%s._D_ ", dirList[j] >MakeFile

      printf "\n\n.PRECIOUS : $(DIR2DO)\n\nall : $(DIR2DO)\n\n" >MakeFile

      for (j=0; j<i; j++)
         {
         printf "." > "CON"

         printf "%s._D_ :\n", dirList[j] >MakeFile
         printf "   @cd .\\$(@:._D_=)\n" >MakeFile
         printf "   @echo ------------------------------------------------------------\n" >MakeFile
         printf "   @echo Compilation of directory:\n" >MakeFile
         printf "   @cd\n" >MakeFile

         if (ifexist(curDir"\\"dirList[j]"\\make\\.") == 1)
            printf "   @$(MAKE) /f .\\make\\makefile\n" >MakeFile
         else
            {
            if (digitizerDir && dirList[j] == "DIG")
               {
               printf "   @$(RAMDRIVE)imcc.bat /N ALL /dig mac\n" >MakeFile
               printf "   @$(RAMDRIVE)imcc.bat /N ALL /dig\n" >MakeFile
               }
            else
               printf "   @$(RAMDRIVE)imcc.bat /N ALL\n" >MakeFile

            if (DirOfSrc != "")
               print curDir"\\"tolower(dirList[j]) >DirOfSrc
            }

         printf "   @cd ..\\.\n\n" >MakeFile
         }

      printf "\n" > "CON"
      }

   else if (!skipDir)
      printf "%s\n", curDir > skipDirList

   printf "\n" >MakeFile

   if (skipDir != 0)
      printf "%d skipped directory (no source in those directories)\n", skipDir > "CON"

   close(MakeFile)

   sysCmd = RAMDRIVE"\\move "MakeFile" "curDir"\\make\\makefile >NUL"
   system(sysCmd)
}


BEGIN {
   doall = toupper(ARGV[1])
   ARGV[1] = ""
   firstPass = 1

   printf "Searching make directories (may be long) ...\n\n" > "CON"

   CurrentWorkingDir = tolower(getcwd())
   gsub(/\\$/, "", CurrentWorkingDir)

   split(CurrentWorkingDir, curWorkDir, ":")
   CWD = curWorkDir[1]":"

   split(GetEnviron("RAMDRIVE"), curWorkDir, ":")
   RAMDRIVE = curWorkDir[1]":"

   for (ii in curWorkDir)
      delete curWorkDir[ii]

   skipDirList = RAMDRIVE"\\dirlist.pip"

   if (doall == "ALL")
      {
      DirOfSrc = RAMDRIVE"\\dirofsrc.pip"

      PipeTmp0 = RAMDRIVE"cmkfile0.pip"
      system("dir /AD /S /B /L /On "CurrentWorkingDir"\\make*>"PipeTmp0)

      while (getline<PipeTmp0 > 0)
         {
         if (match($0, /ntkernel|linux|genutil/) == 0)
            {
            if (firstPass == 1)
               {
               printf "Create makefile for:\n" > "CON"
               firstPass = 0
               }

            gsub(/make/, "")
            gsub(/\\\\/, "\\")
            gsub(/\\$/, "")

            createMakeFile(tolower($0))
            }
         }

      close(PipeTmp0)
      close(DirOfSrc)
      system("del "PipeTmp0">NUL")
      }
   else
      {
      DirOfSrc = ""
      createMakeFile(CurrentWorkingDir)
      }

   printf "\n" >skipDirList

   close(skipDirList)
   system("sort <"DirOfSrc" >"RAMDRIVE"\\used.dir")
   system("sort <"skipDirList" >"RAMDRIVE"\\unused.dir")
   system("del "DirOfSrc">NUL")
   system("del "skipDirList">NUL")

   printf "\n"
   printf "see "RAMDRIVE"\\used.dir   for directory with sources\n"
   printf "see "RAMDRIVE"\\unused.dir for empty directory\n\n"
   printf "done!\n"
}
