BEGIN {

   if (ARGC < 5)
      {
      printf "gawk -f dodoc.awk srcfile nofnctfile fnctfile indexfile\n"
      exit 0
      }

   nofnct = "NO FUNCTION'S HEADER FOUND\n"

   printf "Processing source files ...\n" >"CON"

   filelist = ARGV[1]
   ARGV[1] = ""

   nofnctfile = ARGV[2]
   ARGV[2] = ""

   fnctfile = ARGV[3]
   ARGV[3] = ""

   indexfile = ARGV[4]
   ARGV[4] = ""

   for (ndx in ARGV)
      delete ARGV[ndx]
   
   printf ";=============================================================================\n" >nofnctfile
   printf ";Files with %s\n", nofnct >nofnctfile
   
   printf "\n;=============================================================================\n" >fnctfile
   printf ";Files with function's header\n" >fnctfile

   printf "\n;=============================================================================\n" >indexfile
   printf ";Functions vs filename\n" >indexfile

   while (getline<filelist > 0)
      {
      srcfile = $0

      if (match(srcfile, /:/) != 0 && match(srcfile, /\\bak\\/) == 0 && match(srcfile, /\\old\\/) == 0)
         {
         hdrfound = 0

         printf "Source: %s ", srcfile >"CON"

         # Read source file and extract function's header
         while (getline<srcfile > 0)
            {
            if (match($0, /^/) != 0)
               {
               # Page break found, a header that follow maybe?

               if (validline = getline<srcfile > 0)
                  {
                  while (match($0, /^( *|\t*)$/) != 0 && validline >= 0)
                     {
                     # Remove blank line between  and non-blank line
                     if (validline = getline<srcfile < 0)
                        break
                     }

                  # Valid start of function's header
                  if (match($0, /^ *\/\*|^\; *\/\*|^\;\;|^\;\*|^\*/) != 0 && validline >= 0)
                     {
                     if (hdrfound == 0)
                        printf "\n\nSource: %s\n\n", srcfile >fnctfile

                     # Header found, print first line of header
                     hdrfound = 1

                     printf "." >"CON"

                     printf "\n%s\n", $0 >fnctfile

                     # While not end of function's header
                     while (validline = getline<srcfile > 0)
                        {
                        if (match($0, /\* Name:/) != 0 && validline >= 0)
                           {
                           for (ndx=1; ndx<=NF; ndx++)
                              if (match($(ndx), /\(.*/) != 0)
                                 break
                                 
                           split($(ndx), functionName, "\(")
                           }
                           
                        # Break if end of header found
                        if (match($0, /^ *\*|^\;/) == 0 && validline >= 0)
                           break

                        printf "%s\n", $0 >fnctfile
                        }
                        
                     # Check if function really match name in header
                     do 
                        {
                        if (match($0, functionName[1]) != 0)
                           {
                           if (match(tolower($0), /^static /) != 0)
                              fnctType = "S"
                           else if (match(tolower($0), /inline/) != 0)
                              fnctType = "I"
                           else   
                              fnctType = "P"
                           
                           printf "%-50s %s : %s\n", functionName[1]"()", fnctType, srcfile >indexfile
                           break
                           }
                           
                        if (match($0, /\{/) != 0 || match($0, /proc/) != 0 || match($0, /\.global/) != 0)   
                           {
                           # oops mismatch between Name: and function itself.
                           printf "%-30s : mismatch between header and function itself.\n", functionName[1]"()" >indexfile
                           break
                           }
                        }
                     while (validline = getline<srcfile > 0)
                     
                     }
                  }
               }

               
            if (validline < 0)
               break
            }

         if (hdrfound == 0)
            {
            printf "%s", nofnct >"CON"

            printf "Source: %s\n", srcfile >nofnctfile
            }
         else
            {
            printf "\n" >"CON"
            }


         close(srcfile)
         }
      }

   close(filelist)
   close(nofnctfile)
   close(fnctfile)
   close(indexfile)
}
