# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}

# Extract from SET, PATH and C_TOOLS to combine in PATH.
# Upper case in PATH are conserved. C_TOOLS is merged to PATH.
# C_TOOLS must use lower case  string. If upper case is used
# set will be permanent.
# A very long path can be generated if 'bset' tool is used.
#
# Before:
# PATH=C:\;C:\WINDOWS;C:\NFS;i:\watcom\binb;
# C_TOOLS=i:\bc3.1\bin;
#
# After:
# PATH=C:\;C:\WINDOWS;C:\NFS;i:\bc3.1\bin;

BEGIN {

   nf_path = 0

   RamDrive = toupper(GetEnviron("RAMDRIVE"))

   split(RamDrive, curWorkDir, ":")
   RAMDRIVE = curWorkDir[1]":"

   PipeTmp = RAMDRIVE"subst.pip"
   system("subst>"PipeTmp)

   while (getline<PipeTmp > 0)
   {
      if (RAMDRIVE == $1)
      {
         RamDrive = $3
         break
      }
   }

   close(PipeTmp)
   system("del "PipeTmp">NUL")

   for (ndx in ENVIRON)
      {
      if (tolower(ndx) == "path")
         {
         nf_path = split(ENVIRON[ndx], path, ";")
         break
         }
      }

   if (nf_path == 0)
      {
      printf "ERROR: PATH variable is not set properly\n" > "CON"
      exit 2
      }

   if (path[nf_path] == "")
      nf_path--               # PATH was ended by ;


   if (ARGC == 2)
      {
      SetFile = ARGV[1]
      ARGV[1] = ""

      CTOOLS = ""

      if (ifexist(SetFile) == 0)
      {
         print "Invalid Compiler" > "CON"
         exit 2
      }

      while (getline<SetFile > 0)
         {
         print $0

         if (index(tolower($0), "c_tools=") != 0)
            split($0, CTOOLS, "=")    # CTOOLS[2] is the path for C_TOOLS
         }
      }

   print "IMCCINIT=YES"

   printf ndx"="RamDrive";"


   if (GetEnviron("C_TOOLS") != "")
      {
      nf_tools_path = split(tolower(GetEnviron("C_TOOLS")), tools_path, ";")

      if (tools_path[nf_tools_path] == "")
         nf_tools_path--      # C_TOOLS was ended by ;
      }
   else
      nf_tools_path = 0

   for (i=1; i<=nf_path; i++)
      {
      for (j=1; j<=nf_tools_path; j++)
         {
         if (tolower(path[i]) == tools_path[j])
            break
         }

      # if sub-path not in old C_TOOLS, keep it
      if (j > nf_tools_path && path[i] != "" && toupper(path[i]) != RamDrive)
         printf "%s;", path[i]
      }

   for (ndx in tools_path)
      delete tools_path[ndx]

   for (ndx in path)
      delete path[ndx]


   # Add new C_TOOLS to path
   if (CTOOLS[2] != "")
      {
      nf_tools_path = split(CTOOLS[2], tools_path, ";")

      if (tools_path[nf_tools_path] == "")
         nf_tools_path--      # C_TOOLS was ended by ;
      }
   else
      nf_tools_path = 0

   for (j=1; j<=nf_tools_path; j++)
      {
      if (tools_path[j] != "")
         printf "%s;", tools_path[j]
      }

   for (ndx in tools_path)
      delete tools_path[ndx]

   printf "\n"
}
