///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// AVI File Handler C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_AVIFILEHANDLER_CPLUSPLUS)
#define __ACTIVEMIL_AVIFILEHANDLER_CPLUSPLUS

// Include MFC template support
#include <afxtempl.h>

// Include enumerated types
#include "ActiveMILBaseTypes.h"

/////////////////////////////////////////////////////////////////////////////
// IAVIFileHandler wrapper class

class IAVIFileHandler : public COleDispatchDriver
{
public:
   IAVIFileHandler() {}    // Calls COleDispatchDriver default constructor
   IAVIFileHandler(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
   IAVIFileHandler(const IAVIFileHandler& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}
   
   static IAVIFileHandler NewInstance();

// Attributes
public:

// Operations
public:
   void Save(LPCTSTR FileName, long FileFormat, const CArray<IImage, IImage&>& Images, double FrameRate, BOOL AppendToFile);
   void Load(LPCTSTR FileName, long FileFormat, const CArray<IImage, IImage&>& Images, long StartImage, long NumberOfFrames);

   void Open(LPCTSTR FileName, AVIFileFormatConstants FileFormat, AVIOpenOperationConstants OpenOperation); 
   void Read(const CArray<IImage, IImage&>& Images, long StartImage, long NumberOfFrames); 
   void Write(const CArray<IImage, IImage&>& Images, double FrameRate); 
   void Close(); 

};

#endif // __ACTIVEMIL_AVIFILEHANDLER_CPLUSPLUS