///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Application C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_APPLICATION_CPLUSPLUS)
#define __ACTIVEMIL_APPLICATION_CPLUSPLUS

#if !defined(ACTIVEMIL_IN_PROJECT)
#error ActiveMIL support has not been added to this project.  Make sure that the "Matrox ActiveMIL VC++ Add-In" is enabled, and that "Add ActiveMIL To Project" has been called from the add-in's toolbar.
#endif

#if defined(ACTIVEMIL_USE_COM_CLASS)

   #pragma warning(push)
   #pragma warning(disable : 4146)
   #import "MIL.OCX" no_namespace
   #pragma warning(pop)


   /////////////////////////////////////////////////////////////////////////////
   // CApplication wrapper class

   class CApplication : public CWnd, public IApplicationPtr
   {
      virtual void PreSubclassWindow()
         {
         IApplication* pAppl ;
         CWnd::GetControlUnknown()->QueryInterface(__uuidof(IApplication), (void**) &pAppl) ;
         IApplicationPtr::Attach(pAppl, false) ;
         }
   };

#else // !ACTIVEMIL_USE_COM_CLASS

   // Include enumerated types
   #include "ActiveMILBaseTypes.h"

   // Dispatch interfaces referenced by this interface
   #include "AvailableSystem.h"
   #include "AvailableSystems.h"
   #include "ApplicationTimer.h"

   /////////////////////////////////////////////////////////////////////////////
   // CApplication wrapper class

   class CApplication : public CWnd
   {
      CString m_strName;

   protected:
      DECLARE_DYNCREATE(CApplication)
   public:
      CLSID const& GetClsid()
      {
         static CLSID const clsid
            = { 0xe1208de6, 0xa783, 0x11d0, { 0x91, 0x61, 0x0, 0xa0, 0x24, 0xd2, 0x49, 0x92 } };
         return clsid;
      }
      virtual BOOL Create(LPCTSTR lpszClassName,
         LPCTSTR lpszWindowName, DWORD dwStyle,
         const RECT& rect,
         CWnd* pParentWnd, UINT nID,
         CCreateContext* pContext = NULL)
      { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

      BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
         const RECT& rect, CWnd* pParentWnd, UINT nID,
         CFile* pPersist = NULL, BOOL bStorage = FALSE,
         BSTR bstrLicKey = NULL)
      { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
         pPersist, bStorage, bstrLicKey); }

   // Attributes
   public:
      BOOL GetProcessingCompensation();
      void SetProcessingCompensation(BOOL);
      BOOL GetMemoryCompensation();
      void SetMemoryCompensation(BOOL);
      CString GetName();
      void SetName(LPCTSTR);
      IAvailableSystems GetAvailableSystems();
      IAvailableSystem GetAvailableSystems(long Index);
      void SetAvailableSystems(LPDISPATCH);
      IApplicationTimer GetTimer();
      void SetTimer(LPDISPATCH);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
      void Control(long ControlType, const VARIANT& ControlFlag);
      VARIANT Inquire(long ParamToInquire);
      long ControlThread(long ControlID, long ControlType, long ControlValue);
      void Modified(long ModificationType = 0);
      void AboutBox();
   };


   /////////////////////////////////////////////////////////////////////////////
   // IApplication wrapper class

   class IApplication : public COleDispatchDriver
   {
     CString m_strName;

   public:
	   IApplication() {}		// Calls COleDispatchDriver default constructor
	   IApplication(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	   IApplication(const IApplication& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

     static IApplication NewInstance();

   // Attributes
   public:
     BOOL GetProcessingCompensation();
     void SetProcessingCompensation(BOOL);
     BOOL GetMemoryCompensation();
     void SetMemoryCompensation(BOOL);
     CString GetName();
     void SetName(LPCTSTR);
     IAvailableSystems GetAvailableSystems();
     IAvailableSystem GetAvailableSystems(long Index);
     void SetAvailableSystems(LPDISPATCH);
     IApplicationTimer GetTimer();
     void SetTimer(LPDISPATCH);

     // Default property
     operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
     void Control(long ControlType, const VARIANT& ControlFlag);
     VARIANT Inquire(long ParamToInquire);
     long ControlThread(long ControlID, long ControlType, long ControlValue);
     void Modified(long ModificationType = 0);
     void AboutBox();
   };

#endif // ACTIVEMIL_USE_COM_CLASS

#endif // __ACTIVEMIL_APPLICATION_CPLUSPLUS
