///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Blob Result C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_BLOBRESULT_CPLUSPLUS)
#define __ACTIVEMIL_BLOBRESULT_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IBlobRun;
class IBlobRuns;
class IBlobChain;
class IBlobChains;

/////////////////////////////////////////////////////////////////////////////
// IBlobResult wrapper class

class IBlobResult : public COleDispatchDriver
{
public:
   IBlobResult() {}		// Calls COleDispatchDriver default constructor
   IBlobResult(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
   IBlobResult(const IBlobResult& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
   long GetLabelValue();
   void SetLabelValue(long);
   double GetArea();
   void SetArea(double);
   double GetPerimeter();
   void SetPerimeter(double);
   double GetFirstPointX();
   void SetFirstPointX(double);
   double GetFirstPointY();
   void SetFirstPointY(double);
   double GetMinimumFeretDiameter();
   void SetMinimumFeretDiameter(double);
   double GetMinimumFeretAngle();
   void SetMinimumFeretAngle(double);
   double GetMaximumFeretDiameter();
   void SetMaximumFeretDiameter(double);
   double GetMaximumFeretAngle();
   void SetMaximumFeretAngle(double);
   double GetMeanFeretDiameter();
   void SetMeanFeretDiameter(double);
   double GetFeretElongation();
   void SetFeretElongation(double);
   double GetConvexPerimeter();
   void SetConvexPerimeter(double);
   double GetCompactness();
   void SetCompactness(double);
   long GetNumberOfHoles();
   void SetNumberOfHoles(long);
   IBlobRuns GetRuns();
   IBlobRun GetRuns(long Index);
   void SetRuns(LPDISPATCH);
   double GetRoughness();
   void SetRoughness(double);
   long GetEulerNumber();
   void SetEulerNumber(long);
   double GetLength();
   void SetLength(double);
   double GetBreadth();
   void SetBreadth(double);
   double GetElongation();
   void SetElongation(double);
   long GetIntercept0();
   void SetIntercept0(long);
   long GetIntercept45();
   void SetIntercept45(long);
   long GetIntercept90();
   void SetIntercept90(long);
   long GetIntercept135();
   void SetIntercept135(long);
   double GetSumOfPixelValues();
   void SetSumOfPixelValues(double);
   double GetMinimumPixelValue();
   void SetMinimumPixelValue(double);
   double GetMaximumPixelValue();
   void SetMaximumPixelValue(double);
   double GetMeanPixelValue();
   void SetMeanPixelValue(double);
   double GetSigmaOfPixelValues();
   void SetSigmaOfPixelValues(double);
   double GetSumOfSquaredPixelValues();
   void SetSumOfSquaredPixelValues(double);
   double GetMomentX0Y1();
   void SetMomentX0Y1(double);
   double GetMomentX1Y0();
   void SetMomentX1Y0(double);
   double GetMomentX1Y1();
   void SetMomentX1Y1(double);
   double GetMomentX0Y2();
   void SetMomentX0Y2(double);
   double GetMomentX2Y0();
   void SetMomentX2Y0(double);
   double GetCentralMomentX0Y2();
   void SetCentralMomentX0Y2(double);
   double GetCentralMomentX2Y0();
   void SetCentralMomentX2Y0(double);
   double GetCentralMomentX1Y1();
   void SetCentralMomentX1Y1(double);
   double GetPrincipalAxisAngle();
   void SetPrincipalAxisAngle(double);
   double GetSecondaryAxisAngle();
   void SetSecondaryAxisAngle(double);
   double GetGeneralFeret();
   void SetGeneralFeret(double);
   IBlobChains GetChains();
   IBlobChain GetChains(long Index);
   void SetChains(LPDISPATCH);
   double GetBoxXMaximum();
   void SetBoxXMaximum(double);
   double GetBoxYMaximum();
   void SetBoxYMaximum(double);
   double GetBoxXMinimum();
   void SetBoxXMinimum(double);
   double GetFeretX();
   void SetFeretX(double);
   double GetFeretY();
   void SetFeretY(double);
   double GetBoxYMinimum();
   void SetBoxYMinimum(double);
   double GetCenterOfGravityX();
   void SetCenterOfGravityX(double);
   double GetCenterOfGravityY();
   void SetCenterOfGravityY(double);
   double GetContactPointXMaximumAtYMaximum();
   void SetContactPointXMaximumAtYMaximum(double);
   double GetContactPointXMinimumAtYMinimum();
   void SetContactPointXMinimumAtYMinimum(double);
   double GetContactPointYMinimumAtXMaximum();
   void SetContactPointYMinimumAtXMaximum(double);
   double GetContactPointYMaximumAtXMinimum();
   void SetContactPointYMaximumAtXMinimum(double);
   double GetGeneralMoment();
   void SetGeneralMoment(double);
   double GetMomentX0Y1Grayscale();
   void SetMomentX0Y1Grayscale(double);
   double GetGeneralMomentGrayscale();
   void SetGeneralMomentGrayscale(double);
   double GetCenterOfGravityXGrayscale();
   void SetCenterOfGravityXGrayscale(double);
   double GetCenterOfGravityYGrayscale();
   void SetCenterOfGravityYGrayscale(double);
   double GetMomentX0Y2Grayscale();
   void SetMomentX0Y2Grayscale(double);
   double GetMomentX1Y0Grayscale();
   void SetMomentX1Y0Grayscale(double);
   double GetMomentX1Y1Grayscale();
   void SetMomentX1Y1Grayscale(double);
   double GetMomentX2Y0Grayscale();
   void SetMomentX2Y0Grayscale(double);
   double GetPrincipalAxisAngleGrayscale();
   void SetPrincipalAxisAngleGrayscale(double);
   double GetSecondaryAxisAngleGrayscale();
   void SetSecondaryAxisAngleGrayscale(double);
   double GetCentralMomentX0Y2Grayscale();
   void SetCentralMomentX0Y2Grayscale(double);
   double GetCentralMomentX1Y1Grayscale();
   void SetCentralMomentX1Y1Grayscale(double);
   double GetCentralMomentX2Y0Grayscale();
   void SetCentralMomentX2Y0Grayscale(double);

// Operations
public:
};

#endif // __ACTIVEMIL_BLOBRESULT_CPLUSPLUS
