///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Calibration Points C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_CALIBRATIONPOINTS_CPLUSPLUS)
#define __ACTIVEMIL_CALIBRATIONPOINTS_CPLUSPLUS


// Dispatch interfaces referenced by this interface
class ICalibrationPoint;

/////////////////////////////////////////////////////////////////////////////
// ICalibrationPoints wrapper class

class ICalibrationPoints : public COleDispatchDriver
{
public:
	ICalibrationPoints() {}		// Calls COleDispatchDriver default constructor
	ICalibrationPoints(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ICalibrationPoints(const ICalibrationPoints& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);

// Operations
public:
	ICalibrationPoint Item(long Index);
	long Add(double PixelX = 0, double PixelY = 0, double WorldX = 0, double WorldY = 0);
	void Remove(long Index);
	void RemoveAll();
};

#endif // __ACTIVEMIL_CALIBRATIONPOINTS_CPLUSPLUS
