///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Image C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_CHARACTERRECOGNITION_CPLUSPLUS)
#define __ACTIVEMIL_CHARACTERRECOGNITION_CPLUSPLUS

#if !defined(ACTIVEMIL_IN_PROJECT)
#error ActiveMIL support has not been added to this project.  Make sure that the "Matrox ActiveMIL VC++ Add-In" is enabled, and that "Add ActiveMIL To Project" has been called from the add-in's toolbar.
#endif

#if defined(ACTIVEMIL_USE_COM_CLASS)

   #pragma warning(push)
   #pragma warning(disable : 4146)
   #import "MILCharacterRecognition.OCX" no_namespace
   #pragma warning(pop)


   /////////////////////////////////////////////////////////////////////////////
   // CCharacterRecognition wrapper class

   class CCharacterRecognition : public CWnd, public ICharacterRecognitionPtr
   {
      virtual void PreSubclassWindow()
         {
         ICharacterRecognition* pOCR ;
         CWnd::GetControlUnknown()->QueryInterface(__uuidof(ICharacterRecognition), (void**) &pOCR) ;
         ICharacterRecognitionPtr::Attach(pOCR, false) ;
         }
   };

#else // !ACTIVEMIL_USE_COM_CLASS

   // Include enumerated types
   #include "ActiveMILCharacterRecognitionTypes.h"

   // Dispatch interfaces referenced by this interface
   #include "System.h"
   #include "Image.h"
   #include "RegionOfInterest.h"
   #include "OCRConstraint.h"
   #include "OCRConstraints.h"
   #include "OCRTargetCharacter.h"
   #include "OCRCharacterMetrics.h"
   #include "OCRFont.h"
   #include "OCRResultCharacter.h"
   #include "OCRResultCharacters.h"
   #include "OCRResults.h"

   /////////////////////////////////////////////////////////////////////////////
   // CCharacterRecognition wrapper class

   class CCharacterRecognition : public CWnd
   {
      CString m_strName;

   protected:
      DECLARE_DYNCREATE(CCharacterRecognition)
   public:
      CLSID const& GetClsid()
      {
         static CLSID const clsid
            = { 0xa0eeec96, 0xa7d2, 0x11d1, { 0x9f, 0xc, 0x0, 0x60, 0x8c, 0xc9, 0xf9, 0xfb } };
         return clsid;
      }
      virtual BOOL Create(LPCTSTR lpszClassName,
         LPCTSTR lpszWindowName, DWORD dwStyle,
         const RECT& rect,
         CWnd* pParentWnd, UINT nID,
         CCreateContext* pContext = NULL)
      { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

      BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
         const RECT& rect, CWnd* pParentWnd, UINT nID,
         CFile* pPersist = NULL, BOOL bStorage = FALSE,
         BSTR bstrLicKey = NULL)
      { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
         pPersist, bStorage, bstrLicKey); }

   // Attributes
   public:
      CString GetName();
      void SetName(LPCTSTR);
      BOOL GetAutomaticAllocation();
      void SetAutomaticAllocation(BOOL);
      BOOL GetPropertyValidation();
      void SetPropertyValidation(BOOL);
      BOOL GetIsAllocated();
      void SetIsAllocated(BOOL);
      long GetStringType();
      void SetStringType(long);
      long GetMaximumStringLength();
      void SetMaximumStringLength(long);
      long GetForegroundPixelValue();
      void SetForegroundPixelValue(long);
      double GetAcceptanceThreshold();
      void SetAcceptanceThreshold(double);
      long GetSpeed();
      void SetSpeed(long);
      BOOL GetContrastEnhancement();
      void SetContrastEnhancement(BOOL);
      BOOL GetStringLocation();
      void SetStringLocation(BOOL);
      IOCRResults GetResults();
      void SetResults(LPDISPATCH);
      BOOL GetValidateStringEvent();
      void SetValidateStringEvent(BOOL);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
      ISystem GetOwnerSystem();
      void SetOwnerSystem(LPCTSTR lpszNewValue);
      IImage GetImage();
      void SetImage(LPCTSTR lpszNewValue);
      IRegionOfInterest GetSearchRegion();
      void SetSearchRegion(LPCTSTR lpszNewValue);
      IOCRTargetCharacter GetTargetCharacter();
      void SetTargetCharacter(LPCTSTR lpszNewValue);
      IOCRFont GetFont();
      void SetFont(LPCTSTR lpszNewValue);
      IOCRConstraints GetConstraints();
      IOCRConstraint GetConstraint(long Index);
      void SetConstraints(LPCTSTR lpszNewValue);
      void Allocate();
      void Free();
      VARIANT Inquire(long ParamToInquire);
      void Control(long ControlType, const VARIANT& ControlValue);
      void Modified(long ModificationType = 0);
      void ReadString(long NumberOfCharacters = 0);
      void VerifyString(LPCTSTR ExpectedString);
      void CalibrateFont(LPCTSTR SampleString, double MinimumSizeX, double MaximumSizeX, double StepX, double MinimumSizeY, double MaximumSizeY, double StepY);
      void Load(LPCTSTR FileName);
      void Save(LPCTSTR FileName);
      void AboutBox();
   };


   /////////////////////////////////////////////////////////////////////////////
   // ICharacterRecognition wrapper class

   class ICharacterRecognition : public COleDispatchDriver
   {
      CString m_strName;

   public:
	   ICharacterRecognition() {}		// Calls COleDispatchDriver default constructor
	   ICharacterRecognition(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	   ICharacterRecognition(const ICharacterRecognition& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

     static ICharacterRecognition NewInstance();

   // Attributes
   public:
     CString GetName();
     void SetName(LPCTSTR);
     BOOL GetAutomaticAllocation();
     void SetAutomaticAllocation(BOOL);
     BOOL GetPropertyValidation();
     void SetPropertyValidation(BOOL);
     BOOL GetIsAllocated();
     void SetIsAllocated(BOOL);
     long GetStringType();
     void SetStringType(long);
     long GetMaximumStringLength();
     void SetMaximumStringLength(long);
     long GetForegroundPixelValue();
     void SetForegroundPixelValue(long);
     double GetAcceptanceThreshold();
     void SetAcceptanceThreshold(double);
     long GetSpeed();
     void SetSpeed(long);
     BOOL GetContrastEnhancement();
     void SetContrastEnhancement(BOOL);
     BOOL GetStringLocation();
     void SetStringLocation(BOOL);
     IOCRResults GetResults();
     void SetResults(LPDISPATCH);
     BOOL GetValidateStringEvent();
     void SetValidateStringEvent(BOOL);

     // Default property
     operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
     ISystem GetOwnerSystem();
     void SetOwnerSystem(LPCTSTR lpszNewValue);
     IImage GetImage();
     void SetImage(LPCTSTR lpszNewValue);
     IRegionOfInterest GetSearchRegion();
     void SetSearchRegion(LPCTSTR lpszNewValue);
     IOCRTargetCharacter GetTargetCharacter();
     void SetTargetCharacter(LPCTSTR lpszNewValue);
     IOCRFont GetFont();
     void SetFont(LPCTSTR lpszNewValue);
     IOCRConstraints GetConstraints();
     IOCRConstraint GetConstraint(long Index);
     void SetConstraints(LPCTSTR lpszNewValue);
     void Allocate();
     void Free();
     VARIANT Inquire(long ParamToInquire);
     void Control(long ControlType, const VARIANT& ControlValue);
     void Modified(long ModificationType = 0);
     void ReadString(long NumberOfCharacters = 0);
     void VerifyString(LPCTSTR ExpectedString);
     void CalibrateFont(LPCTSTR SampleString, double MinimumSizeX, double MaximumSizeX, double StepX, double MinimumSizeY, double MaximumSizeY, double StepY);
     void Load(LPCTSTR FileName);
     void Save(LPCTSTR FileName);
     void AboutBox();
   };

#endif // ACTIVEMIL_USE_COM_CLASS

#endif // __ACTIVEMIL_CHARACTERRECOGNITION_CPLUSPLUS
