///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Digitizer C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_DIGITIZER_CPLUSPLUS)
#define __ACTIVEMIL_DIGITIZER_CPLUSPLUS

#if !defined(ACTIVEMIL_IN_PROJECT)
#error ActiveMIL support has not been added to this project.  Make sure that the "Matrox ActiveMIL VC++ Add-In" is enabled, and that "Add ActiveMIL To Project" has been called from the add-in's toolbar.
#endif

#if defined(ACTIVEMIL_USE_COM_CLASS)

   #pragma warning(push)
   #pragma warning(disable : 4146)
   #import "MIL.OCX" no_namespace
   #pragma warning(pop)


   /////////////////////////////////////////////////////////////////////////////
   // CDigitizer wrapper class

   class CDigitizer : public CWnd, public IDigitizerPtr
   {
      virtual void PreSubclassWindow()
         {
         IDigitizer* pDig ;
         CWnd::GetControlUnknown()->QueryInterface(__uuidof(IDigitizer), (void**) &pDig) ;
         IDigitizerPtr::Attach(pDig, false) ;
         }
   };

#else // !ACTIVEMIL_USE_COM_CLASS

   // Include enumerated types
   #include "ActiveMILBaseTypes.h"

   // Dispatch interfaces referenced by this interface
   #include "System.h"
   #include "Image.h"
   #include "LUT.h"
   #include "RegionOfInterest.h"
   #include "FocusParameters.h"
   #include "SerialPort.h"

   /////////////////////////////////////////////////////////////////////////////
   // CDigitizer wrapper class

   class CDigitizer : public CWnd
   {
      CString m_strName;

   protected:
	   DECLARE_DYNCREATE(CDigitizer)
   public:
	   CLSID const& GetClsid()
	   {
		   static CLSID const clsid
			   = { 0xb9475b93, 0x8f25, 0x11d0, { 0x91, 0x4b, 0x0, 0xa0, 0x24, 0xd2, 0x49, 0x92 } };
		   return clsid;
	   }
	   virtual BOOL Create(LPCTSTR lpszClassName,
		   LPCTSTR lpszWindowName, DWORD dwStyle,
		   const RECT& rect,
		   CWnd* pParentWnd, UINT nID,
		   CCreateContext* pContext = NULL)
      {  m_strName.LockBuffer();
         return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

       BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		   const RECT& rect, CWnd* pParentWnd, UINT nID,
		   CFile* pPersist = NULL, BOOL bStorage = FALSE,
		   BSTR bstrLicKey = NULL)
      {  m_strName.LockBuffer();
         return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		      pPersist, bStorage, bstrLicKey); }

   // Attributes
   public:
	   long GetDeviceNumber();
	   void SetDeviceNumber(long);
	   long GetInitializationFlag();
	   void SetInitializationFlag(long);
	   BOOL GetGrabFrameStartEvent();
	   void SetGrabFrameStartEvent(BOOL);
	   BOOL GetGrabEndEvent();
	   void SetGrabEndEvent(BOOL);
	   BOOL GetGrabStartEvent();
	   void SetGrabStartEvent(BOOL);
	   BOOL GetGrabFrameEndEvent();
	   void SetGrabFrameEndEvent(BOOL);
	   BOOL GetGrabFieldEndEvent();
	   void SetGrabFieldEndEvent(BOOL);
	   BOOL GetGrabFieldEndOddEvent();
	   void SetGrabFieldEndOddEvent(BOOL);
	   BOOL GetGrabFieldEndEvenEvent();
	   void SetGrabFieldEndEvenEvent(BOOL);
	   BOOL GetFrameStartEvent();
	   void SetFrameStartEvent(BOOL);
	   BOOL GetFieldStartEvent();
	   void SetFieldStartEvent(BOOL);
	   BOOL GetFieldStartOddEvent();
	   void SetFieldStartOddEvent(BOOL);
	   BOOL GetFieldStartEvenEvent();
	   void SetFieldStartEvenEvent(BOOL);
	   double GetScaleX();
	   void SetScaleX(double);
	   double GetScaleY();
	   void SetScaleY(double);
	   long GetGrabFieldNumber();
	   void SetGrabFieldNumber(long);
	   BOOL GetGrabHaltOnNextField();
	   void SetGrabHaltOnNextField(BOOL);
	   long GetTriggerSource();
	   void SetTriggerSource(long);
	   BOOL GetUserBit0();
	   void SetUserBit0(BOOL);
	   BOOL GetUserBit2();
	   void SetUserBit2(BOOL);
	   BOOL GetUserBit3();
	   void SetUserBit3(BOOL);
	   BOOL GetUserBit4();
	   void SetUserBit4(BOOL);
	   BOOL GetUserBit5();
	   void SetUserBit5(BOOL);
	   BOOL GetUserBit6();
	   void SetUserBit6(BOOL);
	   BOOL GetUserBit7();
	   void SetUserBit7(BOOL);
	   BOOL GetUserBit8();
	   void SetUserBit8(BOOL);
	   BOOL GetTriggerEnabled();
	   void SetTriggerEnabled(BOOL);
	   long GetGrabStartMode();
	   void SetGrabStartMode(long);
	   long GetGrabMode();
	   void SetGrabMode(long);
	   BOOL GetUserBit1();
	   void SetUserBit1(BOOL);
	   long GetTriggerMode();
	   void SetTriggerMode(long);
	   long GetInputGain();
	   void SetInputGain(long);
	   BOOL GetExposure1Enabled();
	   void SetExposure1Enabled(BOOL);
	   long GetExposure1Source();
	   void SetExposure1Source(long);
	   BOOL GetExposureBypass();
	   void SetExposureBypass(BOOL);
	   long GetUserInFormat();
	   void SetUserInFormat(long);
	   long GetUserOutFormat();
	   void SetUserOutFormat(long);
	   long GetLUTPalette();
	   void SetLUTPalette(long);
	   BOOL GetInputTypeVCR();
	   void SetInputTypeVCR(BOOL);
	   BOOL GetExternalChrominance();
	   void SetExternalChrominance(BOOL);
	   long GetExposure1Mode();
	   void SetExposure1Mode(long);
	   long GetBlackReference();
	   void SetBlackReference(long);
	   long GetWhiteReference();
	   void SetWhiteReference(long);
	   long GetBrightness();
	   void SetBrightness(long);
	   long GetContrast();
	   void SetContrast(long);
	   long GetHue();
	   void SetHue(long);
	   long GetSaturation();
	   void SetSaturation(long);
	   long GetSoundVolume();
	   void SetSoundVolume(long);
	   long GetSoundBass();
	   void SetSoundBass(long);
	   long GetSoundTreble();
	   void SetSoundTreble(long);
	   long GetSoundType();
	   void SetSoundType(long);
	   BOOL GetExposure2Enabled();
	   void SetExposure2Enabled(BOOL);
	   long GetExposure2Mode();
	   void SetExposure2Mode(long);
	   long GetExposure2Source();
	   void SetExposure2Source(long);
	   double GetExposure1Time();
	   void SetExposure1Time(double);
	   double GetExposure2Time();
	   void SetExposure2Time(double);
	   double GetExposure2TimeDelay();
	   void SetExposure2TimeDelay(double);
	   double GetExposure1TimeDelay();
	   void SetExposure1TimeDelay(double);
	   BOOL GetGrabInProgress();
	   void SetGrabInProgress(BOOL);
	   long GetSizeX();
	   void SetSizeX(long);
	   long GetSizeY();
	   void SetSizeY(long);
	   long GetNumberOfBands();
	   void SetNumberOfBands(long);
	   long GetDataDepth();
	   void SetDataDepth(long);
	   long GetDataType();
	   void SetDataType(long);
	   long GetColorMode();
	   void SetColorMode(long);
	   long GetScanMode();
	   void SetScanMode(long);
	   long GetInputMode();
	   void SetInputMode(long);
	   long GetInputSignalSource();
	   void SetInputSignalSource(long);
	   BOOL GetInputSignalPresent();
	   void SetInputSignalPresent(BOOL);
	   long GetSignalChannel();
	   void SetSignalChannel(long);
	   long GetSyncChannel();
	   void SetSyncChannel(long);
	   long GetTunerChannel();
	   void SetTunerChannel(long);
	   long GetTunerBand();
	   void SetTunerBand(long);
	   BOOL GetGrabReservedColors();
	   void SetGrabReservedColors(BOOL);
	   long GetGrabTimeout();
	   void SetGrabTimeout(long);
	   long GetGrabFailCheck();
	   void SetGrabFailCheck(long);
	   long GetGrabFailRetryNumber();
	   void SetGrabFailRetryNumber(long);
	   long GetMilID();
	   void SetMilID(long);
	   long GetChannel();
	   void SetChannel(long);
	   BOOL GetAutomaticAllocation();
	   void SetAutomaticAllocation(BOOL);
	   BOOL GetPropertyValidation();
	   void SetPropertyValidation(BOOL);
	   CString GetFormat();
	   void SetFormat(LPCTSTR);
	   CString GetName();
	   void SetName(LPCTSTR);
	   long GetReferenceChannel();
	   void SetReferenceChannel(long);
	   long GetGrabFrameNumber();
	   void SetGrabFrameNumber(long);
	   BOOL GetIsAllocated();
	   void SetIsAllocated(BOOL);
	   long GetGrabDirectionX();
	   void SetGrabDirectionX(long);
	   long GetGrabDirectionY();
	   void SetGrabDirectionY(long);
	   BOOL GetLUTEnabled();
	   void SetLUTEnabled(BOOL);
	   BOOL GetAutomaticInputGain();
	   void SetAutomaticInputGain(BOOL);
	   BOOL GetSerialPortDataEvent();
	   void SetSerialPortDataEvent(BOOL);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
	   ISystem GetOwnerSystem();
	   void SetOwnerSystem(LPCTSTR lpszNewValue);
	   ILUT GetLUT();
	   void SetLUT(LPCTSTR lpszNewValue);
	   IDispatch* GetCalibration();
	   void SetCalibration(LPCTSTR lpszNewValue);
	   IRegionOfInterest GetInputRegion();
	   void SetInputRegion(LPCTSTR lpszNewValue);
	   void Control(long ControlType, const VARIANT& Value);
	   void Grab();
	   void GrabContinuous();
	   void GrabWait(long Flag);
	   void Halt();
	   VARIANT Inquire(long ParamToInquire);
	   void Allocate();
	   void Free();
	   void Modified(long ModificationType = 0);
	   void SendTrigger(long SoftwareTriggerType = digGrabTrigger);
	   IImage GetImage();
	   void SetImage(LPCTSTR lpszNewValue);
	   IFocusParameters GetFocusParameters();
	   void SetFocusParameters(LPCTSTR lpszNewValue);
	   long Focus(long ProcessingMode = digSmartScan, BOOL AutoGrab = TRUE, BOOL Subsample = TRUE, BOOL Filter = TRUE);
	   ISerialPort GetSerialPort();
	   void SetSerialPort(LPCTSTR lpszNewValue);
	   void AboutBox();
   };


   /////////////////////////////////////////////////////////////////////////////
   // IDigitizer wrapper class

   class IDigitizer : public COleDispatchDriver
   {
      CString m_strName;

   public:
	   IDigitizer() { m_strName.LockBuffer(); } 		// Calls COleDispatchDriver default constructor
	   IDigitizer(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) { m_strName.LockBuffer(); }
	   IDigitizer(const IDigitizer& dispatchSrc) : COleDispatchDriver(dispatchSrc) { m_strName.LockBuffer(); }

     static IDigitizer NewInstance();

   // Attributes
   public:
	   long GetDeviceNumber();
	   void SetDeviceNumber(long);
	   long GetInitializationFlag();
	   void SetInitializationFlag(long);
	   BOOL GetGrabFrameStartEvent();
	   void SetGrabFrameStartEvent(BOOL);
	   BOOL GetGrabEndEvent();
	   void SetGrabEndEvent(BOOL);
	   BOOL GetGrabStartEvent();
	   void SetGrabStartEvent(BOOL);
	   BOOL GetGrabFrameEndEvent();
	   void SetGrabFrameEndEvent(BOOL);
	   BOOL GetGrabFieldEndEvent();
	   void SetGrabFieldEndEvent(BOOL);
	   BOOL GetGrabFieldEndOddEvent();
	   void SetGrabFieldEndOddEvent(BOOL);
	   BOOL GetGrabFieldEndEvenEvent();
	   void SetGrabFieldEndEvenEvent(BOOL);
	   BOOL GetFrameStartEvent();
	   void SetFrameStartEvent(BOOL);
	   BOOL GetFieldStartEvent();
	   void SetFieldStartEvent(BOOL);
	   BOOL GetFieldStartOddEvent();
	   void SetFieldStartOddEvent(BOOL);
	   BOOL GetFieldStartEvenEvent();
	   void SetFieldStartEvenEvent(BOOL);
	   double GetScaleX();
	   void SetScaleX(double);
	   double GetScaleY();
	   void SetScaleY(double);
	   long GetGrabFieldNumber();
	   void SetGrabFieldNumber(long);
	   BOOL GetGrabHaltOnNextField();
	   void SetGrabHaltOnNextField(BOOL);
	   long GetTriggerSource();
	   void SetTriggerSource(long);
	   BOOL GetUserBit0();
	   void SetUserBit0(BOOL);
	   BOOL GetUserBit2();
	   void SetUserBit2(BOOL);
	   BOOL GetUserBit3();
	   void SetUserBit3(BOOL);
	   BOOL GetUserBit4();
	   void SetUserBit4(BOOL);
	   BOOL GetUserBit5();
	   void SetUserBit5(BOOL);
	   BOOL GetUserBit6();
	   void SetUserBit6(BOOL);
	   BOOL GetUserBit7();
	   void SetUserBit7(BOOL);
	   BOOL GetUserBit8();
	   void SetUserBit8(BOOL);
	   BOOL GetTriggerEnabled();
	   void SetTriggerEnabled(BOOL);
	   long GetGrabStartMode();
	   void SetGrabStartMode(long);
	   long GetGrabMode();
	   void SetGrabMode(long);
	   BOOL GetUserBit1();
	   void SetUserBit1(BOOL);
	   long GetTriggerMode();
	   void SetTriggerMode(long);
	   long GetInputGain();
	   void SetInputGain(long);
	   BOOL GetExposure1Enabled();
	   void SetExposure1Enabled(BOOL);
	   long GetExposure1Source();
	   void SetExposure1Source(long);
	   BOOL GetExposureBypass();
	   void SetExposureBypass(BOOL);
	   long GetUserInFormat();
	   void SetUserInFormat(long);
	   long GetUserOutFormat();
	   void SetUserOutFormat(long);
	   long GetLUTPalette();
	   void SetLUTPalette(long);
	   BOOL GetInputTypeVCR();
	   void SetInputTypeVCR(BOOL);
	   BOOL GetExternalChrominance();
	   void SetExternalChrominance(BOOL);
	   long GetExposure1Mode();
	   void SetExposure1Mode(long);
	   long GetBlackReference();
	   void SetBlackReference(long);
	   long GetWhiteReference();
	   void SetWhiteReference(long);
	   long GetBrightness();
	   void SetBrightness(long);
	   long GetContrast();
	   void SetContrast(long);
	   long GetHue();
	   void SetHue(long);
	   long GetSaturation();
	   void SetSaturation(long);
	   long GetSoundVolume();
	   void SetSoundVolume(long);
	   long GetSoundBass();
	   void SetSoundBass(long);
	   long GetSoundTreble();
	   void SetSoundTreble(long);
	   long GetSoundType();
	   void SetSoundType(long);
	   BOOL GetExposure2Enabled();
	   void SetExposure2Enabled(BOOL);
	   long GetExposure2Mode();
	   void SetExposure2Mode(long);
	   long GetExposure2Source();
	   void SetExposure2Source(long);
	   double GetExposure1Time();
	   void SetExposure1Time(double);
	   double GetExposure2Time();
	   void SetExposure2Time(double);
	   double GetExposure2TimeDelay();
	   void SetExposure2TimeDelay(double);
	   double GetExposure1TimeDelay();
	   void SetExposure1TimeDelay(double);
	   BOOL GetGrabInProgress();
	   void SetGrabInProgress(BOOL);
	   long GetSizeX();
	   void SetSizeX(long);
	   long GetSizeY();
	   void SetSizeY(long);
	   long GetNumberOfBands();
	   void SetNumberOfBands(long);
	   long GetDataDepth();
	   void SetDataDepth(long);
	   long GetDataType();
	   void SetDataType(long);
	   long GetColorMode();
	   void SetColorMode(long);
	   long GetScanMode();
	   void SetScanMode(long);
	   long GetInputMode();
	   void SetInputMode(long);
	   long GetInputSignalSource();
	   void SetInputSignalSource(long);
	   BOOL GetInputSignalPresent();
	   void SetInputSignalPresent(BOOL);
	   long GetSignalChannel();
	   void SetSignalChannel(long);
	   long GetSyncChannel();
	   void SetSyncChannel(long);
	   long GetTunerChannel();
	   void SetTunerChannel(long);
	   long GetTunerBand();
	   void SetTunerBand(long);
	   BOOL GetGrabReservedColors();
	   void SetGrabReservedColors(BOOL);
	   long GetGrabTimeout();
	   void SetGrabTimeout(long);
	   long GetGrabFailCheck();
	   void SetGrabFailCheck(long);
	   long GetGrabFailRetryNumber();
	   void SetGrabFailRetryNumber(long);
	   long GetMilID();
	   void SetMilID(long);
	   long GetChannel();
	   void SetChannel(long);
	   BOOL GetAutomaticAllocation();
	   void SetAutomaticAllocation(BOOL);
	   BOOL GetPropertyValidation();
	   void SetPropertyValidation(BOOL);
	   CString GetFormat();
	   void SetFormat(LPCTSTR);
	   CString GetName();
	   void SetName(LPCTSTR);
	   long GetReferenceChannel();
	   void SetReferenceChannel(long);
	   long GetGrabFrameNumber();
	   void SetGrabFrameNumber(long);
	   BOOL GetIsAllocated();
	   void SetIsAllocated(BOOL);
	   long GetGrabDirectionX();
	   void SetGrabDirectionX(long);
	   long GetGrabDirectionY();
	   void SetGrabDirectionY(long);
	   BOOL GetLUTEnabled();
	   void SetLUTEnabled(BOOL);
	   BOOL GetAutomaticInputGain();
	   void SetAutomaticInputGain(BOOL);
	   BOOL GetSerialPortDataEvent();
	   void SetSerialPortDataEvent(BOOL);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
	   ISystem GetOwnerSystem();
	   void SetOwnerSystem(LPCTSTR lpszNewValue);
	   ILUT GetLUT();
	   void SetLUT(LPCTSTR lpszNewValue);
	   IDispatch* GetCalibration();
	   void SetCalibration(LPCTSTR lpszNewValue);
	   IRegionOfInterest GetInputRegion();
	   void SetInputRegion(LPCTSTR lpszNewValue);
	   void Control(long ControlType, const VARIANT& Value);
	   void Grab();
	   void GrabContinuous();
	   void GrabWait(long Flag);
	   void Halt();
	   VARIANT Inquire(long ParamToInquire);
	   void Allocate();
	   void Free();
	   void Modified(long ModificationType = 0);
	   void SendTrigger(long SoftwareTriggerType = digGrabTrigger);
	   IImage GetImage();
	   void SetImage(LPCTSTR lpszNewValue);
	   IFocusParameters GetFocusParameters();
	   void SetFocusParameters(LPCTSTR lpszNewValue);
	   long Focus(long ProcessingMode = digSmartScan, BOOL AutoGrab = TRUE, BOOL Subsample = TRUE, BOOL Filter = TRUE);
	   ISerialPort GetSerialPort();
	   void SetSerialPort(LPCTSTR lpszNewValue);
	   void AboutBox();
   };

#endif // ACTIVEMIL_USE_COM_CLASS

#endif // __ACTIVEMIL_DIGITIZER_CPLUSPLUS
