///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Display C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_DISPLAY_CPLUSPLUS)
#define __ACTIVEMIL_DISPLAY_CPLUSPLUS

#if !defined(ACTIVEMIL_IN_PROJECT)
#error ActiveMIL support has not been added to this project.  Make sure that the "Matrox ActiveMIL VC++ Add-In" is enabled, and that "Add ActiveMIL To Project" has been called from the add-in's toolbar.
#endif

#if defined(ACTIVEMIL_USE_COM_CLASS)

   #pragma warning(push)
   #pragma warning(disable : 4146)
   #import "MIL.OCX" no_namespace
   #pragma warning(pop)


   /////////////////////////////////////////////////////////////////////////////
   // CDisplay wrapper class

   class CDisplay : public CWnd, public IDisplayPtr
   {
      virtual void PreSubclassWindow()
         {
         IDisplay* pDisp ;
         CWnd::GetControlUnknown()->QueryInterface(__uuidof(IDisplay), (void**) &pDisp) ;
         IDisplayPtr::Attach(pDisp, false) ;
         }
   };

#else // !ACTIVEMIL_USE_COM_CLASS

   // Include enumerated types
   #include "ActiveMILBaseTypes.h"

   // Dispatch interfaces referenced by this interface
   #include "System.h"
   #include "Image.h"
   #include "LUT.h"
   #include "ExternalWindow.h"

   /////////////////////////////////////////////////////////////////////////////
   // CDisplay wrapper class

   class CDisplay : public CWnd
   {
       CString m_strName;

   protected:
	   DECLARE_DYNCREATE(CDisplay)
   public:
	   CLSID const& GetClsid()
	   {
		   static CLSID const clsid
			   = { 0xe9502373, 0x9624, 0x11d0, { 0xbd, 0xb4, 0x0, 0x60, 0x8c, 0xc9, 0xf9, 0xfb } };
		   return clsid;
	   }
	   virtual BOOL Create(LPCTSTR lpszClassName,
		   LPCTSTR lpszWindowName, DWORD dwStyle,
		   const RECT& rect,
		   CWnd* pParentWnd, UINT nID,
		   CCreateContext* pContext = NULL)
	   { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

       BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		   const RECT& rect, CWnd* pParentWnd, UINT nID,
		   CFile* pPersist = NULL, BOOL bStorage = FALSE,
		   BSTR bstrLicKey = NULL)
	   { return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		   pPersist, bStorage, bstrLicKey); }

   // Attributes
   public:
	   CString GetFormat();
	   void SetFormat(LPCTSTR);
	   BOOL GetOverlapEnabled();
	   void SetOverlapEnabled(BOOL);
	   BOOL GetMoveEnabled();
	   void SetMoveEnabled(BOOL);
	   BOOL GetOverlayDestructive();
	   void SetOverlayDestructive(BOOL);
	   BOOL GetOverlayFlicker();
	   void SetOverlayFlicker(BOOL);
	   BOOL GetOverlayVisible();
	   void SetOverlayVisible(BOOL);
	   BOOL GetPaletteCollapse();
	   void SetPaletteCollapse(BOOL);
	   long GetSnapX();
	   void SetSnapX(long);
	   long GetSnapY();
	   void SetSnapY(long);
	   long GetThreadPriority();
	   void SetThreadPriority(long);
	   BOOL GetUpdateEnabled();
	   void SetUpdateEnabled(BOOL);
	   long GetDesktopSizeX();
	   void SetDesktopSizeX(long);
	   long GetDesktopSizeY();
	   void SetDesktopSizeY(long);
	   long GetSizeX();
	   void SetSizeX(long);
	   long GetSizeY();
	   void SetSizeY(long);
	   BOOL GetResizeEnabled();
	   void SetResizeEnabled(BOOL);
	   BOOL GetAutomaticAllocation();
	   void SetAutomaticAllocation(BOOL);
	   long GetOffsetX();
	   void SetOffsetX(long);
	   long GetOffsetY();
	   void SetOffsetY(long);
	   BOOL GetOverlayKeySupported();
	   void SetOverlayKeySupported(BOOL);
	   long GetPanX();
	   void SetPanX(long);
	   long GetPanY();
	   void SetPanY(long);
	   long GetZoomX();
	   void SetZoomX(long);
	   long GetZoomY();
	   void SetZoomY(long);
	   unsigned long GetOverlayKeyColor();
	   void SetOverlayKeyColor(unsigned long);
	   long GetOverlayKeyCondition();
	   void SetOverlayKeyCondition(long);
	   long GetPaletteMode();
	   void SetPaletteMode(long);
	   BOOL GetOverlayWriting();
	   void SetOverlayWriting(BOOL);
	   BOOL GetFrameStartEvent();
	   void SetFrameStartEvent(BOOL);
	   BOOL GetHardwareZoom();
	   void SetHardwareZoom(BOOL);
	   BOOL GetHardwarePan();
	   void SetHardwarePan(BOOL);
	   long GetDataDepth();
	   void SetDataDepth(long);
	   long GetDataType();
	   void SetDataType(long);
	   BOOL GetDesktopLocked();
	   void SetDesktopLocked(BOOL);
	   long GetDeviceNumber();
	   void SetDeviceNumber(long);
	   BOOL GetDirectWriting();
	   void SetDirectWriting(BOOL);
	   long GetInitializationFlag();
	   void SetInitializationFlag(long);
	   long GetMilID();
	   void SetMilID(long);
	   long GetNumberOfBands();
	   void SetNumberOfBands(long);
	   long GetUserWindow();
	   void SetUserWindow(long);
	   BOOL GetReservedColorsOptimization();
	   void SetReservedColorsOptimization(BOOL);
	   BOOL GetPropertyValidation();
	   void SetPropertyValidation(BOOL);
	   long GetDisplayType();
	   void SetDisplayType(long);
	   CString GetName();
	   void SetName(LPCTSTR);
	   BOOL GetIsAllocated();
	   void SetIsAllocated(BOOL);
	   OLE_HANDLE GetHWnd();
	   void SetHWnd(OLE_HANDLE);
	   OLE_COLOR GetBackColor();
	   void SetBackColor(OLE_COLOR);
	   IImage GetOverlayImage();
	   void SetOverlayImage(LPDISPATCH);
	   IImage GetDirectImage();
	   void SetDirectImage(LPDISPATCH);
	   BOOL GetLUTEnabled();
	   void SetLUTEnabled(BOOL);
	   BOOL GetOverlayLUTEnabled();
	   void SetOverlayLUTEnabled(BOOL);
	   long GetViewMode();
	   void SetViewMode(long);
	   long GetViewBitShift();
	   void SetViewBitShift(long);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
	   IExternalWindow GetExternalWindow();
	   void SetExternalWindow(LPCTSTR lpszNewValue);
	   ISystem GetOwnerSystem();
	   void SetOwnerSystem(LPCTSTR lpszNewValue);
	   ILUT GetLUT();
	   void SetLUT(LPCTSTR lpszNewValue);
	   ILUT GetOverlayLUT();
	   void SetOverlayLUT(LPCTSTR lpszNewValue);
	   void Allocate();
	   void Free();
	   void Update();
	   void Pan(long XOffset, long YOffset);
	   void Control(long ControlType, const VARIANT& ControlValue);
	   VARIANT Inquire(long ParamToInquire);
	   void Modified(long ModificationType = 0);
	   void Zoom(long XFactor, long YFactor, BOOL Incremental = FALSE);
	   IImage GetImage();
	   void SetImage(LPCTSTR lpszNewValue);
	   void AboutBox();
   };


   /////////////////////////////////////////////////////////////////////////////
   // IDisplay wrapper class

   class IDisplay : public COleDispatchDriver
   {
     CString m_strName;

   public:
	   IDisplay() {}		// Calls COleDispatchDriver default constructor
	   IDisplay(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	   IDisplay(const IDisplay& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

     static IDisplay NewInstance();

   // Attributes
   public:
	   CString GetFormat();
	   void SetFormat(LPCTSTR);
	   BOOL GetOverlapEnabled();
	   void SetOverlapEnabled(BOOL);
	   BOOL GetMoveEnabled();
	   void SetMoveEnabled(BOOL);
	   BOOL GetOverlayDestructive();
	   void SetOverlayDestructive(BOOL);
	   BOOL GetOverlayFlicker();
	   void SetOverlayFlicker(BOOL);
	   BOOL GetOverlayVisible();
	   void SetOverlayVisible(BOOL);
	   BOOL GetPaletteCollapse();
	   void SetPaletteCollapse(BOOL);
	   long GetSnapX();
	   void SetSnapX(long);
	   long GetSnapY();
	   void SetSnapY(long);
	   long GetThreadPriority();
	   void SetThreadPriority(long);
	   BOOL GetUpdateEnabled();
	   void SetUpdateEnabled(BOOL);
	   long GetDesktopSizeX();
	   void SetDesktopSizeX(long);
	   long GetDesktopSizeY();
	   void SetDesktopSizeY(long);
	   long GetSizeX();
	   void SetSizeX(long);
	   long GetSizeY();
	   void SetSizeY(long);
	   BOOL GetResizeEnabled();
	   void SetResizeEnabled(BOOL);
	   BOOL GetAutomaticAllocation();
	   void SetAutomaticAllocation(BOOL);
	   long GetOffsetX();
	   void SetOffsetX(long);
	   long GetOffsetY();
	   void SetOffsetY(long);
	   BOOL GetOverlayKeySupported();
	   void SetOverlayKeySupported(BOOL);
	   long GetPanX();
	   void SetPanX(long);
	   long GetPanY();
	   void SetPanY(long);
	   long GetZoomX();
	   void SetZoomX(long);
	   long GetZoomY();
	   void SetZoomY(long);
	   unsigned long GetOverlayKeyColor();
	   void SetOverlayKeyColor(unsigned long);
	   long GetOverlayKeyCondition();
	   void SetOverlayKeyCondition(long);
	   long GetPaletteMode();
	   void SetPaletteMode(long);
	   BOOL GetOverlayWriting();
	   void SetOverlayWriting(BOOL);
	   BOOL GetFrameStartEvent();
	   void SetFrameStartEvent(BOOL);
	   BOOL GetHardwareZoom();
	   void SetHardwareZoom(BOOL);
	   BOOL GetHardwarePan();
	   void SetHardwarePan(BOOL);
	   long GetDataDepth();
	   void SetDataDepth(long);
	   long GetDataType();
	   void SetDataType(long);
	   BOOL GetDesktopLocked();
	   void SetDesktopLocked(BOOL);
	   long GetDeviceNumber();
	   void SetDeviceNumber(long);
	   BOOL GetDirectWriting();
	   void SetDirectWriting(BOOL);
	   long GetInitializationFlag();
	   void SetInitializationFlag(long);
	   long GetMilID();
	   void SetMilID(long);
	   long GetNumberOfBands();
	   void SetNumberOfBands(long);
	   long GetUserWindow();
	   void SetUserWindow(long);
	   BOOL GetReservedColorsOptimization();
	   void SetReservedColorsOptimization(BOOL);
	   BOOL GetPropertyValidation();
	   void SetPropertyValidation(BOOL);
	   long GetDisplayType();
	   void SetDisplayType(long);
	   CString GetName();
	   void SetName(LPCTSTR);
	   BOOL GetIsAllocated();
	   void SetIsAllocated(BOOL);
	   OLE_HANDLE GetHWnd();
	   void SetHWnd(OLE_HANDLE);
	   OLE_COLOR GetBackColor();
	   void SetBackColor(OLE_COLOR);
	   IImage GetOverlayImage();
	   void SetOverlayImage(LPDISPATCH);
	   IImage GetDirectImage();
	   void SetDirectImage(LPDISPATCH);
	   BOOL GetLUTEnabled();
	   void SetLUTEnabled(BOOL);
	   BOOL GetOverlayLUTEnabled();
	   void SetOverlayLUTEnabled(BOOL);
	   long GetViewMode();
	   void SetViewMode(long);
	   long GetViewBitShift();
	   void SetViewBitShift(long);

      // Default property
      operator LPCTSTR() { m_strName.LockBuffer(); m_strName = GetName(); return m_strName; }

   // Operations
   public:
	   IExternalWindow GetExternalWindow();
	   void SetExternalWindow(LPCTSTR lpszNewValue);
	   ISystem GetOwnerSystem();
	   void SetOwnerSystem(LPCTSTR lpszNewValue);
	   ILUT GetLUT();
	   void SetLUT(LPCTSTR lpszNewValue);
	   ILUT GetOverlayLUT();
	   void SetOverlayLUT(LPCTSTR lpszNewValue);
	   void Allocate();
	   void Free();
	   void Update();
	   void Pan(long XOffset, long YOffset);
	   void Control(long ControlType, const VARIANT& ControlValue);
	   VARIANT Inquire(long ParamToInquire);
	   void Modified(long ModificationType = 0);
	   void Zoom(long XFactor, long YFactor, BOOL Incremental = FALSE);
	   IImage GetImage();
	   void SetImage(LPCTSTR lpszNewValue);
	   void AboutBox();
   };

#endif // ACTIVEMIL_USE_COM_CLASS

#endif // __ACTIVEMIL_DISPLAY_CPLUSPLUS
