///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Feature List C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_FEATURELIST_CPLUSPLUS)
#define __ACTIVEMIL_FEATURELIST_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IBlobFeatureGeneralFeret;
class IBlobFeatureGeneralMoment;
class IBlobFeatureBox;
class IBlobFeatureCenterOfGravity;
class IBlobFeatureContactPoints;

/////////////////////////////////////////////////////////////////////////////
// IBlobFeatureList wrapper class

class IBlobFeatureList : public COleDispatchDriver
{
public:
	IBlobFeatureList() {}		// Calls COleDispatchDriver default constructor
	IBlobFeatureList(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IBlobFeatureList(const IBlobFeatureList& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetArea();
	void SetArea(BOOL);
	BOOL GetBreadth();
	void SetBreadth(BOOL);
	BOOL GetChains();
	void SetChains(BOOL);
	BOOL GetCompactness();
	void SetCompactness(BOOL);
	BOOL GetConvexPerimeter();
	void SetConvexPerimeter(BOOL);
	BOOL GetElongation();
	void SetElongation(BOOL);
	BOOL GetEulerNumber();
	void SetEulerNumber(BOOL);
	BOOL GetFeretElongation();
	void SetFeretElongation(BOOL);
	BOOL GetMinimumFeretAngle();
	void SetMinimumFeretAngle(BOOL);
	BOOL GetMaximumFeretAngle();
	void SetMaximumFeretAngle(BOOL);
	BOOL GetMinimumFeretDiameter();
	void SetMinimumFeretDiameter(BOOL);
	BOOL GetMaximumFeretDiameter();
	void SetMaximumFeretDiameter(BOOL);
	BOOL GetMeanFeretDiameter();
	void SetMeanFeretDiameter(BOOL);
	BOOL GetFirstPointX();
	void SetFirstPointX(BOOL);
	BOOL GetFirstPointY();
	void SetFirstPointY(BOOL);
	IBlobFeatureGeneralFeret GetGeneralFeret();
	void SetGeneralFeret(LPDISPATCH);
	IBlobFeatureGeneralMoment GetGeneralMoment();
	void SetGeneralMoment(LPDISPATCH);
	BOOL GetIntercept0();
	void SetIntercept0(BOOL);
	BOOL GetIntercept45();
	void SetIntercept45(BOOL);
	BOOL GetIntercept90();
	void SetIntercept90(BOOL);
	BOOL GetIntercept135();
	void SetIntercept135(BOOL);
	BOOL GetLength();
	void SetLength(BOOL);
	BOOL GetMinimumPixelValue();
	void SetMinimumPixelValue(BOOL);
	BOOL GetMaximumPixelValue();
	void SetMaximumPixelValue(BOOL);
	BOOL GetMeanPixelValue();
	void SetMeanPixelValue(BOOL);
	long GetMomentX0Y1();
	void SetMomentX0Y1(long);
	long GetMomentX1Y0();
	void SetMomentX1Y0(long);
	long GetMomentX1Y1();
	void SetMomentX1Y1(long);
	long GetMomentX0Y2();
	void SetMomentX0Y2(long);
	long GetMomentX2Y0();
	void SetMomentX2Y0(long);
	long GetCentralMomentX0Y2();
	void SetCentralMomentX0Y2(long);
	long GetCentralMomentX2Y0();
	void SetCentralMomentX2Y0(long);
	long GetCentralMomentX1Y1();
	void SetCentralMomentX1Y1(long);
	BOOL GetNumberOfHoles();
	void SetNumberOfHoles(BOOL);
	BOOL GetPerimeter();
	void SetPerimeter(BOOL);
	long GetPrincipalAxisAngle();
	void SetPrincipalAxisAngle(long);
	BOOL GetRoughness();
	void SetRoughness(BOOL);
	BOOL GetRuns();
	void SetRuns(BOOL);
	long GetSecondaryAxisAngle();
	void SetSecondaryAxisAngle(long);
	BOOL GetSigmaOfPixelValues();
	void SetSigmaOfPixelValues(BOOL);
	BOOL GetSumOfPixelValues();
	void SetSumOfPixelValues(BOOL);
	BOOL GetSumOfSquaredPixelValues();
	void SetSumOfSquaredPixelValues(BOOL);
	long GetMilID();
	void SetMilID(long);

// Operations
public:
	IBlobFeatureBox GetBox();
	void SetBox(BOOL bNewValue);
	IBlobFeatureCenterOfGravity GetCenterOfGravity();
	void SetCenterOfGravity(long nNewValue);
	IBlobFeatureContactPoints GetContactPoints();
	void SetContactPoints(BOOL bNewValue);
	void SelectAll();
	void DeselectAll();
};

#endif // __ACTIVEMIL_FEATURELIST_CPLUSPLUS
