///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Filters C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_FILTERS_CPLUSPLUS)
#define __ACTIVEMIL_FILTERS_CPLUSPLUS

// Include enumerated types
#include "ActiveMILBlobAnalysisTypes.h"

// Dispatch interfaces referenced by this interface
class IBlobFilter;

/////////////////////////////////////////////////////////////////////////////
// IBlobFilter wrapper class

class IBlobFilters : public COleDispatchDriver
{
public:
	IBlobFilters() {}		// Calls COleDispatchDriver default constructor
	IBlobFilters(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IBlobFilters(const IBlobFilters& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);

// Operations
public:
	IBlobFilter Item(long Index);
	long Add(long FilterType = blobExclude, long Feature = blobArea, long Condition = blobLessThan, double LowValue = 0, double HighValue = 0);
	void Remove(long Index);
};

#endif // __ACTIVEMIL_FILTERS_CPLUSPLUS
