///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Kernel C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_KERNEL_CPLUSPLUS)
#define __ACTIVEMIL_KERNEL_CPLUSPLUS

/////////////////////////////////////////////////////////////////////////////
// IKernel wrapper class

class IKernel : public COleDispatchDriver
{
public:
	IKernel() {}		// Calls COleDispatchDriver default constructor
	IKernel(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IKernel(const IKernel& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetSizeX();
	void SetSizeX(long);
	long GetSizeY();
	void SetSizeY(long);
	long GetCenterX();
	void SetCenterX(long);
	long GetCenterY();
	void SetCenterY(long);
	BOOL GetAbsoluateValue();
	void SetAbsoluateValue(BOOL);
	BOOL GetSaturation();
	void SetSaturation(BOOL);
	long GetDataType();
	void SetDataType(long);
	long GetDataDepth();
	void SetDataDepth(long);
	double GetNormalizationFactor();
	void SetNormalizationFactor(double);
	long GetMilID();
	void SetMilID(long);
	long GetOverscanType();
	void SetOverscanType(long);
	double GetOverscanValue();
	void SetOverscanValue(double);

// Operations
public:
	double GetData(long X, long Y);
	void SetData(long X, long Y, double newValue);
};

#endif // __ACTIVEMIL_KERNEL_CPLUSPLUS
