///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Kernels C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_KERNELS_CPLUSPLUS)
#define __ACTIVEMIL_KERNELS_CPLUSPLUS

// Include enumerated types
#include "ActiveMILImageProcessingTypes.h"

// Dispatch interfaces referenced by this interface
class IKernel;

/////////////////////////////////////////////////////////////////////////////
// IKernels wrapper class

class IKernels : public COleDispatchDriver
{
public:
	IKernels() {}		// Calls COleDispatchDriver default constructor
	IKernels(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IKernels(const IKernels& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);
	LPUNKNOWN Get_NewEnum();
	void Set_NewEnum(LPUNKNOWN);

// Operations
public:
	IKernel Item(long Index);
	long Add(long DataType = impUnsigned, long DataDepth = 8, long SizeX = 3, long SizeY = 3);
	void Remove(long Index);
};

#endif // __ACTIVEMIL_KERNELS_CPLUSPLUS
