///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// LUT C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_LUT_CPLUSPLUS)
#define __ACTIVEMIL_LUT_CPLUSPLUS

// Include enumerated types
#include "ActiveMILBaseTypes.h"

/////////////////////////////////////////////////////////////////////////////
// ILUT wrapper class

class ILUT : public COleDispatchDriver
{
public:
	ILUT() {}		// Calls COleDispatchDriver default constructor
	ILUT(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ILUT(const ILUT& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetSize();
	void SetSize(long);
	long GetNumberOfBands();
	void SetNumberOfBands(long);
	long GetDataType();
	void SetDataType(long);
	long GetDataDepth();
	void SetDataDepth(long);
	long GetMilID();
	void SetMilID(long);

// Operations
public:
	void GenerateRamp(long StartIndex, double StartValue, long EndIndex, double EndValue);
	void GenerateFunction(long Func, long StartIndex, double StartValueX, long EndIndex, double a = 1.0, double b = 1.0, double c = 0.0);
	void GenerateColor(long StartIndex, long EndIndex, unsigned long Color);
	void Get(const VARIANT& UserArray, long Band = lutAllBands, long Offset = 0.0, long Size = -1.0);
	void Put(const VARIANT& UserArray, long Band, long Offset, long Size);
};

#endif // __ACTIVEMIL_LUT_CPLUSPLUS
