///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Measurement Marker C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_MEASUREMENTMARKER_CPLUSPLUS)
#define __ACTIVEMIL_MEASUREMENTMARKER_CPLUSPLUS


// Dispatch interfaces referenced by this interface
class IMarkerPosition;
class IMarkerPolarity;
class IMarkerValueEdge;
class IMarkerValue;
class IRegionOfInterest2;

/////////////////////////////////////////////////////////////////////////////
// IMeasurementMarker wrapper class

class IMeasurementMarker : public COleDispatchDriver
{
public:
	IMeasurementMarker() {}		// Calls COleDispatchDriver default constructor
	IMeasurementMarker(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IMeasurementMarker(const IMeasurementMarker& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetMarkerType();
	void SetMarkerType(long);
	long GetOrientation();
	void SetOrientation(long);
	double GetEdgeThreshold();
	void SetEdgeThreshold(double);
	long GetMilID();
	void SetMilID(long);
	IMarkerPosition GetPosition();
	void SetPosition(LPDISPATCH);
	IMarkerPolarity GetPolarity();
	void SetPolarity(LPDISPATCH);
	IMarkerValueEdge GetContrast();
	void SetContrast(LPDISPATCH);
	IMarkerValueEdge GetEdgeStrength();
	void SetEdgeStrength(LPDISPATCH);
	IMarkerValue GetWidth();
	void SetWidth(LPDISPATCH);
	IMarkerValue GetNumberOfInsideEdges();
	void SetNumberOfInsideEdges(LPDISPATCH);
	IRegionOfInterest2 GetSearchRegion();
	void SetSearchRegion(LPDISPATCH);
	double GetReferenceX();
	void SetReferenceX(double);
	double GetReferenceY();
	void SetReferenceY(double);
	long GetNumberOfOccurrences();
	void SetNumberOfOccurrences(long);
	long GetMinimumNumberOfOccurrences();
	void SetMinimumNumberOfOccurrences(long);
	IMarkerValue GetSpacing();
	void SetSpacing(LPDISPATCH);
	BOOL GetIsFound();
	void SetIsFound(BOOL);

// Operations
public:
	VARIANT Inquire(long ParamToInquire);
	void Control(long ControlType, const VARIANT& ControlValue);
   void Save(LPCTSTR FileName);
};

#endif // __ACTIVEMIL_MEASUREMENTMARKER_CPLUSPLUS
