///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Measurement Result C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_MEASUREMENTRESULT_CPLUSPLUS)
#define __ACTIVEMIL_MEASUREMENTRESULT_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IMeasurementEdgeResult;

/////////////////////////////////////////////////////////////////////////////
// IMeasurementResult wrapper class

class IMeasurementResult : public COleDispatchDriver
{
public:
	IMeasurementResult() {}		// Calls COleDispatchDriver default constructor
	IMeasurementResult(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IMeasurementResult(const IMeasurementResult& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	double GetPositionX();
	void SetPositionX(double);
	double GetPositionY();
	void SetPositionY(double);
	double GetMaximumPositionX();
	void SetMaximumPositionX(double);
	double GetMaximumPositionY();
	void SetMaximumPositionY(double);
	double GetMinimumPositionX();
	void SetMinimumPositionX(double);
	double GetMinimumPositionY();
	void SetMinimumPositionY(double);
	double GetPositionVariation();
	void SetPositionVariation(double);
	long GetOrientation();
	void SetOrientation(long);
	double GetWidth();
	void SetWidth(double);
	long GetPolarity();
	void SetPolarity(long);
	double GetContrast();
	void SetContrast(double);
	double GetEdgeStrength();
	void SetEdgeStrength(double);
	double GetAngle();
	void SetAngle(double);
	double GetLineEquationSlope();
	void SetLineEquationSlope(double);
	double GetLineEquationIntercept();
	void SetLineEquationIntercept(double);
	double GetScore();
	void SetScore(double);
	double GetLength();
	void SetLength(double);
	double GetEdgeInside();
	void SetEdgeInside(double);
	double GetSpacing();
	void SetSpacing(double);
	double GetWidthVariation();
	void SetWidthVariation(double);
	double GetDistance();
	void SetDistance(double);
	double GetDistanceX();
	void SetDistanceX(double);
	double GetDistanceY();
	void SetDistanceY(double);
	IMeasurementEdgeResult GetEdge1();
	void SetEdge1(LPDISPATCH);
	IMeasurementEdgeResult GetEdge2();
	void SetEdge2(LPDISPATCH);

// Operations
public:
};

#endif // __ACTIVEMIL_MEASUREMENTRESULT_CPLUSPLUS
