///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Measurement Results C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_MEASUREMENTRESULTS_CPLUSPLUS)
#define __ACTIVEMIL_MEASUREMENTRESULTS_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IMeasurementResultEdgeValues;
class IMeasurementResult;

/////////////////////////////////////////////////////////////////////////////
// IMeasurementResults wrapper class

class IMeasurementResults : public COleDispatchDriver
{
public:
	IMeasurementResults() {}		// Calls COleDispatchDriver default constructor
	IMeasurementResults(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IMeasurementResults(const IMeasurementResults& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);
	long GetMilID();
	void SetMilID(long);
	double GetScore();
	void SetScore(double);
	IMeasurementResultEdgeValues GetEdgeValues();
   double GetEdgeValues(long Index);
	void SetEdgeValues(LPDISPATCH);
	LPUNKNOWN Get_NewEnum();
	void Set_NewEnum(LPUNKNOWN);

// Operations
public:
	IMeasurementResult Item(long Index);
	double CalculateMean(long PropertyConstant);
	double CalculateMinimum(long PropertyConstant);
	double CalculateMaximum(long PropertyConstant);
	double CalculateStandardDeviation(long PropertyConstant);
   void Get(long ResultType, const VARIANT& UserArray);
};

#endif // __ACTIVEMIL_MEASUREMENTRESULTS_CPLUSPLUS
