///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Pattern Matching Model C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_PATTERNMATCHINGMODEL_CPLUSPLUS)
#define __ACTIVEMIL_PATTERNMATCHINGMODEL_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IRegionOfInterest;
class IAngle;
class IPatternMatchingSearchAlgorithm;

/////////////////////////////////////////////////////////////////////////////
// IPatternMatchingModel wrapper class

class IPatternMatchingModel : public COleDispatchDriver
{
public:
   IPatternMatchingModel() {}		// Calls COleDispatchDriver default constructor
   IPatternMatchingModel(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
   IPatternMatchingModel(const IPatternMatchingModel& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
   long GetModelType();
   void SetModelType(long);
   long GetSizeX();
   void SetSizeX(long);
   long GetSizeY();
   void SetSizeY(long);
   double GetOriginalPositionX();
   void SetOriginalPositionX(double);
   double GetOriginalPositionY();
   void SetOriginalPositionY(double);
   double GetReferenceX();
   void SetReferenceX(double);
   double GetReferenceY();
   void SetReferenceY(double);
   BOOL GetIsPreprocessed();
   void SetIsPreprocessed(BOOL);
   long GetNumberOfOccurrences();
   void SetNumberOfOccurrences(long);
   long GetPositionAccuracy();
   void SetPositionAccuracy(long);
   long GetSpeed();
   void SetSpeed(long);
   double GetAcceptanceThreshold();
   void SetAcceptanceThreshold(double);
   double GetCertaintyThreshold();
   void SetCertaintyThreshold(double);
   IRegionOfInterest GetSearchRegion();
   void SetSearchRegion(LPDISPATCH);
   IAngle GetSearchAngle();
   void SetSearchAngle(LPDISPATCH);
   IPatternMatchingSearchAlgorithm GetSearchAlgorithm();
   void SetSearchAlgorithm(LPDISPATCH);
   long GetMilID();
   void SetMilID(long);

// Operations
public:
   void Save(LPCTSTR FileName);
   void ExportImage(LPCTSTR DestinationImage);
   void ExportDontCareImage(LPCTSTR DestinationImage, long PixelsValue = 0, BOOL ClearBackground = FALSE);
   void ImportDontCareImage(LPCTSTR SourceImage, long PixelsValue = 0, long OffsetX = 0, long OffsetY = 0);
   VARIANT Inquire(long ParamToInquire);
   void Control(long ControlType, const VARIANT& ControlValue);
   void Preprocess();
};

#endif // __ACTIVEMIL_PATTERNMATCHINGMODEL_CPLUSPLUS
