///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Pattern Matching Models C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_PATTERMATCHINGMODELS_CPLUSPLUS)
#define __ACTIVEMIL_PATTERMATCHINGMODELS_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IPatternMatchingModel;

/////////////////////////////////////////////////////////////////////////////
// IPatternMatchingModels wrapper class

class IPatternMatchingModels : public COleDispatchDriver
{
public:
	IPatternMatchingModels() {}		// Calls COleDispatchDriver default constructor
	IPatternMatchingModels(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IPatternMatchingModels(const IPatternMatchingModels& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);
	// property '_NewEnum' not emitted because of invalid type

// Operations
public:
	IPatternMatchingModel Item(long Index);
	long Add(LPCTSTR SourceImage, long OffsetX, long OffsetY, long SizeX, long SizeY, long NumberOfOccurrences, long ModelType);
	long AddAutomatic(LPCTSTR SourceImage, long SizeX, long SizeY, long PosUncertaintyX, long PosUncertaintyY, long ModelType, long Mode);
	void Remove(long Index);
	long Load(LPCTSTR FileName);
};

#endif // __ACTIVEMIL_PATTERMATCHINGMODELS_CPLUSPLUS
