///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Pattern Matching Search Algorithm C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_PATTERNMATCHINGSEARCHALGORITHM_CPLUSPLUS)
#define __ACTIVEMIL_PATTERNMATCHINGSEARCHALGORITHM_CPLUSPLUS

/////////////////////////////////////////////////////////////////////////////
// IPatternMatchingSearchAlgorithm wrapper class

class IPatternMatchingSearchAlgorithm : public COleDispatchDriver
{
public:
   IPatternMatchingSearchAlgorithm() {}		// Calls COleDispatchDriver default constructor
   IPatternMatchingSearchAlgorithm(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
   IPatternMatchingSearchAlgorithm(const IPatternMatchingSearchAlgorithm& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
   long GetFirstLevel();
   void SetFirstLevel(long);
   long GetLastLevel();
   void SetLastLevel(long);
   long GetFindMode();
   void SetFindMode(long);
   double GetMinimumSpacingX();
   void SetMinimumSpacingX(double);
   double GetMinimumSpacingY();
   void SetMinimumSpacingY(double);
   long GetModelStep();
   void SetModelStep(long);

// Operations
public:
   void Reset();
};

#endif // __ACTIVEMIL_PATTERNMATCHINGSEARCHALGORITHM_CPLUSPLUS
