///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Polar Parameters C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_POLARPARAMETERS_CPLUSPLUS)
#define __ACTIVEMIL_POLARPARAMETERS_CPLUSPLUS

/////////////////////////////////////////////////////////////////////////////
// IPolarParameters wrapper class

class IPolarParameters : public COleDispatchDriver
{
public:
	IPolarParameters() {}		// Calls COleDispatchDriver default constructor
	IPolarParameters(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IPolarParameters(const IPolarParameters& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	double GetCenterX();
	void SetCenterX(double);
	double GetCenterY();
	void SetCenterY(double);
	double GetStartRadius();
	void SetStartRadius(double);
	double GetEndRadius();
	void SetEndRadius(double);
	double GetStartAngle();
	void SetStartAngle(double);
	double GetEndAngle();
	void SetEndAngle(double);

// Operations
public:
	void CalculateRectangularSize(double* SizeX, double* SizeY);
	void CalculatePolarSize(double* AngleSize, double* RadiusSize);
};

#endif // __ACTIVEMIL_POLARPARAMETERS_CPLUSPLUS
