///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Serial Port C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_SERIALPORT_CPLUSPLUS)
#define __ACTIVEMIL_SERIALPORT_CPLUSPLUS

/////////////////////////////////////////////////////////////////////////////
// ISerialPort wrapper class

class ISerialPort : public COleDispatchDriver
{
public:
	ISerialPort() {}		// Calls COleDispatchDriver default constructor
	ISerialPort(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ISerialPort(const ISerialPort& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetParity();
	void SetParity(long);
	long GetStopBits();
	void SetStopBits(long);
	long GetDataLength();
	void SetDataLength(long);
	long GetSpeed();
	void SetSpeed(long);
	long GetTimeout();
	void SetTimeout(long);
	CString GetStringDelimiter();
	void SetStringDelimiter(LPCTSTR);
	BOOL GetDataPending();
	void SetDataPending(BOOL);

// Operations
public:
	CString ReadString(long NumberOfCharacters);
	void WriteString(LPCTSTR OutputString);
};

#endif // __ACTIVEMIL_SERIALPORT_CPLUSPLUS
