///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Structuring Elements C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_STRUCTURINGELEMENTS_CPLUSPLUS)
#define __ACTIVEMIL_STRUCTURINGELEMENTS_CPLUSPLUS

// Include enumerated types
#include "ActiveMILImageProcessingTypes.h"

// Dispatch interfaces referenced by this interface
class IStructuringElement;

/////////////////////////////////////////////////////////////////////////////
// IStructuringElements wrapper class

class IStructuringElements : public COleDispatchDriver
{
public:
	IStructuringElements() {}		// Calls COleDispatchDriver default constructor
	IStructuringElements(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IStructuringElements(const IStructuringElements& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetCount();
	void SetCount(long);
	LPUNKNOWN Get_NewEnum();
	void Set_NewEnum(LPUNKNOWN);

// Operations
public:
	IStructuringElement Item(long Index);
	long Add(long DataType = impSigned, long SizeX = 3, long SizeY = 3);
	void Remove(long Index);
};

#endif // __ACTIVEMIL_STRUCTURINGELEMENTS_CPLUSPLUS
