///////////////////////////////////////////////////////////////////////////////
//
// Matrox Imaging ActiveX Controls
// Warp Parameters C++ Declarations
//
// Matrox Electronics Ltd.
// Copyright 1998
// All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(__ACTIVEMIL_WARPPARAMETERS_CPLUSPLUS)
#define __ACTIVEMIL_WARPPARAMETERS_CPLUSPLUS

// Dispatch interfaces referenced by this interface
class IWarpQuadrilateral;
class IWarpRectangle;
class IWarpLUT;

/////////////////////////////////////////////////////////////////////////////
// IWarpParameters wrapper class

class IWarpParameters : public COleDispatchDriver
{
public:
	IWarpParameters() {}		// Calls COleDispatchDriver default constructor
	IWarpParameters(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IWarpParameters(const IWarpParameters& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	IWarpQuadrilateral GetQuadrilateral();
	void SetQuadrilateral(LPDISPATCH);
	IWarpRectangle GetRectangle();
	void SetRectangle(LPDISPATCH);
	IWarpLUT GetWarpLUT();
	void SetWarpLUT(LPDISPATCH);

// Operations
public:
	void RotateCoefficients(double Angle);
	float GetCoefficients(long X, long Y);
	void SetCoefficients(long X, long Y, float newValue);
	void ResetCoefficients();
	void ScaleCoefficients(double ScaleFactorX, double ScaleFactorY);
	void ShearCoefficients(double ShearingFactorX, double ShearingFactorY);
	void TranslateCoefficients(double DisplacementX, double DisplacementY);
	float Get_Coefficients(long X, long Y);
	void Set_Coefficients(long X, long Y, float newValue);
	void MapQuadrilateralToRectangle();
	void MapRectangleToQuadrilateral();
	void GenerateLUT();
};

#endif // __ACTIVEMIL_WARPPARAMETERS_CPLUSPLUS
