Attribute VB_Name = "HelperFunctions"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Examples Module:
'   This module implements helper functions used in ActiveMIL examples.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' GetSystemPaletteEntries() WIN32 API function declaration
' (taken from win32api.txt) in the VB distribution
Type PALETTEENTRY
        peRed As Byte
        peGreen As Byte
        peBlue As Byte
        peFlags As Byte
End Type
Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long


Public Sub AdjustStepNumber(Example As frmExample)
    
    with example
        ' increment the step counter and write the step number in the frame
        .cmdNext.Tag = .cmdNext.Tag + 1
        .lblStep.Caption = "Step " & .cmdNext.Tag & ":"
    end with
    
End Sub

Public Sub AdjustForm(Example As frmExample)
    Dim MaxDisplayWidth As Long, MaxNextStepWidth As Long
    
    with example
        .Display.Width = .ImageBuffer.SizeX
        .Display.Height = .ImageBuffer.SizeY
        
        MaxDisplayWidth = .Display.Width + (2 * .Display.Left)
        MaxNextStepWidth = .cmdNext.Left + .cmdNext.Width + .lblStep.Left
        
        If MaxNextStepWidth > MaxDisplayWidth Then
            .Width = (MaxNextStepWidth * Screen.TwipsPerPixelX) + 120
        Else
            .Width = (MaxDisplayWidth * Screen.TwipsPerPixelX) + 120
        End If
        
        .Height = 540 + (.Display.Top + .Display.Height) * Screen.TwipsPerPixelY
    end with
    
End Sub

