// MDisplayOverlay example

// ExampleDlg.h : header file
//
//{{AFX_INCLUDES()
#include "Image.h"
#include "Digitizer.h"
#include "Display.h"
#include "System.h"
#include "GraphicContext.h"
//}}AFX_INCLUDES

#if !defined(AFX_EXAMPLEDLG_H_MDisplayOverlay_INCLUDED_)
#define AFX_EXAMPLEDLG_H_MDisplayOverlay_INCLUDED_

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog
//
class CExampleDlg : public CDialog
{
// Construction
public:
	CExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CExampleDlg)
	enum { IDD = IDD_EXAMPLE_DIALOG };
	CString	         m_strCommentText;
	CImage	m_ImageBuffer;
	CDisplay	m_Display;
	CSystem	m_System;
	CDigitizer	m_Digitizer;
	CGraphicContext	m_LeftOverlayGraphicContext;
	CGraphicContext	m_RightOverlayGraphicContext;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
   long m_nStepCount;            // Keeps track of the current example step 
   void AdjustDialog();  // Resizes the dialog to fit any font size and digitizer resolution
   void AdjustStepNumber();      // Increments the step number and updates text in the dialog
   void OverlayDraw();

	// Generated message map functions
	//{{AFX_MSG(CExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnNextbutton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CExampleApp:
// See Example.cpp for the implementation of this class
//
class CExampleApp : public CWinApp
{
public:
   CExampleApp() {};

	//{{AFX_VIRTUAL(CExampleApp)
	inline virtual LRESULT ProcessWndProcException( CException* e, const MSG* pMsg );
	inline virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

};


/////////////////////////////////////////////////////////////////////////////
// CExampleApp initialization
//
BOOL CExampleApp::InitInstance()
{
	AfxEnableControlContainer();

	CExampleDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CExampleApp default exception handling
 
LRESULT CExampleApp::ProcessWndProcException( CException* e, const MSG* pMsg )
{
   e->ReportError() ;
   static_cast<CDialog*>(m_pMainWnd)->EndDialog(IDCANCEL) ;
 
   return 1 ;
}
 
 
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif 
