VERSION 5.00
Object = "{A700DC51-04A2-11D3-BF87-00A024D24992}#2.1#0"; "MIL.ocx"
Begin VB.Form frmExample 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MGrabEvent"
   ClientHeight    =   5832
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   6264
   Icon            =   "MGrabEvent.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   486
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   522
   Begin MIL.Display Display 
      Height          =   4695
      Left            =   120
      TabIndex        =   7
      Top             =   1080
      Width           =   4575
      _Version        =   131073
      _ExtentX        =   8070
      _ExtentY        =   8281
      _StockProps     =   1
      Name            =   "Display"
      OwnerSystem     =   "System"
      Image           =   "ImageBuffer"
      DeviceNumber    =   0
      DisplayType     =   -1
      Format          =   "Default"
      _LUT.Data       =   "MGrabEvent.frx":0442
      _OverlayLUT.Data=   "MGrabEvent.frx":0574
   End
   Begin MIL.Image ImageBuffer 
      Height          =   480
      Left            =   4800
      TabIndex        =   6
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "ImageBuffer"
      AutomaticAllocation=   0   'False
      OwnerSystem     =   "System"
      SizeX           =   -1
      SizeY           =   -1
      NumberOfBands   =   1
      _CanDisplay     =   -1  'True
      _CanGrab        =   -1  'True
      _LUT.Data       =   "MGrabEvent.frx":06A6
   End
   Begin MIL.Digitizer Digitizer 
      Height          =   480
      Left            =   4800
      TabIndex        =   5
      Top             =   2040
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "Digitizer"
      _ScaleX         =   -1  'True
      ScaleX          =   0.5
      _ScaleY         =   -1  'True
      ScaleY          =   0.5
      _GrabMode       =   -1  'True
      GrabMode        =   2
      OwnerSystem     =   "System"
      Image           =   "ImageBuffer"
      Format          =   "Default"
      _LUT.Data       =   "MGrabEvent.frx":07D8
   End
   Begin MIL.System System 
      Height          =   480
      Left            =   4800
      TabIndex        =   4
      Top             =   1560
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "System"
      SystemType      =   "Default"
   End
   Begin MIL.Application Application 
      Height          =   480
      Left            =   4800
      TabIndex        =   3
      Top             =   1080
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "Application"
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "&Next >>"
      Height          =   495
      Left            =   4920
      TabIndex        =   0
      Tag             =   "1"
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label lblComment 
      BorderStyle     =   1  'Fixed Single
      Height          =   600
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   4695
   End
   Begin VB.Label lblStep 
      Caption         =   "Step 1:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmExample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' MGrabEvent
'    This example grabs a sequence of images using an ActiveMIL event handler
'    and plays it back.
'
'    Note: This assume that the copy operation is shorter than a grab
'          and that the PC has sufficient bandwith to support the
'          operations.
'
'   NOTE: Check the history logs to determine which properties were set a
'         design time.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

' Constants.
Const MAX_NUMBER_OF_FRAMES_TO_GRAB = 24 ' Set the number of frames wnated in the sequence

' Globals.
Dim StopPlaybackLoop As Boolean     ' Playback loop termination flag
Dim nFrameCount As Long             ' Frame counter for sequence recording
Dim nGrabStartCount As Long         ' counts the number of GrabStart events
Dim dTime As Double                 ' Time it took to grab the sequence

' Array of images to hold the grabbed sequence.
Dim SequenceImages() As Object

Private Sub Form_Load()
    
    ReDim SequenceImages(MAX_NUMBER_OF_FRAMES_TO_GRAB)
    
    ' Adjust the form and display sizes.
    AdjustForm Me

    ' Step 1: Resize and allocate the ImageBuffer, and start the grab.
    ImageBuffer.SizeX = Digitizer.SizeX * Digitizer.ScaleX
    ImageBuffer.SizeY = Digitizer.SizeY * Digitizer.ScaleY
    ImageBuffer.Allocate
    Digitizer.GrabContinuous
        
    ' Print message.
    lblComment = "This program will record a sequence using ActiveMIL Digitizer events.  " & _
                 "Click Next to continue.  "

End Sub

Private Sub cmdNext_Click()
    
    ' Adjust the step number and associated text.
    AdjustStepNumber Me
    
    Select Case cmdNext.Tag
        
        ' Step 2: Grab the sequence
        Case 2
            ' Stop continuous grab
            Digitizer.Halt
                        
            ' Print message.
            lblComment = "Allocating sequence image...  "
            DoEvents

            ' Allocate all the sequence images.
            Dim i
            For i = 1 To MAX_NUMBER_OF_FRAMES_TO_GRAB
                Set SequenceImages(i) = ImageBuffer.Clone
            Next
            
            ' Set the Digitizer's GrabStartEvent property to enable the
            ' Digitizer_GrabStart handler, which is responsible for the
            ' sequence acquisition
            Digitizer.GrabStartEvent = True
            
            ' Initialize the counters.
            nFrameCount = 1
            nGrabStartCount = -2

            ' Start the sequence grab, which will be continued in the event handlers.
            Digitizer.Image = SequenceImages(nFrameCount)
            Digitizer.Grab
            
            ' Disable the Next button.
            cmdNext.Enabled = False
                        
        ' Step 3: Playback of the sequence
        Case 3
            ' Wait for last grab
            Digitizer.GrabWait mGrabEnd
        
            ' Print statistics before entering playback loop
            lblComment = "Playing the sequence; " & _
                         Str(MAX_NUMBER_OF_FRAMES_TO_GRAB) & " frames grabbed, at a frame rate of " & _
                         Format(MAX_NUMBER_OF_FRAMES_TO_GRAB / dTime, "###0.00") & " frames/sec (" & _
                         Format(1000 * dTime / MAX_NUMBER_OF_FRAMES_TO_GRAB, "###0.00") & " ms/frame).  " & _
                         "Click Next to end. "
                         
            ' Start playback loop
            StopPlaybackLoop = False
            PlaybackLoop

        ' Last Step: End the application
        Case Else
            Unload Me
    End Select
End Sub

Private Sub Digitizer_GrabStart()

    nGrabStartCount = nGrabStartCount + 1

    ' If we are starting, reset the timer
    If nGrabStartCount = 0 Then Application.Timer.Reset
    
    ' Grab the next frame, if we should do this on the frame start
    If nGrabStartCount <= MAX_NUMBER_OF_FRAMES_TO_GRAB Then
         
        ' Set the Digitizer to grab the next frame in the next image in sequence
        Digitizer.Image = SequenceImages(nFrameCount)
        If nGrabStartCount > 0 Then nFrameCount = nFrameCount + 1
        
        ' Start the grab
        Digitizer.Grab
       
        ' Print Status message
        If nGrabStartCount > 0 Then
            lblComment = "Grabbing image " & nFrameCount & " of " & MAX_NUMBER_OF_FRAMES_TO_GRAB & "..."
        Else
            lblComment = "Synchronizing start of sequence..."
        End If
    End If

    ' If we are finished, get the time and re-enable the next button
    If nGrabStartCount = MAX_NUMBER_OF_FRAMES_TO_GRAB Then
    
        ' Get the time it took to grab the sequence
        dTime = Application.Timer.Read
        
        ' Enable the Next button
        cmdNext.Enabled = True
        cmdNext.SetFocus
        
        ' Print message
        lblComment = "Sequence grabbed.  Click Next to play the recorded sequence.  "
    End If

End Sub

Private Sub PlaybackLoop()
    
    ' Local variables.
    Dim dTimeWait As Double
    Dim nFrameNumber As Long
    nFrameNumber = 1
        
    While Not StopPlaybackLoop
        ' Reset timer and copy next image to the display.
        Application.Timer.Reset
        ImageBuffer.Copy SequenceImages(nFrameNumber)
                        
        ' Compute how much time we must still wait for this frame.
        dTimeWait = Application.Timer.Read
        dTimeWait = dTime / MAX_NUMBER_OF_FRAMES_TO_GRAB - dTimeWait
                
        ' Wait for remaining time.
        Application.Timer.Wait dTimeWait
        
        ' Adjust frame number
        nFrameNumber = nFrameNumber Mod MAX_NUMBER_OF_FRAMES_TO_GRAB + 1
        
        ' Yield execution so that the operating system can process other events.
        DoEvents
    Wend
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Notify the playback loop to stop
    StopPlaybackLoop = True
End Sub

