VERSION 5.00
Object = "{A700DC51-04A2-11D3-BF87-00A024D24992}#2.1#0"; "MIL.ocx"
Begin VB.Form frmExample 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MGrabSequence"
   ClientHeight    =   6660
   ClientLeft      =   30
   ClientTop       =   270
   ClientWidth     =   6495
   Icon            =   "MGrabSequence.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   444
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   433
   Tag             =   "1"
   Begin MIL.Application Application 
      Height          =   480
      Left            =   5040
      TabIndex        =   3
      Top             =   1320
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "Application"
   End
   Begin MIL.System System 
      Height          =   480
      Left            =   5040
      TabIndex        =   4
      Top             =   1800
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "System"
      SystemType      =   "Default"
   End
   Begin MIL.Image ImageBuffer 
      Height          =   480
      Left            =   5040
      TabIndex        =   5
      Top             =   2280
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "ImageBuffer"
      AutomaticAllocation=   0   'False
      OwnerSystem     =   "System"
      SizeX           =   -1
      SizeY           =   -1
      NumberOfBands   =   -1
      _CanDisplay     =   -1  'True
      _CanGrab        =   -1  'True
      _LUT.Data       =   "MGrabSequence.frx":0442
   End
   Begin MIL.Digitizer Digitizer 
      Height          =   480
      Left            =   5040
      TabIndex        =   6
      Top             =   2760
      Visible         =   0   'False
      Width           =   480
      _Version        =   131073
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Name            =   "Digitizer"
      _GrabMode       =   -1  'True
      GrabMode        =   2
      OwnerSystem     =   "System"
      Image           =   "ImageBuffer"
      Format          =   "Default"
      _LUT.Data       =   "MGrabSequence.frx":0574
   End
   Begin MIL.Display Display 
      Height          =   4452
      Left            =   120
      TabIndex        =   7
      Top             =   2040
      Width           =   4572
      _Version        =   131073
      _ExtentX        =   8064
      _ExtentY        =   7853
      _StockProps     =   1
      Name            =   "Display"
      OwnerSystem     =   "System"
      Image           =   "ImageBuffer"
      DeviceNumber    =   0
      DisplayType     =   -1
      Format          =   "Default"
      _LUT.Data       =   "MGrabSequence.frx":06A6
      _OverlayLUT.Data=   "MGrabSequence.frx":07D8
   End
   Begin VB.CheckBox chkSaveFile 
      Caption         =   "Save the grabbed sequence to an AVI file"
      Height          =   252
      Left            =   120
      TabIndex        =   10
      Top             =   1680
      Value           =   1  'Checked
      Width           =   4572
   End
   Begin VB.OptionButton optJPEGLossyCompression 
      Caption         =   "JPEG lossy compression"
      Height          =   375
      Left            =   2520
      Style           =   1  'Graphical
      TabIndex        =   9
      Top             =   1200
      Width           =   2415
   End
   Begin VB.OptionButton optUncompressed 
      Caption         =   "Uncompressed images"
      Height          =   375
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   8
      Top             =   1200
      Value           =   -1  'True
      Width           =   2415
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "&Next >>"
      Height          =   495
      Left            =   5040
      TabIndex        =   0
      Tag             =   "1"
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label lblComment 
      BorderStyle     =   1  'Fixed Single
      Height          =   720
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   4815
   End
   Begin VB.Label lblStep 
      Caption         =   "Step 1:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmExample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' MGrabSequence
'    This example grabs a sequence of images in a loop.
'
'    Note: This assumes that the copy operation is shorter than a grab
'          and that the PC has sufficient bandwith to support the
'          operations.
'
'    NOTE: Check the history logs to determine which properties were set at
'          design time.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' Constants.
Const MAXIMUM_NUMBER_OF_FRAMES = 100
Const Q_FACTOR = 50
Const SEQUENCE_FILE = "seq.avi"

' Globals.
Dim StopPlaybackLoop As Boolean         ' Playback loop termination flag
Dim dTime As Double                     ' Time it took to grab the sequence
Dim bUseCompression As Boolean          ' Grab compressed images or not
Dim nNumberOfFrames As Long             ' Number of frames that will be grabbed

Dim dAverageFramePlaybackTime As Double ' Average time needed to playback a single frame

' Array of images to hold the grabbed sequence.
Dim SequenceImages() As Object

Private Sub Form_Load()

    Digitizer.ScaleX = 0.5
    Digitizer.ScaleY = 0.5

    ' Disable the JPEG lossy compression button if compression is not supported
    If Not System.CompressionSupported Then
        optJPEGLossyCompression.Enabled = False
    End If
    
    ReDim SequenceImages(1 To MAXIMUM_NUMBER_OF_FRAMES)
    
    ' Adjust the form and display sizes.
    AdjustForm Me

    ' Step 1: Resize and allocate the ImageBuffer, and start the grab.
    ImageBuffer.SizeX = Digitizer.SizeX * Digitizer.ScaleX
    ImageBuffer.SizeY = Digitizer.SizeY * Digitizer.ScaleY
    ImageBuffer.Allocate
    Digitizer.GrabContinuous
        
    ' Print message.
    lblComment = "This will record a sequence in a loop.  " & _
                 "The compression type to apply to the images grabbed in the sequence may be specified using the buttons below.  " & _
                 "Click Next to continue.  "

End Sub

Private Sub cmdNext_Click()
    
    ' Adjust the step number and associated text.
    AdjustStepNumber Me
    
    Select Case cmdNext.Tag
        
        ' Step 2: Grab the sequence
        Case 2
                    
            ' Disable the Next button
            cmdNext.Enabled = False
            
            ' Stop continuous grab
            Digitizer.Halt
            
            ' Disable compression buttons
            optJPEGLossyCompression.Enabled = False
            optUncompressed.Enabled = False
            
            ' Print message
            lblComment = "Allocating sequence images...  "
            DoEvents
            
            ' The compression algorithm used depends on the system and the digitizer
            Dim CompressionType As Long
            CompressionType = mJPEGLossy
            If (Not InStr(System.BoardType, "Compression") = 0) And _
                (Digitizer.ScanMode = mInterlace) Then
                CompressionType = mJPEGLossyInterlaced
            End If
            
            ' Allocate all the sequence images
            Dim ContinueAllocatingImages As Boolean
            
            ContinueAllocatingImages = True
            nNumberOfFrames = 0
            
            While ContinueAllocatingImages
                Dim NewImage As Object
                Set NewImage = CreateObject("MIL.Image")
                
                With NewImage
                    .CanGrab = True
                    .CanDisplay = False
                    .NumberOfBands = ImageBuffer.NumberOfBands
                    .SizeX = ImageBuffer.SizeX
                    .SizeY = ImageBuffer.SizeY
                
                    If bUseCompression Then
                        .CompressionType = CompressionType
                        .JPEGAlgorithm.QFactor = Q_FACTOR
                    End If
                
                    On Error Resume Next
                    .Allocate
                    On Error GoTo 0
                    
                    If .IsAllocated Then
                        Set SequenceImages(nNumberOfFrames + 1) = NewImage
                        nNumberOfFrames = nNumberOfFrames + 1
                            
                        If nNumberOfFrames = MAXIMUM_NUMBER_OF_FRAMES Then
                            ContinueAllocatingImages = False
                        End If
                    Else
                        ' stop allocating images when we run out of memory
                        ContinueAllocatingImages = False
                    End If
                    
                End With
                
            Wend
            
            ' Print message
            lblComment = "Grabbing a sequence of " & nNumberOfFrames & " frames, please wait...  "
            DoEvents
            
            ' Synchronize the timer and start the grab
            Digitizer.Image = SequenceImages(1)
            Digitizer.Grab
            Digitizer.Grab
            Application.Timer.Reset
            
            ' Grab the sequence in loop
            Dim i As Integer
            For i = 2 To nNumberOfFrames
                ' Set the Digitizer to grab the next frame in the next image in sequence
                Digitizer.Image = SequenceImages(i)
                
                ' Start the grab
                Digitizer.Grab
            Next
            
            ' Wait for the last frame to be grabbed, and then get the time it took
            ' to grab the sequence
            Digitizer.GrabWait mGrabEnd
            dTime = Application.Timer.Read
            
            ' Disable the check button indicating whether the AVI should be saved
            chkSaveFile.Enabled = False
            
            ' Save the sequence into an AVI file, according the check button
            If chkSaveFile Then
                lblComment = "Saving and re-loading the sequence, please wait... "
                DoEvents
                
                Dim AVIHandler As New AVIFileHandler
                AVIHandler.Open App.Path & "\..\..\..\..\images\" & SEQUENCE_FILE, _
                                aviFileFormatDefault, aviCreate
                AVIHandler.Write SequenceImages, nNumberOfFrames / dTime
                AVIHandler.Close
                                
                ' Clear all buffers in the sequence
                For i = 1 To nNumberOfFrames
                    SequenceImages(i).Clear
                Next
                
                ' Restore the sequence from the file
                
                AVIHandler.Open App.Path & "\..\..\..\..\images\" & SEQUENCE_FILE, _
                                aviFileFormatDefault, aviRead
                AVIHandler.Read SequenceImages, 0, nNumberOfFrames
                AVIHandler.Close
            End If
            
            ' Enable the Next button
            cmdNext.Enabled = True
            cmdNext.SetFocus
            
            ' Start playback loop
            '
            ' Print statistics before entering playback loop
            lblComment = "Playing the sequence; " & _
                         Str(nNumberOfFrames) & " frames grabbed, at a frame rate of " & _
                         Format(nNumberOfFrames / dTime, "###0.00") & " frames/sec (" & _
                         Format(1000 * dTime / nNumberOfFrames, "###0.00") & " ms/frame).  " & _
                         "Click Next to continue.  "
            DoEvents
            
            StopPlaybackLoop = False
            PlaybackLoop
            
            
        ' Stop the playback and print statistics
        Case 3
            StopPlaybackLoop = True
            
            lblComment = nNumberOfFrames & _
                         " frames replayed at a frame rate of " & _
                         Format(1 / dAverageFramePlaybackTime, "###0.00") & " frames/sec (" & _
                         Format(1000 * dAverageFramePlaybackTime, "###0.00") & " ms/frame).  " & _
                        "Click Next to end.  "
                        
        ' Last Step: End the application
         Case Else
            Unload Me
    End Select
End Sub

Private Sub PlaybackLoop()
    
    ' loacal variables
    Dim dTimeWait As Double
    Dim nFrameNumber As Long
    Dim nFramesPlayed As Long
    Dim dTotalPlaybackTime As Double
    Dim dTemp As Double

    nFrameNumber = 1
    
    While Not StopPlaybackLoop
        ' Reset timer and copy next image to the display
        Application.Timer.Reset
        ImageBuffer.Copy SequenceImages(nFrameNumber)
        
        dTemp = Application.Timer.Read
        
        dTotalPlaybackTime = dTotalPlaybackTime + dTemp
        
        ' Compute how much time we must still wait for this frame
        dTimeWait = dTime / nNumberOfFrames - dTemp
        
        dTotalPlaybackTime = dTotalPlaybackTime + dTimeWait
                
        ' Wait for remaining time
        Application.Timer.Wait dTimeWait
        
        ' Adjust frame number and number of frames played
        nFrameNumber = nFrameNumber Mod nNumberOfFrames + 1
        nFramesPlayed = nFramesPlayed + 1
        
        ' Update the average time of an iteration (sec per frame)
        dAverageFramePlaybackTime = dTotalPlaybackTime / nFramesPlayed
        
        ' Yield execution so that the operating system can process other events
        DoEvents
    Wend
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Notify the playback loop to stop, if necessary
    StopPlaybackLoop = True
End Sub

Private Sub optJPEGLossyCompression_Click()
    
    bUseCompression = True
    
    ' There is a limitation on the Meteor II board with MJPEG compression module
    ' that prevents digitizer scaling when grabbing with compression.
    If Not InStr(System.BoardType, "Compression") = 0 Then
    
        If ImageBuffer.IsAllocated Then
            ImageBuffer.Free
        End If
        If Digitizer.IsAllocated Then
            Digitizer.Free
        End If
        
        Digitizer.ScaleX = 1
        Digitizer.ScaleY = 1
        ImageBuffer.SizeX = Digitizer.SizeX * Digitizer.ScaleX
        ImageBuffer.SizeY = Digitizer.SizeY * Digitizer.ScaleY
    
        ' Adjust the form and display sizes.
        AdjustForm Me
        
        ImageBuffer.Allocate
        Digitizer.Allocate
        Digitizer.GrabContinuous
        
    End If
   
End Sub

Private Sub optUncompressed_Click()
    
    bUseCompression = False
    
    ' There is a limitation on the Meteor II board with MJPEG compression module
    ' that prevents digitizer scaling when grabbing with compression.
    If Not InStr(System.BoardType, "Compression") = 0 Then
    
        If ImageBuffer.IsAllocated Then
            ImageBuffer.Free
        End If
        If Digitizer.IsAllocated Then
            Digitizer.Free
        End If
        
        Digitizer.ScaleX = 0.5
        Digitizer.ScaleY = 0.5
        ImageBuffer.SizeX = Digitizer.SizeX * Digitizer.ScaleX
        ImageBuffer.SizeY = Digitizer.SizeY * Digitizer.ScaleY
        
        ' Adjust the form and display sizes.
        AdjustForm Me
        
        ImageBuffer.Allocate
        Digitizer.Allocate
        Digitizer.GrabContinuous
        
    End If
    
End Sub



