; File name: exrun.cl
; Synopsis:  This program configures the board, calls all the MILINTER
;            examples and executes them one by one.
;

; Disable the automatic printing of the return values of commands
silence 1

; detect the system type, and notify user
setnbr SysType [MsysInquire ActSYS M_SYSTEM_TYPE M_NULL]
setnbr DoDigExamples 1

if ([getnbr SysType] == M_SYSTEM_METEOR_TYPE)
   {
   echo "Using METEOR system"
   }
if ([getnbr SysType] == M_SYSTEM_PULSAR_TYPE)
   {
   echo "Using PULSAR system"
   }
if ([getnbr SysType] == M_SYSTEM_GENESIS_TYPE)
   {
   echo "Using GENESIS system"
   }
if ([getnbr SysType] == M_SYSTEM_CORONA_TYPE)
   {
   echo "Using CORONA system"
   }
if ([getnbr SysType] == M_SYSTEM_VGA_TYPE)
   {
   echo "Using VGA system"
   setnbr DoDigExamples 0
   }
if ([getnbr SysType] == M_SYSTEM_HOST_TYPE)
   {
   echo "Using HOST system"
   setnbr DoDigExamples 0
   }

; MIL examples
echo "MSTART.CL"
pause
execcl "MSTART.CL"

echo "MDISPLAY.CL"
pause
execcl "MDISPLAY.CL"

if ( MIL_FULL_ENABLED == 1 )
   {
   echo "MMULTDIS.CL"
   pause
   execcl "MMULTDIS.CL"

   echo "MCOUNT.CL"
   pause
   execcl "MCOUNT.CL"

   echo "MPERIM.CL"
   pause
   execcl "MPERIM.CL"

   echo "MOPEN.CL"
   pause
   execcl "MOPEN.CL"

   echo "MCONVOL.CL"
   pause
   execcl "MCONVOL.CL"

   echo "MHIST.CL"
   pause
   execcl "MHIST.CL"

   echo "MBLOBCNT.CL"
   pause
   execcl "MBLOBCNT.CL"

   echo "MBLOBCOG.CL"
   pause
   execcl "MBLOBCOG.CL"

   echo "MSEARCH.CL"
   pause
   execcl "MSEARCH.CL"

   echo "MSHIFT.CL"
   pause
   execcl "MSHIFT.CL"

   echo "MRESTMOD.CL"
   pause
   execcl "MRESTMOD.CL"

   echo "MMEASSTR.CL"
   pause
   execcl "MMEASSTR.CL"

   echo "MOCRFONT.CL"
   pause
   execcl "MOCRFONT.CL"

   echo "MOCRREAD.CL"
   pause
   execcl "MOCRREAD.CL"

   echo "MOCRVIEW.CL"
   pause
   execcl "MOCRVIEW.CL"
   }

; notify user about dig. examples
if ([getnbr DoDigExamples] == 1)
   {
   echo "*** DIGITIZER NOTICE"
   echo 
   echo "RS170 is the digitizer by default."
   echo "If you have another kind of digitizer, please"
   echo "say no to the next question and change the MILSETUP.CL"
   echo "command list's M_DEF_DIGITIZER_FORMAT macro accordingly."
   echo 
   echo "Do you want to test the digitizer ? (Y/N) "
   setnbr KeyPressed [inkey]

	if ( ( [getnbr KeyPressed] == 89) || ( [getnbr KeyPressed] == 121 ) )
		{
		setnbr DoDigExamples 1

      if ([getnbr DoDigExamples] == 1)
         {
         echo "MFOCUS.CL"
         pause
         execcl "MFOCUS.CL"

         echo "MGRAB.CL"
         pause
         execcl "MGRAB.CL"
         }

      if ( MIL_FULL_ENABLED == 1 )
         {
         if ([getnbr DoDigExamples] == 1)
            {
            echo "MSURVEY.CL"
            pause
            execcl "MSURVEY.CL"
            }

         if ([getnbr DoDigExamples] == 1)
            {
            echo "MOBJTRAC.CL"
            pause
            execcl "MOBJTRAC.CL"
            }
         }
      }
   else
      {
      setnbr DoDigExamples 0
      }
   }
else
   {
   echo "Digitizer examples skipped."
   }

echo "*** Execution of examples completed !!!"

; Enable the automatic printing of the return values of commands
silence 0
