; File name: mfocus.cl 
; Synopsis:  This program allows you to adjust your camera by 
;            grabbing continuously from the default camera until
;            a key is pressed.
;


; Disable the automatic printing of the return values of commands
silence 1

MIL_ID MilApplication ; Application identifier.
MIL_ID MilSystem      ; System identifier.  
MIL_ID MilDisplay     ; Display identifier.
MIL_ID MilDigitizer   ; Digitizer identifier.  
MIL_ID MilImage       ; Image buffer identifier.  


; Allocate defaults.
MappAllocDefault M_SETUP &MilApplication &MilSystem &MilDisplay &MilDigitizer &MilImage

; Grab continuously.
MdigGrabContinuous MilDigitizer MilImage

; When a key is pressed, halt.
echo "Continuous grab in progress. Adjust your camera and"
pause"press <Enter> to stop grabbing."


; Stop continuous grab.
MdigHalt MilDigitizer

echo "Displaying the last grabbed image."
pause "Press <Enter> to end."

; Release defaults.
MappFreeDefault MilApplication MilSystem MilDisplay MilDigitizer MilImage


; Enable the automatic printing of the return values of commands
silence 0
