;File name: mocrview.c
;Synopsis:  This program shows how to visualize the characters of a font.

; Disable the automatic printing of the return values of commands
silence 1

; Target font file name.
macro FONT_FILE_NAME   "\semi1292.mfo"

MIL_ID MilApplication              ; Application identifier. 
MIL_ID MilSystem                   ; System identifier.      
MIL_ID MilDisplay                  ; Display identifier.     
MIL_ID MilImage                    ; Image buffer identifier.
MIL_ID OcrFont                     ; OCR font identifier.    
double CharNumber                  ; Number of characters in font.
double CharBoxSizeX                ; Size of character's box in font.
double CharBoxSizeY 
double oSizeX                       ; Size of the Image.
double oSizeY 

; Allocate defaults
   MappAllocDefault M_SETUP &MilApplication &MilSystem &MilDisplay M_NULL &MilImage

; Restore the OCR character font from disk.
   setstr str_font [ addstr imagepath FONT_FILE_NAME ]
   MocrRestoreFont [getstr str_font] M_RESTORE MilSystem &OcrFont

; Inquire the OCR font character number and dimentions.
   MocrInquire OcrFont M_CHAR_NUMBER     &CharNumber
   MocrInquire OcrFont M_CHAR_BOX_SIZE_X &CharBoxSizeX
   MocrInquire OcrFont M_CHAR_BOX_SIZE_Y &CharBoxSizeY

; Verify that all the character representations fits in the target image
   setoSizeX [MbufInquire MilImage M_SIZE_X M_NULL]
   setoSizeY [MbufInquire MilImage M_SIZE_Y M_NULL]

   if  (CharNumber < ((oSizeX / CharBoxSizeX) * (oSizeY / CharBoxSizeY)) )
      {
; Display the font representation.
      MocrCopyFont MilImage OcrFont (M_COPY_FROM_FONT + M_ALL_CHAR) ""

; Pause to show the result.
      echo "The font characters have been copied to the displayed image."
      pause "Press <Enter> to end."
      }
   else 
      {
      echo "Error: Target image too small to copy the font characters."
      }

; Free all allocations.
   MocrFree OcrFont
   MappFreeDefault MilApplication MilSystem MilDisplay M_NULL MilImage

; Enable the automatic printing of the return values of commands
silence 0
