; File name: mallocd.cl
; Synopsis : This command list simulates the behavior of the Matrox Imaging
;            Library MappAllocDefault macro. It sets up the requested MIL and
;            processing environments using the defaults specified. It can
;            initialize MIL, download any system resident software, allocate
;            the system which will receive the MIL commands, allocate the
;            input device (if one is to be used), and allocate and clear a
;            displayable image buffer, depending on what is requested.
; Usage    : MappAllocDefault LONG InitFlag, MIL_ID *ApplicationIdPtr,
;					     MIL_ID *SystemIdPtr,
;					     MIL_ID *DisplayIdPtr,
;					     MIL_ID *DigitizerIdPtr,
;					     MIL_ID *ImageIdPtr


setnbr SystemId  0
setnbr DisplayID 0
setnbr ImageID   0
setnbr DigID     0
setnbr FreeDig   0
setnbr DefX M_D_SIZ_X
setnbr DefY M_D_SIZ_Y
setnbr DefT M_D_TYP
setnbr DefA M_D_ATT
setnbr DefB M_D_BANDS

setnbr IntellicamApp  ACTAPP
setnbr IntellicamSys  ACTSYS
setnbr IntellicamDisp ACTDISP
setnbr IntellicamDig  ACTDIG

; return current application of Intellicam
if ( #2 != M_NULL)
   {
   setarray TemporaryMilID #2
   setnbrarray TemporaryMilID 0 [getnbr IntellicamApp]
   
   ; reset all graphics default settings stored in the application object 
   MgraFontScale  M_DEFAULT 1.0 1.0
   MgraColor      M_DEFAULT 0xFFFFFFFF
   MgraBackColor  M_DEFAULT 0
   MgraControl    M_DEFAULT M_BACKGROUND_MODE M_OPAQUE
   MgraFont       M_DEFAULT M_FONT_DEFAULT
   }

; return current system of Intellicam
if ( #3 != M_NULL )
   {
   setarray TemporaryMilID #3

   setnbrarray TemporaryMilID 0 [getnbr IntellicamSys]
   setnbr SystemId [getnbrarray TemporaryMilID 0]
   }
                                
; return current display of Intellicam current system
if ( #4 != M_NULL )
   {
   setarray TemporaryMilID #4

   setnbrarray TemporaryMilID 0 [getnbr IntellicamDisp]
   setnbr DisplayID [getnbrarray TemporaryMilID 0]
   }

; return current digitizer of Intellicam current system
; OR if no digitizer is allocated on the current system,
; do so here
if ( #5 != M_NULL )
   {
   setarray TemporaryMilID #5

   if ( [getnbr IntellicamDig] != 0)
      {
      setnbrarray TemporaryMilID 0 [getnbr IntellicamDig]
	  }
	else
	  {
	  MdigAlloc [getnbr SystemId] M_DEF_DIGITIZER_NUM M_DEF_DIGITIZER_FORMAT M_DEF_DIGITIZER_INIT [getarray TemporaryMilID]
	  setnbr FreeDig 1
	  }

   setnbr DigId [getnbrarray TemporaryMilID 0]
   }

; allocate an image buffer
if ( #6 != M_NULL )
   {
   if ( [getnbr DisplayID] != 0)
      {
      setnbr DispMode [MdispInquire [getnbr DisplayID] M_DISP_MODE M_NULL]
      if ([getnbr DispMode] == M_WINDOWED )
         {
         if ( [getnbr DigID] != 0)
            {
            setnbr DefX [MdigInquire [getnbr DigID] M_SIZE_X M_NULL]
            setnbr DefY [MdigInquire [getnbr DigID] M_SIZE_Y M_NULL]
            setnbr DefT [MdispInquire [getnbr DisplayID] M_TYPE   M_NULL]
            }
         else
            {
            setnbr DefX M_D_SIZ_X
            setnbr DefY M_D_SIZ_Y
            setnbr DefT [MdispInquire [getnbr DisplayID] M_TYPE   M_NULL]
            }   
         }
      else
         {
         setnbr DefX [MdispInquire [getnbr DisplayID] M_SIZE_X M_NULL]
         setnbr DefY [MdispInquire [getnbr DisplayID] M_SIZE_Y M_NULL]
         setnbr DefT [MdispInquire [getnbr DisplayID] M_TYPE   M_NULL]
         }   
      
      if ([getnbr DefX] < M_D_SIZ_X)
         {
         setnbr DefX M_D_SIZ_X
         }
      if ([getnbr DefX] > M_DEF_IMAGE_SIZE_X_MAX)
         {
         setnbr DefX M_DEF_IMAGE_SIZE_X_MAX
         }
      if ([getnbr DefY] < M_D_SIZ_Y)
         {
         setnbr DefY M_D_SIZ_Y
         }
      if ([getnbr DefY] > M_DEF_IMAGE_SIZE_Y_MAX)
         {
         setnbr DefY M_DEF_IMAGE_SIZE_Y_MAX
         }
      if ((([getnbr DefT]|0xFFFFFF00)^0xFFFFFF00) < ((M_D_TYP|0xFFFFFF00)^0xFFFFFF00))
         {
         setnbr DefT M_D_TYP
         setnbr ([getnbr DefT]+M_UNSIGNED)
         }
      setnbr DefA ([getnbr DefA]+M_DISP)
      }

   if ( [getnbr DigID] != 0)
      {
      setnbr DefA ([getnbr DefA]+M_GRAB)
      setnbr DefB [MdigInquire [getnbr DigID] M_SIZE_BAND M_NULL]
      }
   macro SizB [getnbr DefB]
   macro SizX [getnbr DefX]
   macro SizY [getnbr DefY]
   macro SizT [getnbr DefT]
   macro Attr [getnbr DefA]
   setnbr ImageID [MbufAllocColor [getnbr SystemId] SizB SizX SizY SizT Attr #6]
   MbufClear [getnbr ImageID] 0
   }

; display the image buffer
if ( [getnbr DisplayID] != 0)
   {
   if ([getnbr ImageID] != 0)
      {
      MdispSelect [getnbr DisplayID] [getnbr ImageID]
      }
   if (M_DEF_DISPLAY_KEY_ENABLE_ON_ALLOC != 0)
      {
      if ([MdispInquire [getnbr DisplayID] M_DISP_KEY_SUPPORTED M_NULL])
         {
         MdispOverlayKey [getnbr DisplayID] M_KEY_ON_COLOR M_EQUAL 255 M_DEF_DISPLAY_KEY_COLOR
         }
      }
   }
