@echo off
SETLOCAL ENABLEEXTENSIONS

set BDEBUG=
set CHOICE=..\util\imccrun\choice
set CONSOLEOUT=NUL
set GAWK=..\util\imccrun.nt\gawk.exe
set GENPATH=c:\genesis
set GENVERSION=
set GNLDLLPATH=..\lib\obj\nt
set GOVERSION=yes
set REBOOT=
set SETUPMODE=
set SPARAM=
set WINDLLPATH=%windir%\system32
set WINDRVPATH=%WINDLLPATH%\drivers

goto :SKIP_USAGE

:USAGE
@echo off
if not exist bsetup.txt echo.Help file bsetup.txt not found!
if not exist bsetup.txt goto :END
type bsetup.txt|more
if /I "%GOVERSION%" == "err" echo.WARNING: You must specify a version number
goto :END

:SKIP_USAGE
REM Read batch install parameter(s)
:MOREPARAM
if "%1" == ""                 goto :ENDPARAM
if "%1" == "?"                goto :USAGE
if "%1" == "!"                set BDEBUG=echo.
if "%1" == "!"                goto :SKIPPARAM
if /I "%1" == "bycopy"        set SETUPMODE=%1
if /I "%1" == "bycopy"        goto :SKIPPARAM
if /I "%1" == "install"       set SETUPMODE=%1
if /I "%1" == "install"       goto :SKIPPARAM
if /I "%1" == "reactivate"    set SETUPMODE=%1
if /I "%1" == "reactivate"    goto :SKIPPARAM
if /I "%1" == "remove"        set SETUPMODE=%1
if /I "%1" == "remove"        goto :SKIPPARAM
if /I "%1" == "path"          set GENPATH=%2
if /I "%1" == "version"       set GENVERSION=version %2
if /I "%1" == "reboot"        set REBOOT=%2
if not "%SPARAM%" == ""       set SPARAM=%SPARAM% %1
if     "%SPARAM%" == ""       set SPARAM=%1
:SKIPPARAM
shift
goto :MOREPARAM

:ENDPARAM
if not "%BDEBUG%" == "" set CONSOLEOUT=CON
if not "%BDEBUG%" == "" @echo on

REM Check if at lease one parameter pass
if "%SPARAM%" == "" goto :USAGE

REM ----------------------------------------------------------------------------
REM Ok to go for install

REM Get NT version
%GAWK% -f ntrev.awk
set NT_VERSION=%ERRORLEVEL%

if "%NT_VERSION%" == "3" set DRVPATH=nt3.51
if "%NT_VERSION%" == "4" set DRVPATH=nt4.0
if "%NT_VERSION%" == "5" set DRVPATH=w2k

if /I "%SETUPMODE%" == "remove"       goto  :REMOVE
if /I "%SETUPMODE%" == "reactivate"   goto  :REACTIVATE
if /I "%SETUPMODE%" == "bycopy"       goto  :BYCOPY
if /I "%SETUPMODE%" == "install"      goto  :INSTALL

REM Fallback if invalid parameter(s)
echo.
echo.ERROR: First parameter (SetupMode) is invalid
goto :USAGE


:REMOVE
if not exist %GENPATH%\. goto :END
if not exist %GENPATH%\Uninst.isu goto :END
echo.Removing Genesis "%GENVERSION%" from %GENPATH% ...
%BDEBUG%start /WAIT %windir%\IsUninst.exe -f%GENPATH%\Uninst.isu -c%GENPATH%\uninsgen.dll
call :DRIVERREMOVE
%BDEBUG%rd /S /Q %GENPATH%  >%CONSOLEOUT%
if exist %WINDLLPATH%\genlib.dll  %BDEBUG%del /F /Q %WINDLLPATH%\genlib.dll   >%CONSOLEOUT%
if exist %WINDLLPATH%\pixvlib.dll %BDEBUG%del /F /Q %WINDLLPATH%\pixvlib.dll  >%CONSOLEOUT%
echo.done
goto :END


:BYCOPY
REM Install GNL by doing a copy (uninstall impossible)
if /I "%GOVERSION%" == "yes"  call :VERSION
if /I "%GOVERSION%" == "no"   goto :END
if /I "%GOVERSION%" == "err"  goto :USAGE
call :DRIVERREMOVE
echo.Copying files to %GENPATH% ...
set XCOPY_OPT=
if "%NT_VERSION%" == "5" set XCOPY_OPT=/Y
if not exist %GENPATH% md %GENPATH%  >%CONSOLEOUT%
pushd ..\
%BDEBUG%xcopy /S /E /R /Q %XCOPY_OPT% *.* %GENPATH%  >%CONSOLEOUT%
REM Overwrite mildrv and mtxdma to use new one
%BDEBUG%copy setup\mildrv.exe %GENPATH%\drivers\%DRVPATH%\i386  >%CONSOLEOUT%
%BDEBUG%copy setup\mtxdma.sys %GENPATH%\drivers\%DRVPATH%\i386  >%CONSOLEOUT%
popd
REM Remove setup files in target directory because they can't be used from there
pushd %GENPATH%
if exist setup.ini   %BDEBUG%del /F /Q *.*      >%CONSOLEOUT%
if exist setup\.     %BDEBUG%rd  /S /Q setup    >%CONSOLEOUT%
popd
echo.done, ready to reactivate


:REACTIVATE
REM GNL activation
if not exist setup.exe echo.ERROR: Setup.exe in current directory is not present
if not exist setup.exe goto :END
if not exist %GNLDLLPATH%\genlib.dll echo.ERROR: GNL DLL not found in %GNLDLLPATH%
if not exist %GNLDLLPATH%\genlib.dll goto :END
if /I "%GOVERSION%"  == "done"         echo.Activation in progress,
if /I "%GOVERSION%"  == "yes"          echo.Reactivation in progress,
if /I "%GOVERSION%"  == "yes"          call :VERSION
if /I "%GOVERSION%"  == "no"           goto :END
if /I "%GOVERSION%"  == "err"          goto :USAGE
if /I "%SETUPMODE%"  == "reactivate"   call :DRIVERREMOVE
echo.Updating driver and NT registry ...
REM Use standard Genesis setup but don't copy files
%BDEBUG%copy %GNLDLLPATH%\genlib.dll   %WINDLLPATH%  >%CONSOLEOUT%
%BDEBUG%copy %GNLDLLPATH%\pixvlib.dll  %WINDLLPATH%  >%CONSOLEOUT%
%BDEBUG%copy %GNLDLLPATH%\miltiff.dll  %WINDLLPATH%  >%CONSOLEOUT%
%BDEBUG%copy %GNLDLLPATH%\mfc42.dll    %WINDLLPATH%  >%CONSOLEOUT%
REM WARNING: Microsoft standard DLL are not copied to %WINDLLPATH%
%BDEBUG%start /WAIT setup.exe %SPARAM% nocopy %GENVERSION%
if /I "%REBOOT%" == "reboot" goto :END
echo....Waiting that Genesis Setup has finish
%CHOICE% /N /T:y,20  >%CONSOLEOUT%
echo.done

REM Start Genesis driver
if not exist %WINDRVPATH%\genesis.sys echo.ERROR: Driver not present in %WINDRVPATH%
if not exist %WINDRVPATH%\genesis.sys goto :END
if not "%NT_VERSION%" == "5" echo.Starting Genesis driver ...
if not "%NT_VERSION%" == "5" %BDEBUG%net start genesis
if not "%NT_VERSION%" == "5" echo.done
goto :FINISH


:INSTALL
REM Normal install (will work fine only for GNL version > 2.08.03)
if not exist ..\setup.exe echo.ERROR: Setup program not available
if not exist ..\setup.exe goto :END
call :DRIVERREMOVE
echo.Install with default setup program
pushd ..\
%BDEBUG%start /WAIT setup.exe %SPARAM%
popd
echo.done
goto :FINISH


:DRIVERREMOVE
REM Remove previous Genesis driver
if not exist %WINDRVPATH%\genesis.sys goto :EOF
echo.Removing old driver if any (please ignore error if any) ...
if not "%NT_VERSION%" == "5" %BDEBUG%net stop genesis
if not exist mildrv.exe echo.ERROR: mildrv.exe not found in bsetup directory
if not exist mildrv.exe goto :END
%BDEBUG%mildrv.exe genesis -remove -noinfo -noerror
echo.Done
REM Return from call
goto :EOF


:VERSION
set GOVERSION=done
if exist setup.ini del /F /Q setup.ini    >%CONSOLEOUT%
if exist ..\setup.ini copy ..\setup.ini . >%CONSOLEOUT%
if exist ..\setup.ini if not exist setup.ini echo.ERROR: Read only drive, you must be on a writable drive
if exist ..\setup.ini if not exist setup.ini goto :END
REM Extract version from setup.ini if present
REM (it overwrite version passed to bsetup)
if exist setup.ini %GAWK% -f getver.awk <setup.ini >setver.bat
if exist setup.ini call setver.bat
if exist setup.ini del /F /Q setver.bat >%CONSOLEOUT%
if "%GENVERSION%" == "" set GOVERSION=err
if "%GENVERSION%" == "" goto :EOF
echo.Ready to proceed for "%GENVERSION%" (default is YES in 5 seconds) ...
%CHOICE% /T:y,5
if errorlevel 2 set GOVERSION=no
goto :EOF


:FINISH
echo.
echo.---------------------------------------------------------------------------
echo.Your new settings is NOT active in the current Command Shell,
echo.you MUST exit from it and create a new Command Shell.
echo.The new Command Shell will be set to run with the new settings
echo.(environment variables will be set properly).
echo.var GENESIS should now be equal to %GENPATH%
if not "%GENINIPATH%" == "" echo.Be sure that GENINIPATH is empty before starting an application
echo.---------------------------------------------------------------------------
echo.
if "%REBOOT%" == "" if "%NT_VERSION%" == "5" echo.You MUST reboot to run with your new settings


:END
REM Finish install
ENDLOCAL
