#------------------------------------------------------------------------------
# 
#   File Name: ins_line.awk
# Description: GAWK.EXE script file 
#              Used by WInstall to edit files for a MIL installation under DOS
#              Insert a new line after the line where the string is found
#     Version: 1.00
#        Date: October 96
#
#------------------------------------------------------------------------------
#
# COPYRIGHT (c) 1996 Matrox Electronic Systems Ltd.
# All Rights Reserved
#
#------------------------------------------------------------------------------
 
BEGIN {

   if (ARGC < 4)
      {
      printf "gawk -fsetup.awk FILENAME STRING CONDITION LINE                     \n\n"
      printf "where:  FILENAME:  Name of the file to edit                           \n"
      printf "        STRING:    Add LINE after the line where STRING is found      \n"
      printf "        CONDITION: If CONDITION is found on a line,overwrite this line\n"
      printf "        LINE:      Line to write                                    \n\n"
      exit 1
      }

   # Initialize variables
   FileName  = ARGV[1]
   String    = ARGV[2]
   Condition = ARGV[3]
   Line      = ARGV[4]
   
   for (ii=0; ii<2; ii++)
      ARGV[ii] == ""

   
   # Parse the file: look for CONDITION

   ConditionIsFound = 0

   while( getline<FileName > 0)
   {
      if ( index ($0, Condition ) == 0)
      {
         print > "tempfile"
      }
      else
      {
         ConditionIsFound = 1
         print Line > "tempfile"
      }
   }

   if ( ConditionIsFound == 0 )
   {
      # CONDITION was not found
      # Parse the file: insert LINE after the line where STRING is found
      
      close ( FileName )
      close ( "tempfile" )
      system ("del tempfile" )

      while( getline<FileName > 0)
      {
         if ( index ($0, String ) == 0)
         {
            print > "tempfile"
         }
         else
         {
            print > "tempfile"
            print Line > "tempfile"
         }
      }
    }


   close("tempfile")
   system ("copy tempfile "FileName"")
   system ("del tempfile" )
}
 
