#------------------------------------------------------------------------------
# 
#   File Name: append.awk
# Description: GAWK.EXE script file 
#              Used by WInstall to edit files for a MIL installation under DOS
#              Edit the setup files for a MIL installation
#     Version: 1.00
#        Date: October 96
#
#------------------------------------------------------------------------------
#
# COPYRIGHT (c) 1996 Matrox Electronic Systems Ltd.
# All Rights Reserved
#
#------------------------------------------------------------------------------

BEGIN {

   if (ARGC < 3)
      {
      printf "gawk -fsetup.awk FILENAME DEFINE VALUE   \n\n"
      printf "where:  FILENAME: Name of the file to edit\n"
      printf "        DEFINE:   Define to look for      \n"
      printf "        VALUE:    New value to write    \n\n"

      printf "example: gawk -fsetup.awk milsetup.h M_DEF_SYSTEM_TYPE M_SYSTEM_METEOR"
      exit 1
      }

   # Initialize variables
   FileName = ARGV[1]
   Define   = ARGV[2]
   Value    = ARGV[3]
   
   for (ii=0; ii<2; ii++)
      ARGV[ii] == ""

   # Parse the file
   while( getline<FileName > 0)
   {
      if ( ( $2 == Define ) && ( $1 == "#define") )
      {
         gsub ( $3 , Value, $0)
         print $0 > "out.h"
      }
      else
      {
         print > "out.h"
      }
   }

   close("out.h")
   system ("copy out.h "FileName"")
   system ("del out.h" )
}
