/* File name: mfocus.c 
 * Synopsis:  This program allows you to adjust your camera by 
 *            grabbing continuously until a key is pressed.
 */

#include <stdio.h> 
#include <mil.h> 

void main(void)
{ 
   MIL_ID MilApplication,  /* Application identifier.  */
          MilSystem,       /* System identifier.       */
          MilDisplay,      /* Display identifier.      */
          MilDigitizer,    /* Digitizer identifier.    */ 
          MilImage;        /* Image buffer identifier. */

   /* Allocate defaults. */
   MappAllocDefault(M_SETUP, &MilApplication, &MilSystem,
                    &MilDisplay, &MilDigitizer, &MilImage);

   /* Grab continuously. */
   MdigGrabContinuous(MilDigitizer, MilImage);

   /* When a key is pressed, halt. */
   printf("Continuous grab in progress. Adjust your camera and\n");
   printf("press <Enter> to stop grabbing.\n");
   getchar();

   /* Stop continuous grab. */
   MdigHalt(MilDigitizer);

   /* Pause to show the result. */
   printf("\nDisplaying the last grabbed image.\n");
   printf("Press <Enter> to end.\n");
   getchar();

   /* Release defaults. */
   MappFreeDefault(MilApplication, MilSystem, MilDisplay,
                                  MilDigitizer, MilImage);
}

