/* File name: mgrab.c 
 * Synopsis:  This program grabs an image from the camera.
 */

#include <stdio.h> 
#include <mil.h> 

void main(void)
{ 
   MIL_ID MilApplication,  /* Application identifier.  */
          MilSystem,       /* System identifier.       */
          MilDisplay,      /* Display identifier.      */
          MilDigitizer,    /* Digitizer identifier.    */ 
          MilImage;        /* Image buffer identifier. */

   /* Allocate defaults. */
   MappAllocDefault(M_SETUP, &MilApplication, &MilSystem,
                    &MilDisplay, &MilDigitizer, &MilImage);

   /* Grab an image. */ 
   MdigGrab(MilDigitizer, MilImage);

   /* Report what has happened to the Host screen. */ 
   printf("An image has been grabbed.\n");
   printf("Press <Enter> to end.\n");
   getchar();

   /* Release defaults. */
   MappFreeDefault(MilApplication, MilSystem, MilDisplay,
                                  MilDigitizer, MilImage);
}

