// MdispMFC.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MdispMFC.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MdispMFCDoc.h"
#include "MdispMFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCApp

BEGIN_MESSAGE_MAP(CMdispMFCApp, CWinApp)
	//{{AFX_MSG_MAP(CMdispMFCApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCApp construction

CMdispMFCApp::CMdispMFCApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMdispMFCApp object

CMdispMFCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCApp initialization

BOOL CMdispMFCApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)


	/////////////////////////////////////////////////////////////////////////
	// MIL: Write your one-time initialization code here 
	/////////////////////////////////////////////////////////////////////////	

	// Allocate an application
	MappAlloc(M_DEFAULT,&MilApplication);
	// Disable MIL error message to be displayed as the usual way
	MappControl(M_ERROR,M_PRINT_DISABLE);
	// Retrieve previous hanler ptr and user handler ptr
	MappInquire(M_CURRENT_ERROR_HANDLER_PTR,&HandlerPtr);		
	MappInquire(M_CURRENT_ERROR_HANDLER_USER_PTR,&HandlerUserPtr);	
	// Hook MIL error on function DisplayError()
	MappHookFunction(M_ERROR_CURRENT,DisplayErrorExt,this);
	// Allocate a system	
 	MsysAlloc(M_SYSTEM_SETUP,M_DEF_SYSTEM_NUM,M_COMPLETE,&MilSystem);
	// Inquire number of digitizers available on the system
	MsysInquire(MilSystem,M_DIGITIZER_NUM,&NumberOfDigitizer);
	
   // Digitizer is available
   if (NumberOfDigitizer)	
	{
      // Allocate a digitizer
		MdigAlloc(MilSystem,M_DEFAULT,M_CAMERA_SETUP,M_DEFAULT,&MilDigitizer);
		// Stop live grab when window is disable
    	MsysControl(MilSystem,M_STOP_LIVE_GRAB_WHEN_DISABLED,M_ENABLE);
		// Inquire digitizer informations
  		MdigInquire(MilDigitizer,M_SIZE_X,&DigSizeX);
		MdigInquire(MilDigitizer,M_SIZE_Y,&DigSizeY);  	
		MdigInquire(MilDigitizer,M_SIZE_BAND,&Band);
		
		if (DigSizeX > M_DEF_IMAGE_SIZE_X_MAX) 
		   DigSizeX = M_DEF_IMAGE_SIZE_X_MAX;
		if (DigSizeY > M_DEF_IMAGE_SIZE_Y_MAX) 
			DigSizeY = M_DEF_IMAGE_SIZE_Y_MAX;
	}
   // Digitizer is not available
   else					
	{
		SizeX = M_DEF_IMAGE_SIZE_X_MIN; 
		SizeY = M_DEF_IMAGE_SIZE_Y_MIN;
		Band  =	M_DEF_IMAGE_NUMBANDS_MIN;
	}

	// Initialize the state of the grab
	GrabIsStarted = FALSE;
	
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write your one-time initialization code here 
	/////////////////////////////////////////////////////////////////////////
    
    
   // Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MDISPTYPE,
		RUNTIME_CLASS(CMdispMFCDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMdispMFCView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
    
    // The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMdispMFCApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCApp commands

int CMdispMFCApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class

	/////////////////////////////////////////////////////////////////////////
	// MIL: Write your code that will be executed on application exit
	/////////////////////////////////////////////////////////////////////////	

	if (MilDigitizer)    MdigFree (MilDigitizer);	// Free the digitizer
   if (MilSystem) 	   MsysFree (MilSystem);		// Free the system
  	if (MilApplication)  MappFree (MilApplication);	// Free the application
                        
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write your code that will be executed on application exit
	/////////////////////////////////////////////////////////////////////////
   
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////
// MIL: Hook-handler function: DisplayError()
/////////////////////////////////////////////////////////////////////////

long MFTYPE DisplayErrorExt(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr)
{
	((CMdispMFCApp*) AfxGetApp())->DisplayError(HookType,EventId, (CWinApp*) UserDataPtr);
	return M_NULL;
}


long MFTYPE CMdispMFCApp::DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr)
{
	char 	ErrorMessageFunction[M_ERROR_MESSAGE_SIZE] = "";
	char 	ErrorMessage[M_ERROR_MESSAGE_SIZE]         = "";
	char 	ErrorSubMessage1[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage2[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage3[M_ERROR_MESSAGE_SIZE]     = "";
	long 	NbSubCode;
	CString	CErrorMessage;

	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_FCT,ErrorMessageFunction);
	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT,ErrorMessage);
	MappGetHookInfo(EventId,M_CURRENT_SUB_NB,&NbSubCode);	
	if (NbSubCode > 2)
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_3,ErrorSubMessage3);	
	if (NbSubCode > 1)	
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_2,ErrorSubMessage2);
   if (NbSubCode > 0)
	   MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_1,ErrorSubMessage1);

	CErrorMessage = ErrorMessageFunction;
	CErrorMessage = CErrorMessage + "\n";
	CErrorMessage = CErrorMessage + ErrorMessage;
	
	if(NbSubCode > 0)
	{
		CErrorMessage = CErrorMessage + "\n";
		CErrorMessage = CErrorMessage + ErrorSubMessage1;
	}
	
	if(NbSubCode > 1)
	{
		CErrorMessage = CErrorMessage + "\n";
		CErrorMessage = CErrorMessage + ErrorSubMessage2;
	}
	
	if(NbSubCode > 2)
	{
		CErrorMessage = CErrorMessage + "\n";
		CErrorMessage = CErrorMessage + ErrorSubMessage3;
	}
	
	AfxMessageBox(CErrorMessage,MB_OK,0);

	// Chain hook function
 	if(HandlerPtr)
 		(*HandlerPtr)(HookType,EventId,HandlerUserPtr);
 	
	return M_NULL;
}

/////////////////////////////////////////////////////////////////////////
// MIL: Hook-handler function: DisplayError()
/////////////////////////////////////////////////////////////////////////

