// MdispMFCDoc.cpp : implementation of the CMdispMFCDoc class
//

#include "stdafx.h"
#include "MdispMFC.h"

#include "MdispMFCDoc.h"
#include "MdispMFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCDoc

IMPLEMENT_DYNCREATE(CMdispMFCDoc, CDocument)

BEGIN_MESSAGE_MAP(CMdispMFCDoc, CDocument)
	//{{AFX_MSG_MAP(CMdispMFCDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCDoc construction/destruction

CMdispMFCDoc::CMdispMFCDoc()
{
	// TODO: add one-time construction code here

}

CMdispMFCDoc::~CMdispMFCDoc()
{
}

BOOL CMdispMFCDoc::OnNewDocument()
{
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

   /////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a new document is created
	/////////////////////////////////////////////////////////////////////////
																	  
	// Set buffer attributes
	if(((CMdispMFCApp*)AfxGetApp())->NumberOfDigitizer)
	   BufferAttributes=M_IMAGE+M_DISP+M_GRAB+M_PROC;
	else
		BufferAttributes=M_IMAGE+M_DISP+M_PROC;
	
	// Set SizeX and SizeY variables
	if(((CMdispMFCApp*)AfxGetApp())->NumberOfDigitizer)
	{
		((CMdispMFCApp*)AfxGetApp())->SizeX	= ((CMdispMFCApp*)AfxGetApp())->DigSizeX;
		((CMdispMFCApp*)AfxGetApp())->SizeY	= ((CMdispMFCApp*)AfxGetApp())->DigSizeY;
	}
		
	// Allocate a buffer
  	MbufAllocColor(((CMdispMFCApp*)AfxGetApp())->MilSystem,
  			   		((CMdispMFCApp*)AfxGetApp())->Band,
  			   		((CMdispMFCApp*)AfxGetApp())->SizeX,
  			   		((CMdispMFCApp*)AfxGetApp())->SizeY,
  			   		M_DEF_IMAGE_TYPE,
  		       		BufferAttributes,
  			   		&MilImage);
	
	// If not able to allocate a buffer, do not create a new document
	if(!MilImage)
		return FALSE;
	
	// Clear the buffer 
	MbufClear(MilImage,0);
  	
  	/////////////////////////////////////////////////////////////////////////
  	// MIL: Write code that will be executed when a new document is created
	/////////////////////////////////////////////////////////////////////////	

	return CDocument::OnNewDocument();
}

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCDoc serialization

void CMdispMFCDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCDoc diagnostics

#ifdef _DEBUG
void CMdispMFCDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMdispMFCDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCDoc commands

void CMdispMFCDoc::OnCloseDocument() 
{
	// TODO: Add your specialized code here and/or call the base class
   
   /////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is closed
	/////////////////////////////////////////////////////////////////////////
	
	// Halt the grab, deselected the display, free the display and the image buffer
	// only if MbufAlloc was successful
	if (MilImage)
	{
		CMdispMFCView	*CurView;
		POSITION		   CurPos;
				
		// Make sure all views displays are deselected and grab is halt
		CurPos = GetFirstViewPosition();
      while(CurView = (CMdispMFCView *)GetNextView(CurPos))
      CurView->RemoveFromDisplay();
			
		// Free image buffer
		MbufFree(MilImage);
	}

	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is closed
	/////////////////////////////////////////////////////////////////////////
   
   CDocument::OnCloseDocument();
}

BOOL CMdispMFCDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here

	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is opened
	/////////////////////////////////////////////////////////////////////////
	
   MbufImport((LPSTR)lpszPathName,M_DEFAULT,M_RESTORE,((CMdispMFCApp*)AfxGetApp())->MilSystem,&MilImage);

	// Set SizeX and SizeY variable to the size of the buffer
	if (MilImage) 
	{
		((CMdispMFCApp*)AfxGetApp())->SizeX	= MbufInquire(MilImage,M_SIZE_X,M_NULL);
		((CMdispMFCApp*)AfxGetApp())->SizeY = MbufInquire(MilImage,M_SIZE_Y,M_NULL);
		return TRUE;
	}
	else
		return FALSE;
	
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is opened
	/////////////////////////////////////////////////////////////////////////
}

BOOL CMdispMFCDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	// TODO: Add your specialized code here and/or call the base class
   
   /////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is saved
	/////////////////////////////////////////////////////////////////////////
	
	BOOL	 SaveStatus;

	// To get the first view in the list of views:
	POSITION pos = GetFirstViewPosition();
	CView* pFirstView = GetNextView( pos );
	
	// Halt the grab if the current view has it
	if((((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr == pFirstView) &&
	   (((CMdispMFCApp*)AfxGetApp())->GrabIsStarted == TRUE))
	   MdigHalt(((CMdispMFCApp*)AfxGetApp())->MilDigitizer);
		
	// Save the current buffer
	MbufSave((LPSTR)lpszPathName,MilImage);
	
	// Verify if save operation was successful
	SaveStatus = (MappGetError(M_CURRENT,M_NULL) == M_NULL_ERROR);

	// Document has been saved
	if (!((((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr == pFirstView) &&
	      (((CMdispMFCApp*)AfxGetApp())->GrabIsStarted == TRUE)))
	   SetModifiedFlag(FALSE);
		
	// Restart the grab if the current view had it
	if((((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr == pFirstView) &&
	  (((CMdispMFCApp*)AfxGetApp())->GrabIsStarted == TRUE))
	  MdigGrabContinuous(((CMdispMFCApp*)AfxGetApp())->MilDigitizer, MilImage);
	
   return SaveStatus;
	
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when a document is saved
	/////////////////////////////////////////////////////////////////////////

	return CDocument::OnSaveDocument(lpszPathName);
}
