// MdispMFCView.cpp : implementation of the CMdispMFCView class
//

#include "stdafx.h"
#include "MdispMFC.h"

#include "MdispMFCDoc.h"
#include "MdispMFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCView

IMPLEMENT_DYNCREATE(CMdispMFCView, CView)

BEGIN_MESSAGE_MAP(CMdispMFCView, CView)
	//{{AFX_MSG_MAP(CMdispMFCView)
	ON_COMMAND(ID_GRAB_START, OnGrabStart)
	ON_UPDATE_COMMAND_UI(ID_GRAB_START, OnUpdateGrabStart)
	ON_COMMAND(ID_GRAB_STOP, OnGrabStop)
	ON_UPDATE_COMMAND_UI(ID_GRAB_STOP, OnUpdateGrabStop)
	ON_WM_DESTROY()
	ON_COMMAND(ID_OVERLAY, OnOverlay)
	ON_UPDATE_COMMAND_UI(ID_OVERLAY, OnUpdateOverlay)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCView construction/destruction

CMdispMFCView::CMdispMFCView()
{
	// TODO: add construction code here

    MilOverlayImage       = M_NULL;	// Overlay image buffer identifier 
    MilDisplay            = M_NULL;   // Display identifier.
    OverlayIsEnable       = FALSE;    // Overlay state
    fOverlayIsInitialized = FALSE;
}

CMdispMFCView::~CMdispMFCView()
{
}

BOOL CMdispMFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCView diagnostics

#ifdef _DEBUG
void CMdispMFCView::AssertValid() const
{
	CView::AssertValid();
}

void CMdispMFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMdispMFCDoc* CMdispMFCView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMdispMFCDoc)));
	return (CMdispMFCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMdispMFCView message handlers

void CMdispMFCView::OnGrabStart() 
{
	// TODO: Add your command handler code here
	
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed on a grab start
	/////////////////////////////////////////////////////////////////////////

	// If there is a grab in a view, halt the grab before starting a new one
	if(((CMdispMFCApp*)AfxGetApp())->GrabIsStarted)
		((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr->SendMessage(WM_COMMAND, ID_GRAB_STOP, 0);

   // Start a continuous grab in this view
	MdigGrabContinuous(((CMdispMFCApp*)AfxGetApp())->MilDigitizer, ((CMdispMFCDoc*)GetDocument())->MilImage);

	// Update the variable GrabIsStarted
	((CMdispMFCApp*)AfxGetApp())->GrabIsStarted = TRUE;	

	// GrabInViewPtr is now a pointer to this view
	((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr = this;

	// Document has been modified
	((CMdispMFCDoc*)GetDocument())->SetModifiedFlag(TRUE);
	
	/////////////////////////////////////////////////////////////////////////	
	// MIL: Write code that will be executed on a grab start
	/////////////////////////////////////////////////////////////////////////

}

void CMdispMFCView::OnUpdateGrabStart(CCmdUI* pCmdUI)
   {
   // TODO: Add your command update UI handler code here
   CView *GrabOwnerViewPtr = ((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr;
   
   pCmdUI->Enable(!(GrabOwnerViewPtr &&
                   (GetDocument() == GrabOwnerViewPtr->GetDocument())     &&
                   (((CMdispMFCApp*)AfxGetApp())->GrabIsStarted == TRUE)  &&
	                ((CMdispMFCApp*)AfxGetApp())->NumberOfDigitizer));
   }

void CMdispMFCView::OnGrabStop() 
{
	// TODO: Add your command handler code here
 
   /////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed on a grab stop 
	/////////////////////////////////////////////////////////////////////////
	
	// Halt the grab
	MdigHalt(((CMdispMFCApp*)AfxGetApp())->MilDigitizer);	
	((CMdispMFCApp*)AfxGetApp())->GrabIsStarted = FALSE;
	
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed on a grab stop 
	/////////////////////////////////////////////////////////////////////////
}

void CMdispMFCView::OnUpdateGrabStop(CCmdUI* pCmdUI) 
   {
   // TODO: Add your command update UI handler code here
   CView *GrabOwnerViewPtr = ((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr;

   pCmdUI->Enable(GrabOwnerViewPtr &&
                  (GetDocument() == GrabOwnerViewPtr->GetDocument())    &&
                  (((CMdispMFCApp*)AfxGetApp())->GrabIsStarted == TRUE) &&
	               ((CMdispMFCApp*)AfxGetApp())->NumberOfDigitizer);
   
   }

void CMdispMFCView::OnOverlay() 
{
   // TODO: Add your command handler code here

   /////////////////////////////////////////////////////////////////////////
   // MIL: Write code that will be executed when 'add overlay' is selected
   /////////////////////////////////////////////////////////////////////////

   // Initialize overlay if not already done
   if ( (!fOverlayIsInitialized) && (MilDisplay))
      {
      if ((MdispInquire(MilDisplay, M_DISPLAY_MODE, M_NULL) == M_WINDOWED ) &&
          (((CMdispMFCDoc*)GetDocument())->MilImage)                     &&
          (MilDisplay) )
         {
         // Prepare overlay buffer //
         ////////////////////////////
         
         // Disable overlay display while preparing the data
 	      MdispControl(MilDisplay, M_WINDOW_OVR_SHOW, M_DISABLE);
 	           
         // Enable writting Overlay graphics on top of display buffer.
 	      MdispControl(MilDisplay, M_WINDOW_OVR_WRITE, M_ENABLE);
 	           
         // Inquire the Overlay buffer associated with the displayed buffer.
 	      MdispInquire(MilDisplay, M_WINDOW_OVR_BUF_ID, &MilOverlayImage);
         
         // Inquire the current keying color.
         MdispInquire(MilDisplay, M_KEY_COLOR, &TransparentColor);    
                                                                      
         // Clear the overlay buffer with the keying color.           
         MbufClear(MilOverlayImage, TransparentColor); 

         // Draw MIL monochrome overlay annotation *
         //*****************************************

         // Inquire MilOverlayImage size x and y. 
         ImageWidth  = MbufInquire(MilOverlayImage,M_SIZE_X,M_NULL);
         ImageHeight = MbufInquire(MilOverlayImage,M_SIZE_Y,M_NULL);
            
         // Set graphic text to transparent background.
         MgraControl(M_DEFAULT, M_BACKGROUND_MODE, M_TRANSPARENT);

         // Set drawing color to white.
         MgraColor(M_DEFAULT, 255);

         // Print a string in the overlay image buffer.
         MgraText(M_DEFAULT, MilOverlayImage, ImageWidth/9, ImageWidth/6,    " -------------------- ");
         MgraText(M_DEFAULT, MilOverlayImage, ImageWidth/9, ImageWidth/6+25, " - MIL Overlay Text - ");
         MgraText(M_DEFAULT, MilOverlayImage, ImageWidth/9, ImageWidth/6+50, " -------------------- ");
   
         // Draw MIL color overlay annotation *
         //************************************

         // If the overlay buffer is monochrome, associate a pseudo-color 
         // LUT to the overlay display and draw color annotations.        
         if (MbufInquire(MilOverlayImage, M_SIZE_BAND, M_NULL) == 1)
            {
            // Local variables and arrays.
            MIL_ID       MILLut, MILLutChildLow, MILLutChildHigh, MILLutChildKey;
            PALETTEENTRY PalEntry;
            HDC          hDC;
            COLORREF     ColRef;
            
            // LUT data for PSEUDO-COLOR:          R    G    B     Entry:    Color: */
            static unsigned char LutLow[30] =  {   0,   0,   0, // Index 0 = black 
                                                 128,   0,   0, // Index 1 = dark-red
                                                   0, 128,   0, // Index 2 = dark-green
                                                 128, 128,   0, // Index 3 = dark-yellow
                                                   0,   0, 128, // Index 4 = dark-blue
                                                 128,   0, 128, // Index 5 = dark-magenta
                                                   0, 128, 128, // Index 6 = dark-cyan
                                                 192, 192, 192, // Index 7 = bright-grey
                                                 192, 220, 192, // Index 8 = lite-green
                                                 166, 202, 240  // Index 9 = lite-blue
                                               };
            static unsigned char LutHigh[30] = { 255, 251, 240, // Index 246 = lite-white
                                                 160, 160, 164, // Index 247 = lite-grey
                                                 128, 128, 128, // Index 248 = dark-grey
                                                 255,   0,   0, // Index 249 = red
                                                   0, 255,   0, // Index 250 = green
                                                 255, 255,   0, // Index 251 = yellow
                                                   0,   0, 255, // Index 252 = blue
                                                 255,   0, 255, // Index 253 = magenta
                                                   0, 255, 255, // Index 254 = cyan
                                                 255, 255, 255  // Index 255 = white
                                               };

            // Create a grey scale LUT with pseudo-colors in the 2 extremes. 
            // This LUT match the Windows default palette in 8 bit VGA mode  
            // and give the best results for grayscale image display with    
            // color anotations.                                             
            MbufAllocColor(((CMdispMFCApp*)AfxGetApp())->MilSystem, 3L, 256L, 1L, 8L+M_UNSIGNED, M_LUT, &MILLut);
            MbufChild2d(MILLut, 0,   0, 10,  1, &MILLutChildLow);
            MbufChild2d(MILLut, 246, 0, 10,  1, &MILLutChildHigh);
            MgenLutRamp(MILLut, 0,   0, 255, 255);
            MbufPutColor(MILLutChildLow,  M_RGB24+M_PACKED, M_ALL_BAND, &LutLow);
            MbufPutColor(MILLutChildHigh, M_RGB24+M_PACKED, M_ALL_BAND, &LutHigh);

            // Insert the transparent color in the LUT 
            hDC = ::GetDC(NULL);
            GetSystemPaletteEntries(hDC, TransparentColor, 1, &PalEntry);
            ColRef = RGB(PalEntry.peRed, PalEntry.peGreen, PalEntry.peBlue);
            MbufChild1d(MILLut, TransparentColor, 1, &MILLutChildKey);
            MbufPutColor(MILLutChildKey, (M_RGB24 | M_PACKED), M_ALL_BAND, &ColRef);
            ::ReleaseDC(NULL, hDC);

            // Associate the pseudo-color LUT to the overlay display. 
            MdispControl(MilDisplay, M_WINDOW_OVR_LUT, MILLut);

            // Free the LUT. 
            MbufFree(MILLutChildKey);
            MbufFree(MILLutChildHigh);
            MbufFree(MILLutChildLow);
            MbufFree(MILLut);
            
            // Set drawing color to the green index in the pseudo-color LUT.
            MgraColor(M_DEFAULT, 250);

            // Print a string in the overlay image buffer. 
            MgraText(M_DEFAULT, MilOverlayImage, ImageWidth*11/18, ImageWidth/6,    " -------------------- ");
            MgraText(M_DEFAULT, MilOverlayImage, ImageWidth*11/18, ImageWidth/6+25, " - MIL Overlay Text - ");
            MgraText(M_DEFAULT, MilOverlayImage, ImageWidth*11/18, ImageWidth/6+50, " -------------------- ");
            }
         else    
         // If the overlay buffer is color, draw annotations only in the 
         // selected color band to create color annotation.              
            {
            // Local variable. 
            MIL_ID MilOverlayImageGreen;

            // Create a child buffer on the green component for drawing. 
            MbufChildColor(MilOverlayImage, M_GREEN , &MilOverlayImageGreen);
            
            // Set drawing color to maximum intensity for green. 
            MgraColor(M_DEFAULT, 250);

            // Print a string in the green component overlay image buffer.
            MgraText(M_DEFAULT, MilOverlayImageGreen, ImageWidth*11/18, ImageWidth/6,    " -------------------------- ");
            MgraText(M_DEFAULT, MilOverlayImageGreen, ImageWidth*11/18, ImageWidth/6+25, " - MIL Overlay Text - ");
            MgraText(M_DEFAULT, MilOverlayImageGreen, ImageWidth*11/18, ImageWidth/6+50, " -------------------------- ");
            
            // Free the child buffer. 
            MbufFree(MilOverlayImageGreen);
            }
   
         // Draw GDI color overlay annotation *
         //************************************

         // Create a device context to draw in the overlay buffer with GDI. 
         MbufControl(MilOverlayImage, M_WINDOW_DC_ALLOC, M_DEFAULT);

         // Attach the device context.
         CDC NewDC;
         NewDC.Attach((HDC)MbufInquire(MilOverlayImage, M_WINDOW_DC, M_NULL));

         // Create a blue pen. 
         hpen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255)); 
         hpenOld = NewDC.SelectObject(&hpen);
         	
         // Draw a cross in the overlay buffer. 
         NewDC.MoveTo(0,ImageHeight/2);
         NewDC.LineTo(ImageWidth,ImageHeight/2);
         NewDC.MoveTo(ImageWidth/2,0);
         NewDC.LineTo(ImageWidth/2,ImageHeight);
         
         // Write text in the overlay buffer. 
         strcpy(chText, "GDI Overlay Text ");
         NewDC.SetTextColor(RGB(0, 0, 255));
         NewDC.TextOut(ImageWidth*3/18,ImageHeight*4/6, chText, strlen(chText));
         NewDC.SetTextColor(RGB(255, 0, 0));
         NewDC.TextOut(ImageWidth*12/18,ImageHeight*4/6, chText, strlen(chText));
         
         // Deselect and destroy the blue pen.
         NewDC.SelectObject(hpenOld);
         hpen.DeleteObject(); 
         
         // Detach the device context.
         NewDC.Detach();
         
         // Delete created device context. 
         MbufControl(MilOverlayImage, M_WINDOW_DC_FREE, M_DEFAULT);

         // Overlay is now initialized
         fOverlayIsInitialized = TRUE;
         }
      }   
   
   // Make sure that overlay is initialized
   if (fOverlayIsInitialized)
      {
      // Enable overlay
      if (OverlayIsEnable == FALSE)
         {
         // Enable the overlay display. 
         MdispControl(MilDisplay, M_WINDOW_OVR_SHOW, M_ENABLE);

         OverlayIsEnable = TRUE;
         }
      
      // Disable overlay
      else
         {
         // Disable the overlay display. 
         MdispControl(MilDisplay, M_WINDOW_OVR_SHOW, M_DISABLE);

         OverlayIsEnable = FALSE;
         }
      }
   
   
     // The following lines show how to deinitialize the overlay if necessary:
//   if (fOverlayIsInitialized)
//      {
//      // Disable the overlay display. 
//      MdispControl(MilDisplay, M_WINDOW_OVR_SHOW, M_DISABLE;
//         
//      // If the overlay buffer is monochrome, reomove the pseudo-color 
//      // LUT from the overlay display.        
//      if (MbufInquire(MilOverlayImage, M_SIZE_BAND, M_NULL) == 1)
//         {
//         // Associate a default LUT to the overlay display. 
//         MdispControl(MilDisplay, M_WINDOW_OVR_LUT, M_DEFAULT);
//         }
//
//      // Disable writing Overlay graphics on top of display buffer.
//      MdispControl(MilDisplay, M_WINDOW_OVR_WRITE, M_DISABLE);
//      }
   
   
   /////////////////////////////////////////////////////////////////////////
   // MIL: Write code that will be executed when 'add overlay' is selected
   /////////////////////////////////////////////////////////////////////////
}


void CMdispMFCView::OnUpdateOverlay(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck(OverlayIsEnable);
}


void CMdispMFCView::OnInitialUpdate() 
{

   // TODO: Add your specialized code here and/or call the base class
   
   /////////////////////////////////////////////////////////////////////////
   // MIL: Code that will be executed when a view is first attached to the document
   /////////////////////////////////////////////////////////////////////////
   if (((CMdispMFCDoc*)GetDocument())->MilImage)
   {
      // Allocate a display
      MdispAlloc(((CMdispMFCApp*)AfxGetApp())->MilSystem,	M_DEFAULT, M_DISPLAY_SETUP, M_DEFAULT, &MilDisplay);

      /* Do not allow example to run in dual screen mode */             
      if(MdispInquire(MilDisplay, M_DISPLAY_MODE, M_NULL)!=M_WINDOWED)             
      {
         MessageBox("This example does not run in dual screen mode.",
                    "MdispMFC example", MB_ICONINFORMATION );
         MdispFree(MilDisplay);
         MilDisplay = (MIL_ID) NULL;
      }

      if (MilDisplay)
      {
         // Disable scroll bars on display
   	   MdispControl(MilDisplay,M_WINDOW_SCROLLBAR,M_DISABLE);
   	   
   	   // Select the buffer from it's display object and given window
   	   MdispSelectWindow(MilDisplay, ((CMdispMFCDoc*)GetDocument())->MilImage, m_hWnd);
   	   
   	   // Get active multimedia window rectangle    
   	   MMRect.SetRect(0,0,((CMdispMFCApp*)AfxGetApp())->SizeX,((CMdispMFCApp*)AfxGetApp())->SizeY);
   	      
   	   if (!MMRect.IsRectEmpty())
   	   {		
            // Get major and minor version numbers of Windows
            DWORD dwVersion = GetVersion();
            DWORD dwWindowsMajorVersion =  (DWORD)(LOBYTE(LOWORD(dwVersion)));
            DWORD dwWindowsMinorVersion =  (DWORD)(HIBYTE(LOWORD(dwVersion)));
            
            // Check if dimension must be adjusted
            long PosOffset=0;

            // Windows NT351 check
            if ( (dwVersion < 0x80000000   ) &&
                 (dwWindowsMajorVersion==3 ) &&
                 (dwWindowsMinorVersion==51)    )
               PosOffset=0;
            else
               PosOffset=4;
               
            // Resize frame to the dimensions of the multimedia window
   	      GetParent()->CalcWindowRect(&MMRect);
   	      MMRect.OffsetRect(-MMRect.left,-MMRect.top);
 	         GetParent()->SetWindowPos(NULL, 0, 0, 
   	                             	  MMRect.right+PosOffset,
   	                             	  MMRect.bottom+PosOffset, 
   	                             	  SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE);
   	      GetParent()->InvalidateRect(NULL,FALSE);
   	   }
      }
   	
      CView::OnInitialUpdate();
   }

   /////////////////////////////////////////////////////////////////////////
   // MIL: Code that will be executed when a view is first attached to the document
   /////////////////////////////////////////////////////////////////////////
}

void CMdispMFCView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
 
   /////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when the window is destroyed
	/////////////////////////////////////////////////////////////////////////
	
    RemoveFromDisplay();
		
	/////////////////////////////////////////////////////////////////////////
	// MIL: Write code that will be executed when the window is destroyed
	/////////////////////////////////////////////////////////////////////////	
	
}

// Function used to halt the grab, deselect the buffer and free the display
void CMdispMFCView::RemoveFromDisplay()
{
   	// Halt grab if in process in THIS view
	if ((((CMdispMFCApp*)AfxGetApp())->GrabInViewPtr == this) && ((CMdispMFCApp*)AfxGetApp())->GrabIsStarted)
	{
      MdigHalt(((CMdispMFCApp*)AfxGetApp())->MilDigitizer);
    	((CMdispMFCApp*)AfxGetApp())->GrabIsStarted = FALSE;	
	}
   	
   	// Deselect the buffer from it's display object and given window 
  	if (((CMdispMFCDoc*)GetDocument())->MilImage && MilDisplay)
		MdispDeselect(MilDisplay,((CMdispMFCDoc*)GetDocument())->MilImage);
	
	// Free the display
	if (MilDisplay) MdispFree(MilDisplay);
	MilDisplay = M_NULL;
}

void CMdispMFCView::OnDraw(CDC* pDC) 
{
	// TODO: Add your specialized code here and/or call the base class
}
