; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        Genesis interpreter Command List (.cl)
; *                  Allocate a buffer, load a .tif file into it, allocate a
; *                  child in the display, then transfer the contents of
; *                  the buffer to the display.
; *
; * Used Functions:  imBufAlloc, imBufLoad, imBufChild, imBufCopy.
; *
; * Designed:        rBec
; *
; * Date:            23 May 1995
; *
; * Notes:
; *
; *******************************************************************

long dev
long thread
long srcbuf
long dstbuf

; allocate a device and a thread
imDevAlloc 0 0 NULL IM_DEFAULT &dev
imThrAlloc dev 0 &thread

; allocate source and destination buffers
imBufRestore thread "im2team.tif" IM_TIFF IM_PROC &srcbuf
imBufChild thread IM_DISP 0 0 512 480 &dstbuf

; copy source to destination
imBufCopy thread srcbuf dstbuf 0 0

; view destination contents
GenPixv dstbuf

imBufFree thread dstbuf
imBufFree thread srcbuf
imThrFree thread
imDevFree dev

freedev
freethread
freesrcbuf
freedstbuf
