; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        This script performs various imIntDyadic 
; *                  operation on integer image.
; *
; *
; *
; * Used Functions:  imIntDyadic
; *                  imBufClear
; *                  imBufCopy
; *
; * Designed:        bfournie
; *
; * Date:            17/05/95
; *
; * Notes:
; *
; *
; *******************************************************************



      ; Declare internal variables

      long dev
      long thread

      long SrcA_buf
      long SrcB_buf
      long SrcB_buf_child
      long Dst_buf
      
      long Disp_Src
      long Disp_Dst
      
      long cnt        

      ; Allocate the device and thread
      imDevAlloc 0 0 null IM_DEFAULT &dev
      imThrAlloc dev 0 &thread



      ; Allocate Source processing buffers
      imBufAlloc thread 512 480 1 IM_BYTE IM_PROC &SrcA_buf
      
      imBufAlloc thread 512 480 1 IM_BYTE IM_PROC &SrcB_buf
      imBufChild thread SrcB_buf 0 0 128 128 &SrcB_buf_child
      
      
      ; Load image to process
      imBufLoad thread "im2team.tif" IM_TIFF SrcA_buf
      
      
      
      ; Allocate Destination buffer
      imBufAlloc thread 512 480 1 IM_BYTE IM_PROC &Dst_buf
      
      
      ; Allocate Display buffer
      imBufChild thread IM_DISP_RED 0 0 512 480  &Disp_Src
      imBufChild thread IM_DISP_RED 512 0 512 480  &Disp_Dst
      
      
      ; Verify that no error occurs
      execcl "test_err.cl" thread   
      
      
      echo  " Operation to do: imIntDyadic operation - Invert "
      echo  " Press a key to end "
            
      setcnt 1
      
      while (cnt < 40)
         {   
         
         ; Perform the imIntDyadic operation - Invert
         imIntDyadic thread SrcA_buf SrcA_buf Dst_buf IM_NAND 0 

      
         ; Copy the Src and Dst buffer in the Display 
         imBufCopy thread SrcA_buf Disp_Src 0 0
         imBufCopy thread Dst_buf Disp_Dst 0 0                
         
         echoln "."
         
         setcnt ([getcnt] + 1)
         
         if( [keyhit] > 0 )
           {
           setcnt 50
           }
         
         }
         
      echo " "
         
      
      ; Verify that no error occurs
      execcl "test_err.cl" thread   
      
      
      
      echo  " Operation to do: imIntDyadic operation -"
      echo  "                  Add with a constant image "
      echo  " Press a key to end "
            
      setcnt 1
      
      imBufClear thread SrcB_buf 0x07 0
      imBufCopy thread SrcA_buf Dst_buf 0 0                

      
      while (cnt < 40)
         {   
         
         ; Perform the imIntDyadic operation - Addition
         imIntDyadic thread Dst_buf SrcB_buf Dst_buf IM_ADD 0 
      
      
         ; Copy the Src and Dst buffer in the Display 
         imBufCopy thread SrcA_buf Disp_Src 0 0
         imBufCopy thread Dst_buf Disp_Dst 0 0                
         

         setcnt ([getcnt] + 1)
         
         if( [keyhit] > 0 )
           {
           setcnt 50
           }
         
         }
         

      
      
      echo  " Operation to do: imIntDyadic operation -"
      echo  "                  Logical operation (And) with a child buffer "
      echo  "                  place at a random position "
      echo  " Press a key to end "
            
      setcnt 1
      long xpos
      long ypos
      
      while (cnt < 50)
         {   
   

         imBufClear thread SrcB_buf 0 0

         ; Free the child to replace it with absolute position
         imBufFree thread SrcB_buf_child

         ; Find the new position of child buffer (at random) 
         setxpos ([rand] / 95)
         setypos ([rand] / 95)

         
         ; Reallocate the child buffer at a new position
         imBufChild thread SrcB_buf [getxpos] [getypos] 128 128 &SrcB_buf_child
         
         imBufClear thread SrcB_buf_child 0x0ff 0
         
         ; Perform the imIntDyadic operation - logical and
         imIntDyadic thread SrcA_buf SrcB_buf Dst_buf IM_AND 0 
      
      
         ; Copy the Src and Dst buffer in the Display 
         imBufCopy thread SrcA_buf Disp_Src 0 0
         imBufCopy thread Dst_buf Disp_Dst 0 0                
         
         ; Add delay for longer effect at the screen
         delay 100
         
         
         setcnt ([getcnt] + 1)
         
         if( [keyhit] > 0 )
           {
           setcnt 50
           }
         
         }
     

      
         
      ;
      ; Free up all buffers threads and deallocate the device
      ;
      imBufFree thread SrcA_buf
      imBufFree thread SrcB_buf
      imBufFree thread SrcB_buf_child
      
      imBufFree thread Dst_buf
       
      imBufFree thread Disp_Src
      imBufFree thread Disp_Dst
       
      imThrFree thread
      imDevFree dev
      
      
      
      ; free all used variables
      freedev
      freethread
      
      freeSrcA_buf
      freeSrcB_buf
      freeSrcB_buf_child
      freeDst_buf
      
      freeDisp_Src
      freeDisp_Dst
            
      freexpos
      freeypos
