; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        This example will determine the pixel intensities
; *                  which are absent from the given image.
; *                  
; *
; * Used Functions:  imIntHistogram, imIntLocateEvent
; *
; * Designed:        VTARANTI 
; *
; * Date:            17/05/95
; *
; * Notes:           
; *
; *******************************************************************

   long        dev
   long        thread
   long        SrcBuf
   long        HistResBuf
   long        IntensityBuf
   long        NumInten
   long        Disp1Buf
   long        errorNum
   setstr      errorMsg "                                                             "
   setstr      errorFunc "                                                            "
   allocarray  Intensity   1024
   
   ; Allocate the device and thread
   imdevalloc 0 0 null im_default &dev
   imthralloc dev 0 &thread

   ; Alloc the buffers
   imbufalloc thread 512 480 1 im_ubyte im_proc &SrcBuf
   imbufalloc thread 256 1 1 im_ulong im_proc &HistResBuf
   imbufalloc thread 256 1 1 im_ulong im_proc &IntensityBuf
   
   
   ; Alloc the display child
   imbufchild thread im_disp_red 0 0 512 512 &Disp1Buf
   
   ; load the image 
   imbufload thread "logo2.tif" im_tiff SrcBuf
   imbufcopy thread SrcBuf Disp1Buf 0 0
   
   ; Check and Display any errors which have occured
   if ( [imthrgeterror thread  im_err_msg [getstrptr errorMsg]] != 0)
   {
      seterrorNum [imthrgeterror thread  im_err_func [getstrptr errorFunc]]
      echoln " The Error Code is : "
      echo [nbrtostr errorNum 10]
      echoln " The Logged Error is : "
      echo [getstr errorMsg]
      echoln " The offended function is : "
      echo [getstr errorFunc]
      return
   }
   
   
   
   ; perform the histogram
   imIntHistogram thread SrcBuf HistResBuf im_default 0
   
   ; search for zero result in Histogram Result buffer
   imIntLocateEvent thread HistResBuf IntensityBuf 0 0 IntensityBuf im_equal 0x0 0x0 0
   
   ;Obtain the number of non existent intensities
   seterrorNum [imbufgetfield thread IntensityBuf  im_res_num_events &NumInten]
   imbufget thread IntensityBuf [getarray Intensity]
   
   echoln " There are "
   echoln [nbrtostr NumInten 10]
   echo " Non existant intensities in this image "
   echo " The missing Intensities are :"
   
   
   for index 0 NumInten 1
   {
   
      echoln " Intensity Value: "
      echo [nbrtostr [getnbrarray Intensity _index] 10]
   
   }
   

   ; free all buffers
   imbuffree thread Disp1Buf
   imbuffree thread SrcBuf
   imbuffree thread HistResBuf
   imbuffree thread IntensityBuf
   imthrfree thread
   imdevfree dev

   ; free the allocated array
   freearray Intensity
   
   ; free interpreter variables
   freedev
   freethread
   freeSrcBuf
   freeHistResBuf
   freeIntensityBuf
   freeNumInten
   freeDisp1Buf
   freeerrorNum
   clearstr errorMsg 
   clearstr errorFunc
