; *******************************************************************
; *
; * COPYRIGHT (c) 1995 Matrox Electronic Systems Ltd.
; * All Rights Reserved
; *
; *******************************************************************
;
; *******************************************************************
; *
; * Synopsis:        This script performs a Lutmap operation. 
; *                  The 8 bits Lut definition is;
; *
; *                                      /--------
; *                                     / |      |
; *                              ------/  |      |
; *                              |    |   |      |
; *                              0   35  180    255
; *
; *
; * Used Functions:  imIntLutMap
; *
; *
; * Designed:        bfournie
; *
; * Date:            17/05/95
; *
; * Notes:
; *
; *
; *******************************************************************



      ; Declare internal variables

      long dev
      long thread

      long Src_buf
      long Src_buf_child
      long Dst_buf
      
      long Lut

      long Disp_Src
      long Disp_Dst
      
      long cnt        
      long tmp

      ; Allocate the device and thread
      imDevAlloc 0 0 null IM_DEFAULT &dev
      imThrAlloc dev 0 &thread



      ; Allocate Source processing buffers
      imBufAlloc thread 512 480 1 IM_BYTE IM_PROC &Src_buf
      imBufChild thread Src_buf 0 0 128 128 &Src_buf_child
      
      
      ; Load image to process
      imBufLoad thread "im2team.tif" IM_TIFF Src_buf
      
      
      
      ; Allocate Destination buffer
      imBufAlloc thread 512 480 1 IM_BYTE IM_PROC &Dst_buf
      imBufClear thread Dst_buf 0 0        
      
      
      ; Allocate Display buffer
      imBufChild thread IM_DISP_RED 0 0 512 480  &Disp_Src
      imBufChild thread IM_DISP_RED 512 0 512 480  &Disp_Dst
      
      
      ; Allocate the Lut
      imBufAlloc thread 256 1 1 IM_BYTE IM_PROC &Lut



      ; Fill the Lut with a ramp, with saturation in min/max value

      for index 0 256 1
         {
         settmp  (_index + (_index / 3))

         if(_index < 35)
            {
            settmp 35
            }

         if(_index > 190)
            {
            settmp 190
            }

         imbufput1D thread lut _index 1 &tmp
         }



      ; Verify that no error occurs
      execcl "test_err.cl" thread   
      
      
      echo  " Operation to do: imIntLutMap operation "
      echo  "                  Lut is ramp with min and max value"
      echo  " Press a key to end "
            
      setcnt 1
      
      while (cnt < 48)
         {   
         
         ; Move child buffer to be transformed
         imBufChildmove thread Src_buf_child 0 0 ([getcnt] *10) ([getcnt] *10) 
         
         
         
         ; Perform the imIntLutMap operation
         imIntLutMap thread Src_buf_child Dst_buf Lut 0
         

      
         ; Copy the Src and Dst buffer in the Display 
         imBufCopy thread Src_buf Disp_Src 0 0
         imBufCopy thread Dst_buf Disp_Dst 0 0                
         
         
         setcnt ([getcnt] + 1)
         
         if( [keyhit] > 0 )
           {
           setcnt 50
           }
         
         }
         
         
      
         
      ;
      ; Free up all buffers threads and deallocate the device
      ;
      imBufFree thread Src_buf
      imBufFree thread Src_buf_child
      
      imBufFree thread Dst_buf
       
      imBufFree thread Lut

      imBufFree thread Disp_Src
      imBufFree thread Disp_Dst
       
      imThrFree thread
      imDevFree dev
      
      
      
      ; free all used variables
      freedev
      freethread
      
      freeSrc_buf
      freeSrc_buf_child
      freeDst_buf
      
      freeLut
      
      freeDisp_Src
      freeDisp_Dst
            
      freecnt
      freetmp
