# ----------------------------------------------------------------------------
# NULL those macros to prevent a conflict with predefined environment variables
ASM            =
PP_ASM         =
COMPILER       =
CPP_COMPILER   =
PP_COMPILER    =
RC_COMPILER    =

# ----------------------------------------------------------------------------
ASM            = @echo Not supported by $(COMP_NAME) Assembler
PP_ASM         = @echo Not supported by $(COMP_NAME) Assembler

COMPILER       = @echo Not supported by $(COMP_NAME) Compiler
CPP_COMPILER   = @echo Not supported by $(COMP_NAME) Compiler
PP_COMPILER    = @echo Not supported by $(COMP_NAME) Compiler

RC_COMPILER    = rem @echo Not supported by $(COMP_NAME) Compiler

TMPRSPFILE     = $(TMPDRIVE)tmp.rsp

!if "$(DIG_ID)" == ""
GRABMODID =
!endif
!if "$(DIG_ID)" == "gen"
GRABMODID = GRAB_MODULE_0
!endif
!if "$(DIG_ID)" == "mac"
GRABMODID = GRAB_MODULE_1
!endif


# COMP_ID is defined in chkfile.awk accordingly to COMP_NAME
# If a new compiler is added change chkfile.awk if required.

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "C80"
!if "$(GRABMODID)" != ""
D_GRABMODID = -d$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -g
D_EXCEPTION    = -dD_EXCEPTION
!if "$(OPTIMIZE)" == ""
OPTIMIZE       = -o0
!else
OPTIMIZE       = -o$(OPTIMIZE)
!endif
!else
# WARNING: DON'T USE LEVEL 3 IT WILL FAIL
!if "$(OPTIMIZE)" == ""
OPTIMIZE       = -o2
!else
OPTIMIZE       = -o$(OPTIMIZE)
!endif
!endif
!if "$(GENASM)" != ""
GENASM         = -s
!endif
!if "$(PATH_PROJECT_UNX)" != ""
# UNIX compiler
LOGOUTPUT      = $(LOGOUTPUTFILE)
# Response file must preceed any other switch
ASM            = $(RAMDRIVE)mp_asm /r $(TMPRSPFILE) $(DEBUG) $(D_EXCEPTION) -fo $@ $<
PP_ASM         = $(RAMDRIVE)pp_asm /r $(TMPRSPFILE) $(DEBUG) $(D_EXCEPTION) -fo $@ $<
COMPILER       = $(RAMDRIVE)mp_cl /r $(TMPRSPFILE) -mv $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(GENASM) -fr $(OBJDIR) -eo .obj $<
PP_COMPILER    = $(RAMDRIVE)pp_cl /r $(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(GENASM) -fr $(OBJDIR) -eo .o $<
LIB_METHOD     = single
FILEINLIB      = $@
LIBRARIAN      = $(RAMDRIVE)mvp_ar rq
!else
# NT compiler
# No response file possible with NT TI Tools
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = mpasm.exe $< $(FASTTMPDRIVE)$@ $(D_EXCEPTION) $(ASM_OPTION)
PP_ASM         = ppasm.exe $< $(FASTTMPDRIVE)$@ $(D_EXCEPTION) $(ASM_OPTION)
COMPILER       = mpcl.exe -mv $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -fr $(FASTTMPDRIVE)$(OBJDIR) -eo .obj $<
PP_COMPILER    = ppcl.exe $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(GENASM) -fr $(FASTTMPDRIVE)$(OBJDIR) -eo .o $<
LIB_METHOD     = multiple
FILEINLIB      = $(FASTTMPDRIVE)$@
LIBRARIAN      = mvpar.exe rq
!endif
!endif

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "WATCOM"
!if "$(GRABMODID)" != ""
D_GRABMODID = -d$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -d2
D_EXCEPTION    = -dD_EXCEPTION
OPTIMIZE       = -od
!else
OPTIMIZE       =
!endif
!if "$(GENASM)" != ""
GENASM         =
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = wasm.exe /d_IM_COMP_WATCOM $(DEBUG:-v=/zi) /5ps /fpc /w1 /mf $< /fo=$(FASTTMPDRIVE)$@
COMPILER       = wpp386.exe @$(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -fr=NUL -fo$(FASTTMPDRIVE)$@ $<
CPP_COMPILER   = $(COMPILER)
LIB_METHOD     = tmpfile
FILEINLIB      = -+$(FASTTMPDRIVE)$@
LIBRARIAN      = wlib.exe -b -q
!endif

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "BC45++"
!if "$(GRABMODID)" != ""
D_GRABMODID = -D$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -v
D_EXCEPTION    = -DD_EXCEPTION
OPTIMIZE       =
!else
OPTIMIZE       =
!endif
!if "$(GENASM)" != ""
GENASM         = -S
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = tasm32.exe /d_IM_COMP_BC45 $(DEBUG:-v=/zi) /w /ml $<, $(FASTTMPDRIVE)$@, NUL, NUL;
COMPILER       = bcc32.exe @$(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -o$(FASTTMPDRIVE)$@ $<
CPP_COMPILER   = $(COMPILER)
LIB_METHOD     = tmpfile
FILEINLIB      = -+$(FASTTMPDRIVE)$@
LIBRARIAN      = tlib.exe
!endif

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "BC++"
!if "$(GRABMODID)" != ""
D_GRABMODID = -d$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -v
D_EXCEPTION    = -DD_EXCEPTION
OPTIMIZE       =
!else
OPTIMIZE       =
!endif
!if "$(GENASM)" != ""
GENASM         = -S
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = tasm.exe /d_IM_COMP_BC $(DEBUG:-v=/zi) /w1 /ml $<, $(FASTTMPDRIVE)$@, NUL, NUL;
COMPILER       = bcc.exe @$(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -o$(FASTTMPDRIVE)$@ $<
CPP_COMPILER   = $(COMPILER)
LIB_METHOD     = tmpfile
FILEINLIB      = -+$(FASTTMPDRIVE)$@
LIBRARIAN      = tlib.exe
!endif

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "VC++"
!if "$(GRABMODID)" != ""
D_GRABMODID = /D$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = /Z7
D_EXCEPTION    = /DD_EXCEPTION
OPTIMIZE       = /Odi
!else
OPTIMIZE       = /Ox
!endif
!if "$(GENASM)" != ""
GENASM         = /Fa
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = tasm.exe /d_IM_COMP_MICROSOFT $(DEBUG:/Z7=/zi) /w1 /ml $<, $(FASTTMPDRIVE)$@, NUL, NUL;
!if "$(PURE_C)" != ""
COMPILER       = cl.exe /nologo @$(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) /Fo$(FASTTMPDRIVE)$@ $<
!else
COMPILER       = cl.exe /nologo @$(TMPRSPFILE) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) /Fo$(FASTTMPDRIVE)$@ /Tp$<
!endif
CPP_COMPILER   = $(COMPILER)
RC_COMPILER    = rc.exe /fo $@ $<
LIB_METHOD     = multiple
FILEINLIB      = $(FASTTMPDRIVE)$@ $(OBJDIR)\*.lib
LIBRARIAN      = lib.exe /NOLOGO
!endif

# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "PPC"
!if "$(REVISION)" != ""
TMPRSPFILE     = $(TMPDRIVE)\obj\$(OBJDIR)\..\tmp.rsp
!else
TMPRSPFILE     = $(TMPDRIVE)\obj\$(OBJDIR)\tmp.rsp
!endif
TMPRSPFILE     = $(TMPRSPFILE:.MAC=)
TMPRSPFILE     = $(TMPRSPFILE:.GEN=)
TMPRSPFILE     = $(TMPRSPFILE:.mac=)
TMPRSPFILE     = $(TMPRSPFILE:.gen=)
!if "$(GRABMODID)" != ""
D_GRABMODID = -D$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -g
D_EXCEPTION    = -DD_EXCEPTION
AD_EXCEPTION   = -DD_EXCEPTION=1
OPTIMIZE       = -opt none
!else
AD_EXCEPTION   = -DD_EXCEPTION=0
OPTIMIZE       = -opt full
!endif
!if "$(GENASM)" != ""
GENASM         = -dis
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = mwasmeppc -prefix $(TMPRSPFILE) $(ASM_OPTION) $(DEBUG) $(AD_EXCEPTION) -o $(FASTTMPDRIVE)$@ $<
COMPILER       = mwcceppc  -prefix $(TMPRSPFILE) $(C_OPTION) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -o $(FASTTMPDRIVE)$@ $<
CPP_COMPILER   = $(COMPILER)
LIB_METHOD     = allobjects
FILEINLIB      = $(FASTTMPDRIVE)$@
LIBRARIAN      = mwldeppc -nostdlib -xml -little -o
!endif
# ----------------------------------------------------------------------------
!if "$(COMP_ID)" == "MWPPC"
!if "$(GRABMODID)" != ""
D_GRABMODID = -D$(GRABMODID)
!endif
!if "$(DEBUG_INFO)" != ""
DEBUG          = -g
#D_EXCEPTION    = -DD_EXCEPTION -DMETAWARE_SMALL_DEBUG
D_EXCEPTION    = -DD_EXCEPTION
OPTIMIZE       = -O0
!else
OPTIMIZE       = -O7 -Hoff=Behaved
!endif
!if "$(GENASM)" != ""
GENASM         = -S -Hanno -Hoff=DWARF_SUPPORTS_SFNAMES
!endif
LOGOUTPUT      = >$(LOGOUTPUTFILE)
ASM            = asppc  @$(TMPRSPFILE) $(ASM_OPTION) $(D_EXCEPTION) -D__HIGHC__ -o $(FASTTMPDRIVE)$@ -c -Eo -diab -le $<
COMPILER       = hcppc  @$(TMPRSPFILE) $(C_OPTION) $(DEBUG) $(OPTIMIZE) $(D_EXCEPTION) $(D_GRABMODID) $(GENASM) -Hobjdir=$(OBJDIR) -Hsuffix=.obj -Hnocopyr -Hefile=@ -Hasopt=-Eo $<
CPP_COMPILER   = $(COMPILER)
LIB_METHOD     = multiple
FILEINLIB      = $(FASTTMPDRIVE)$@
LIBRARIAN      = arppc -r
!endif
