# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}

# Print available compiler for imcc
# fileToCheck is of the form: $(path_project)\sw\util\imccfile\*.set

BEGIN {
   if (ARGC < 2)
      {
      printf "gawk -f compset.awk [fileToCheck|\"*.ext\"]\n"
      exit 0
      }

   fileToCheck = ARGV[1]
   ARGV[1] = ""

   # If no path provide use BATCH path
   if (index(fileToCheck, "*") == 1)
      fileToCheck = GetEnviron("BATCH")"imccfile\\"fileToCheck

   CurrentWorkingDir = tolower(getcwd())

   split(CurrentWorkingDir, curWorkDir, ":")
   CWD = curWorkDir[1]":"

   split(GetEnviron("RAMDRIVE"), curWorkDir, ":")
   RAMDRIVE = curWorkDir[1]":"

   for (ii in curWorkDir)
      delete curWorkDir[ii]

   split(fileToCheck, imccDir, "\*")

   if (index(tolower(fileToCheck), ".set") != 0)
      printf "\nAvailable Compiler in '%s' directory ...\n", imccDir[1]
   else if (index(tolower(fileToCheck), ".fmt") != 0)
      printf "\nAvailable Format for linker in '%s' directory ...\n", imccDir[1]
   else
      printf "\nUnknown file type\n"

   for (ii in imccDir)
      delete imccDir[ii]

   ndx = 0

   PipeTmp = RAMDRIVE"compset.pip"
   system("dir /B /On "fileToCheck">"PipeTmp)

   while (getline<PipeTmp > 0)
      {
      if ((ndx++ % 4) == 0)
         printf "\n"
      split($1, compiler, ".")
      printf "%10s", toupper(compiler[1])

      for (ii in compiler)
         delete compiler[ii]
      }

   close(PipeTmp)
   system("del "PipeTmp">NUL")

   printf "\n"
}
