# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}

# --------------------------------------------------------------------------
function GetReplacementKeyword(fileToConvert, other)
{
   other[0] = ""
   other[1] = ""
   other[2] = ""

   # First search replacement keywords: $(...)
   while(validLine = getline<fileToConvert > 0)
      {
      if (((index(toupper(fileToConvert), ".FMT") != 0) || (index(toupper(fileToConvert), ".LCF") != 0)) && match($0, /\$\(DEBUG\)|\$\(OBJ\)|\$\(BIN\)|\$\(MAP\)|\$\(LIB\)|\$\(OUT\)|\$\(DEF\)|\$\(RAM_SIZE\)|\$\(RAMX\)|\$\(RAMX_SIZE\)/))
         # Ignore those $(...) in .FMT file, used by imlk
         $0 = ""

      else if (index($0, "$(") != 0)
         {
         # Search replacement keywords
         nbf = split($0, tmpstr, "[\(\)]")

         for (ndx=1; ndx<=nbf; ndx++)
            {
            if (index(tmpstr[ndx], "$") != 0)
               {
               ndx++

               for (ii=0; ii<globalWordNdx; ii++)
                  {
                  if (globalWord[0,ii] == tmpstr[ndx])
                     break
                  }

               if (ii == globalWordNdx)
                  {
                  globalWord[0, globalWordNdx]   = tmpstr[ndx]
                  globalWord[1, globalWordNdx++] = "$("tmpstr[ndx]")"
                  }
               }
            }

         for (ii in tmpstr)
            delete tmpstr[ii]
         }

      else if (index($0, "RSPFILE=") != 0)
         {
         # Found only in .SET file
         nbf = split($0, tmpstr, "=")

         if (tmpstr[2] != "")
            other[0] = toupper(tmpstr[2])

         for (ii in tmpstr)
            delete tmpstr[ii]
         }

      else if (index($0, "LNKFORMAT=") != 0)
         {
         # Found only in .SET file
         nbf = split($0, tmpstr, "=")

         if (tmpstr[2] != "")
            other[1] = toupper(tmpstr[2])".FMT"

         if (index(tolower($0), "ppc") != 0)
            other[2] = toupper(tmpstr[2])".LCF"

         for (ii in tmpstr)
            delete tmpstr[ii]
         }
      }

   close(fileToConvert)
}


# --------------------------------------------------------------------------
function GetKeywordValue(fileToConvert)
{
   # Second scan file for definition of replacement keywords
   while(validLine = getline<fileToConvert > 0)
      {
      for (ndx=0; ndx<globalWordNdx; ndx++)
         {
         if (GetEnviron(globalWord[0,ndx]) != "")
            {
            # Environment variable is used instead

            if (tolower(globalWord[0,ndx]) == globalWord[0,ndx])
               globalWord[1,ndx] = tolower(GetEnviron(globalWord[0,ndx]))
            else
               globalWord[1,ndx] = toupper(GetEnviron(globalWord[0,ndx]))
            }
         else
            {
            if (index(tolower($0), tolower(globalWord[0,ndx])"=") != 0)
               {
               nbf = split($0, tmpstr, "=")

               # Use that Keyword value only if defined to something
               if (tmpstr[2] != "")
                  {
                  if (tolower(globalWord[0,ndx]) == globalWord[0,ndx])
                     globalWord[1,ndx] = tolower(tmpstr[2])
                  else
                     globalWord[1,ndx] = toupper(tmpstr[2])
                  }

               for (ii in tmpstr)
                  delete tmpstr[ii]
               }
            }
         }
      }

   close(fileToConvert)

   # Resolve recurrent setting
   for (ndx=0; ndx<globalWordNdx; ndx++)
      {
      if (index(globalWord[1,ndx], "$(") != 0)
         {
         nbf = split(globalWord[1,ndx], tmpstr, "[\(\)]")

         for (fndx=1; fndx<=nbf; fndx++)
            {
            if (index(tmpstr[fndx], "$") != 0)
               {
               fndx++

               for (_ndx=0; _ndx<globalWordNdx; _ndx++)
                  {
                  if (toupper(tmpstr[fndx]) == toupper(globalWord[0,_ndx]))
                     {
                        subst_st = "\\$\\("tolower(globalWord[0,_ndx])"\\)"
                        gsub(subst_st, tolower(globalWord[1,_ndx]), globalWord[1,ndx])

                        subst_st = "\\$\\("toupper(globalWord[0,_ndx])"\\)"
                        gsub(subst_st, toupper(globalWord[1,_ndx]), globalWord[1,ndx])
                     }
                  }
               }
            }

         for (ii in tmpstr)
            delete tmpstr[ii]
         }
      }
}

# --------------------------------------------------------------------------
function ConvertFile(fileToConvert, outputTo)
{
   # Thirds replace all occurences of replacement keywords in file and print
   while(validLine = getline<fileToConvert > 0)
      {
      if (index($0, "$(") != 0)
         {
         for (ndx=0; ndx<globalWordNdx; ndx++)
            {
            subst_st = "\\$\\("globalWord[0,ndx]"\\)"
            gsub(subst_st, globalWord[1,ndx], $0)
            }
         }

      if ($0 != "")
         print $0 >outputTo
      }

   close(fileToConvert)
   close(outputTo)
}

# --------------------------------------------------------------------------
function CreateTmpDir(inThisDrive, fileName)
{
   # Forth create temporary directory for each compiler

   tmpBaseDir = inThisDrive"\\obj"

   if (ifexist(tmpBaseDir) == 0)
      system("md "tmpBaseDir)

   while(validLine = getline<fileName > 0)
      {
      if (index($0, "OBJDIR") == 1)
         {
         split($0, thisSubDir, "=")

         if (ifexist(tmpBaseDir"\\"thisSubDir[2]) == 0)
            {
            system("md "tmpBaseDir"\\"thisSubDir[2])
            system("md "tmpBaseDir"\\"thisSubDir[2]"\\src")
            }

         for (ii in thisSubDir)
            delete thisSubDir[ii]
         }
      }

   close(fileName)
}


# Scan a file and replace all occurences of $(...) with the appropriate
# value. If an environment variable exist for that replacement keyword
# it is used instead of the one that may be defined in the input file.
#
# If $(...) is in lower case, replacement is done in lower case else,
# replacement is done in upper case.
#

BEGIN {
   if (ARGC < 2)
      {
      printf "gawk -f instcomp.awk [pathOut]\n"
      exit 0
      }

   pathOut = ARGV[1]
   ARGV[1] = ""

   CurrentWorkingDir = tolower(getcwd())

   split(CurrentWorkingDir, curWorkDir, ":")
   CWD = curWorkDir[1]":"

   split(GetEnviron("RAMDRIVE"), curWorkDir, ":")
   RAMDRIVE = curWorkDir[1]":"

   for (ii in curWorkDir)
      delete curWorkDir[ii]

   imccPath = GetEnviron("BATCH")"imccfile"

   otherFiles[0] = dummy[0] = "FILE000.RSP"
   otherFiles[1] = dummy[1] = "FILE000.FMT"
   otherFiles[2] = dummy[2] = "FILE000.LCF"

   PipeTmp = RAMDRIVE"instcomp.pip"
   system("dir /B "imccPath"\\*.set>"PipeTmp)

   while (getline<PipeTmp > 0)
      {
      fileName = $0

      globalWordNdx = 0

      globalWord[0,globalWordNdx] = ""
      globalWord[1,globalWordNdx] = ""
      globalWord[2,globalWordNdx] = ""

      # First get all possible replacement keywords - $(...)
      # in .SET, .RSP, .FMT, and .LCF files
      GetReplacementKeyword(imccPath"\\"fileName,      otherFiles)
      GetReplacementKeyword(imccPath"\\"otherFiles[0], dummy)           # .RSP
      GetReplacementKeyword(imccPath"\\"otherFiles[1], dummy)           # .FMT
      GetReplacementKeyword(imccPath"\\"otherFiles[2], dummy)           # .LCF

      # Second scan .SET file for definition of replacement keywords
      GetKeywordValue(imccPath"\\"fileName)

      # Thirds replace all occurences of replacement keywords in files
      ConvertFile(imccPath"\\"fileName,      pathOut""fileName)
      ConvertFile(imccPath"\\"otherFiles[0], pathOut""otherFiles[0])    # .RSP
      ConvertFile(imccPath"\\"otherFiles[1], pathOut""otherFiles[1])    # .FMT
      ConvertFile(imccPath"\\"otherFiles[2], pathOut""otherFiles[2])    # .LCF

      # Forth create temporary directory for each compiler
      CreateTmpDir(RAMDRIVE, RAMDRIVE"\\"fileName)

      for (ii in globalWord)
         {
         delete globalWord[ii]
         delete globalWord[ii]
         }
      }

   close(PipeTmp)
   system("del "PipeTmp">NUL")
}
