# --------------------------------------------------------------------------
function GetEnviron(var)
{
   if (var in ENVIRON)
      return(ENVIRON[var])

   _var_ = tolower(var)
   for (varndx in ENVIRON)
      {
      if (tolower(varndx) == _var_)
         return(ENVIRON[varndx])
      }

   return("")
}

# --------------------------------------------------------------------------
function asciiToVal(val)
{
   decValue = 0

   val = tolower(val)
   if (match(val, /0x/) != 0)
      {
      split(val, value, "x")

      gsub(/0/, "0 ", value[2])
      gsub(/1/, "1 ", value[2])
      gsub(/2/, "2 ", value[2])
      gsub(/3/, "3 ", value[2])
      gsub(/4/, "4 ", value[2])
      gsub(/5/, "5 ", value[2])
      gsub(/6/, "6 ", value[2])
      gsub(/7/, "7 ", value[2])
      gsub(/8/, "8 ", value[2])
      gsub(/9/, "9 ", value[2])
      gsub(/a/, "10 ", value[2])
      gsub(/b/, "11 ", value[2])
      gsub(/c/, "12 ", value[2])
      gsub(/d/, "13 ", value[2])
      gsub(/e/, "14 ", value[2])
      gsub(/f/, "15 ", value[2])

      nbf = split(value[2], digit, " ")

      for (ii=1; ii<=nbf; ii++)
         {
         decValue *= 16
         decValue += digit[ii]+0
         }

      return(decValue)
      }
   else
      {
      exit(1)
      }
}

# --------------------------------------------------------------------------
function normalizeName(targetName)
{
   if (match(targetName, /^\.|\~|\\|\/|\:/) == 0)
      return "$(SPECIAL_CASE)"tolower(targetName)
   else
      {
      for (chNdx=length(targetName); chNdx>0; chNdx--)
         {
         if (match(substr(targetName, chNdx), /\:|\\|\//) != 0)
            break
         }

      return substr(tolower(targetName),1,chNdx)"$(SPECIAL_CASE)"substr(tolower(targetName), chNdx+1)
      }
}

# --------------------------------------------------------------------------
function addItemInLists(objToAdd, nf_objdir, objdir)
{
   gsub(/ /, "", objToAdd)
   gsub(/\$\(OBJDIR\.DIG_ID\)/, "$(objdir.dig_id)", objToAdd)
   gsub(/\$\(OBJDIR\)/, "$(objdir)", objToAdd)
   gsub(/\$\(REV\)/, "$(rev)", objToAdd)
   gsub(/\$\(DIG_ID\)/, "$(dig_id)", objToAdd)
   gsub(/\\\$\(objdir\.dig_id\)/, ".$(dig_id)\\$(objdir)", objToAdd)

   nbfield = split(objToAdd, obj_to_add, "#")

   if (nbfield > 1)
      objToAdd = obj_to_add[1]

   if (index(tolower(objToAdd), "$(genesis)") != 0)
      {
      objToAdd = tolower(objToAdd)
      gsub(/\$\(genesis\)/, tolower(GetEnviron("GENESIS")), objToAdd)
      }

   nbfield = split(objToAdd, obj_to_add, "\\")

   if (nbfield > 0 && index(objToAdd, "#") == 0)
      {
      objname = tolower(obj_to_add[nbfield])      # OBJ name
      subpath = ""
      subobj  = ""

      if (nbfield >= 2)
         {
         subpath = tolower(obj_to_add[nbfield-1])    # subpath is for tool
         if (nbfield > 2)
            subobj  = tolower(obj_to_add[nbfield-2]) # subobj is where subpath is stored
         else
            subobj  = ""

         if (subpath == "$(rev)")      # a revision is present
            {
            subpath = tolower(obj_to_add[nbfield-2]) # subpath is for tool
            subobj  = tolower(obj_to_add[nbfield-3]) # subobj is where subpath is stored
            }
         }

      split(objname, tmpstr, "\.")
      objext = tmpstr[2]

      for (ndx in tmpstr)
         delete tmpstr[ndx]

      if (index(objToAdd, ":") != 0)
         driveStr = ""
      else
         driveStr = "$(drive)"

      if (subpath == objdir[nf_objdir] || subpath == "$(objdir)")
         {
         # Add release path if necessary
         gsub(/\$\(rev\)\\/, release, objToAdd)

         if (index(subobj, "obj") == 1)    # valid for obj || obj.???
            {
            # OBJ already defined in path, use end of OBJDIR to complete path
            for (ndx=0; ndx<nf_objdir; ndx++)
               {
               if (index(objdir[ndx], "obj") == 1)    # valid for obj || obj.???
                  break;
               }

            if (ndx == nf_objdir)
               error("[objdir] parameter must have subpath 'obj' in it!\n")

            tmp_buf = ""
            for (++ndx; ndx<=nf_objdir; ndx++)
               {
               tmp_str = tmp_buf"/"objdir[ndx]     # Use / instead, because \ is confusing for gsub()
               tmp_buf = tmp_str
               }

            sub(/[\\\/]/, "", tmp_buf)

            gsub(/\$\(objdir\)/, tmp_buf, objToAdd)
            }
         else
            {
            # replace $(objdir) by default path
            gsub(/\$\(objdir\)/, auto_obj, objToAdd)
            }

         if (DigDirPath == "" && GetEnviron("DIG_ID") != "")
            DigDirPath = tolower(GetEnviron("DIG_ID"))

         gsub(/ /,   "", DigDirPath)

         IsDigPath = index(objToAdd, "$(dig_id)")

         if (DigDirPath != "" && IsDigPath != 0)
            {
            gsub(/\\$/, "", DigDirPath)
            gsub(/\$\(dig_id\)/, DigDirPath, objToAdd)
            }

         else if (DigDirPath == "" && IsDigPath != 0)
            gsub(/\$\(dig_id\)/, "gen", objToAdd)   # Default digitizer directory for Genesis

         for (ndx_elem=0; ndx_elem<nb_rd_elem; ndx_elem++)
            {
            if (!IsDigPath && index(objToAdd, "\\obj.") == 0 && objname == definedObj[ndx_elem])
               break
            }

         if (ndx_elem == nb_rd_elem)
            {
            definedObj[nb_rd_elem++] = objname

            # if .\ or ..\ in first column use currentDrive
            if (index(objToAdd, ".\\") == 1 || index(objToAdd, "..\\") == 1)
               {
               if (objext != "lib" && objext != "out")
                  obj_list[nb_obj_elem++] = driveStr""currentDrive[2]"\\"tolower(objToAdd)
               else
                  lib_list[nb_lib_elem++] = driveStr""currentDrive[2]"\\"tolower(objToAdd)
               }
            else
               {
               if (objext != "lib" && objext != "out")
                  obj_list[nb_obj_elem++] = driveStr""tolower(objToAdd)
               else
                  lib_list[nb_lib_elem++] = driveStr""tolower(objToAdd)
               }
            }
         else
            printf "Duplicate  : %s\n", tolower(objToAdd) >dupfile
         }
      else
         {
         # No $(objdir) defined and path different
         gsub(/\$\(objdir\)/, auto_obj, objToAdd)

         if (subpath != "" && index(objToAdd, ":") == 0 && index(objToAdd, ".\\") != 1 && index(objToAdd, "..\\") != 1)
            printf "Wrong type : %s\n", tolower(objToAdd) >dupfile
         else
            {
            if (subpath == "" || index(objToAdd, ":") != 0)
               {
               if (objext != "lib" && objext != "out")
                  obj_list[nb_obj_elem++] = tolower(objToAdd)
               else
                  lib_list[nb_lib_elem++] = tolower(objToAdd)
               }
            else if (subpath == "" || index(objToAdd, ".\\") == 1 || index(objToAdd, "..\\") == 1)
               {
               if (objext != "lib" && objext != "out")
                  obj_list[nb_obj_elem++] = driveStr""currentDrive[2]"\\"tolower(objToAdd)
               else
                  lib_list[nb_lib_elem++] = driveStr""currentDrive[2]"\\"tolower(objToAdd)
               }
            }
         }
      }
}

# --------------------------------------------------------------------------
function getListe(fname)
{
   tmpFname = tolower(fname)

   if (index(tmpFname, "$(") == 1 && index(tmpFname, "$(objdir") == 0)  # invalid for $(objdir) && $(objdir.dig_id)
      {
      gsub(/\$\(/, "", fname)
      gsub(/\)/, "", fname)

      fname = GetEnviron(fname)
      }

   nf_objdir = split(auto_obj, objdir, "[\\\/]")

   if (index(tolower(fname), "\.obj") == 0 && index(tolower(fname), "\.out") == 0 && index(tolower(fname), "\.o") == 0 && index(tolower(fname), "\.lib") == 0 && index(tolower(fname), "\.res") == 0)
      {
      # OK Probably a link list

      checkFile(fname, "link list")

      while (getline<fname > 0)
         {
         addItemInLists($0, nf_objdir, objdir)
         }
      }
   else
      {
      # An object or a library was provided in place of a link list

      addItemInLists(fname, nf_objdir, objdir)
      }

   for (ndx in objdir)
      delete objdir[ndx]

   close(fname)
}


# --------------------------------------------------------------------------
function setDrive(drive)
{
   split(GetEnviron("PATH_PROJECT"), pathProj, ":")

   subPathProj = GetEnviron("PATH_PROJECT")
   gsub(/\\/, "\\\\", subPathProj)

   if (symbolicinfo == "/d")
      printf "With symbolic information in target\n"

   for (ndx=0; ndx<nb_obj_elem; ndx++)
      {
      gsub(/\$\(drive\)/, drive, obj_list[ndx])

      if (os == "/u")
         gsub(subPathProj, drive, obj_list[ndx])
      }

   for (ndx=0; ndx<nb_lib_elem; ndx++)
      {
      gsub(/\$\(drive\)/, drive, lib_list[ndx])

      if (os == "/u")
         gsub(subPathProj, drive, lib_list[ndx])
      }

   split(targetfile, tfile, ":")

   if (os == "/u")
      {
      if (tfile[1] == pathProj[1])
         targetfile = drive""tfile[2]
      else
         error("Current DOS drive must be "GetEnviron("PATH_PROJECT"))
      }

   for (ndx in tfile)
      delete tfile[ndx]

   for (ndx in pathProj)
      delete pathProj[ndx]
}


# --------------------------------------------------------------------------
function toUnix()
{
   for (ndx=0; ndx<nb_obj_elem; ndx++)
      gsub(/\\/, "/", obj_list[ndx])

   for (ndx=0; ndx<nb_lib_elem; ndx++)
      gsub(/\\/, "/", lib_list[ndx])

   gsub(/\\/, "/", targetfile)
}


# --------------------------------------------------------------------------
function toDos()
{
   for (ndx=0; ndx<nb_obj_elem; ndx++)
      gsub(/\//, "\\", obj_list[ndx])

   for (ndx=0; ndx<nb_lib_elem; ndx++)
      gsub(/\//, "\\", lib_list[ndx])

   gsub(/\//, "\\", targetfile)
}


# --------------------------------------------------------------------------
function error(s)
{
   printf("Error:\n%s\n", s)
   err = 1
   exit 1
}


# --------------------------------------------------------------------------
function checkFile(fname, type)
{
   if (ifexist(fname) == 0)
      {
      str = sprintf("File %s is not a valid %s", fname, type)
      error(str)
      }
}


# --------------------------------------------------------------------------
function BORLANDlink()
{
   # Create batch to link for BORLAND

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".exe"
   else if (targettype == "dll")
      targetname = targetfile".dll"
   else if (targettype == "lib")
      targetname = targetfile".lib"

   if (dolnk != "CON")
      {
      printf "tlink.exe @%s >%s\n", lnkrspfile, logFile >dolnk
      }


   # $(DEBUG)
   # [options] c0pl.obj+
   # $(OBJ)
   # $(BIN)
   # $(MAP)
   # $(LIB)
   # [$(DEF)]

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         if (nb_obj_elem > 0)
            {
            ndx = 0
            if (nb_obj_elem > 1)
               {
               for (ndx=0; ndx<nb_obj_elem-1; ndx++)
                  printf "%s+\n", obj_list[ndx] >lnkrspfile
               }

            printf "%s\n", obj_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(LIB)") != 0)
         {
         if (nb_lib_elem > 0)
            {
            if (nb_lib_elem > 1)
               {
               for (ndx=0; ndx<nb_lib_elem-1; ndx++)
                  printf "%s+\n", lib_list[ndx] >lnkrspfile
               }

            printf "%s", lib_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         printf "%s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "%s.map\n", targetfile >lnkrspfile
         }

      else if (index($0, "$(DEF)") != 0)
         {
         if (deffile != "")
            printf "\n%s", deffile >lnkrspfile
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "/v", $0)
         else
            gsub(/\$\(DEBUG\)/, "", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(") != 0)
         {
         error("Wrong option")
         }

      else
         {
#         if (index($0, "FILE") != 0)
#            {
#            for (ndx=0; ndx<nb_obj_elem; ndx++)
#               {
#               if (tolower($2) == tolower(obj_list[ndx]))
#                  break    # Duplicate between response file and link list
#               }
#
#            # if no duplicate, add OBJECT file to response file
#            if (ndx == nb_obj_elem)
#               printf "%s\n", $0 >lnkrspfile
#            }
#         else if (index($0, "LIBRARY") != 0)
#            {
#            for (ndx=0; ndx<nb_lib_elem; ndx++)
#               {
#               if (tolower($2) == tolower(lib_list[ndx]))
#                  break    # Duplicate between response file and link list
#               }
#
#            # if no duplicate, add LIBRARY file to response file
#            if (ndx == nb_lib_elem)
#               printf "%s\n", $0 >lnkrspfile
#            }
#         else
            printf "%s\n", $0 >lnkrspfile
         }
      }
}

# --------------------------------------------------------------------------
function BC45link()
{
   # Create batch to link for BC45

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".exe"
   else if (targettype == "dll")
      targetname = targetfile".dll"
   else if (targettype == "lib")
      targetname = targetfile".lib"

   if (dolnk != "CON")
      {
      printf "tlink32.exe -Tpe -ax @%s >%s\n", lnkrspfile, logFile >dolnk
      }


   # $(DEBUG)
   # [options] c0pl.obj+
   # $(OBJ)
   # $(BIN)
   # $(MAP)
   # $(LIB)
   # [$(DEF)]

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         if (nb_obj_elem > 0)
            {
            ndx = 0
            if (nb_obj_elem > 1)
               {
               for (ndx=0; ndx<nb_obj_elem-1; ndx++)
                  printf "%s+\n", obj_list[ndx] >lnkrspfile
               }

            printf "%s\n", obj_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(LIB)") != 0)
         {
         if (nb_lib_elem > 0)
            {
            if (nb_lib_elem > 1)
               {
               for (ndx=0; ndx<nb_lib_elem-1; ndx++)
                  printf "%s+\n", lib_list[ndx] >lnkrspfile
               }

            printf "%s", lib_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         printf "%s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "%s.map\n", targetfile >lnkrspfile
         }

      else if (index($0, "$(DEF)") != 0)
         {
         if (deffile != "")
            printf "\n%s", deffile >lnkrspfile
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "/v", $0)
         else
            gsub(/\$\(DEBUG\)/, "", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(") != 0)
         {
         error("Wrong option")
         }

      else
         {
#         if (index($0, "FILE") != 0)
#            {
#            for (ndx=0; ndx<nb_obj_elem; ndx++)
#               {
#               if (tolower($2) == tolower(obj_list[ndx]))
#                  break    # Duplicate between response file and link list
#               }
#
#            # if no duplicate, add OBJECT file to response file
#            if (ndx == nb_obj_elem)
#               printf "%s\n", $0 >lnkrspfile
#            }
#         else if (index($0, "LIBRARY") != 0)
#            {
#            for (ndx=0; ndx<nb_lib_elem; ndx++)
#               {
#               if (tolower($2) == tolower(lib_list[ndx]))
#                  break    # Duplicate between response file and link list
#               }
#
#            # if no duplicate, add LIBRARY file to response file
#            if (ndx == nb_lib_elem)
#               printf "%s\n", $0 >lnkrspfile
#            }
#         else
            printf "%s\n", $0 >lnkrspfile
         }
      }
}



# --------------------------------------------------------------------------
function MICROSOFTlink()
{
   # Create batch to link for MICROSOFT

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".exe"
   else if (targettype == "dll")
      {
      targetname = targetfile".dll"
      dexname = targetfile".dex"
      defname = targetfile".def"

      if (release != "")
         {
         subsStr = "\\\\"release"\\"
         gsub(subsStr, "\\", dexname)
         gsub(subsStr, "\\", defname)
         }
      }
   else if (targettype == "lib")
      targetname = targetfile".lib"

   if (dolnk != "CON")
      {
      printf "link.exe @%s >%s\n", lnkrspfile, logFile >dolnk
      printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk

      if (dexname != "")
         {
         printf "dumpbin /EXPORTS %s >%s\n", targetname, dexname >dolnk
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         }

      if (deffile == "" && ifexist(defname))
         {
         # Strip or add new entry
         print GetEnviron("RAMDRIVE")"gawk -f "GetEnviron("RAMDRIVE")"strpdef.awk "defname" > NUL" >dolnk
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         print "copy "GetEnviron("RAMDRIVE")"obj\\"GetEnviron("OBJDIR")"\\tmp.def "defname" > NUL" >dolnk

         # Relink with that DEF file.
         printf "link.exe @%s /DEF:%s >%s\n", lnkrspfile, defname, logFile >dolnk
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         if (dexname != "")
            {
            printf "dumpbin /EXPORTS %s >%s\n", targetname, dexname >dolnk
            printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk

            if (symbolicinfo == "" && GetEnviron("IMAGEBASE") != "")
               {
               printf "rebase -x .\\ -a -b %s %s > NUL\n", "\%IMAGEBASE\%", targetname >dolnk
               printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
               }
            }
         }

      printf ":EXIT_ERR\n" >dolnk
      }

   # $(DEBUG)

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         if (nb_obj_elem > 0)
            {
            for (ndx=0; ndx<nb_obj_elem; ndx++)
               printf "%s\n", obj_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(LIB)") != 0)
         {
         if (nb_lib_elem > 0)
            {
            for (ndx=0; ndx<nb_lib_elem; ndx++)
               printf "%s\n", lib_list[ndx] >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         if (targettype == "dll")
            printf "/DLL\n" >lnkrspfile

         printf "/OUT:%s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "/MAP:%s.map\n", targetfile >lnkrspfile
         }

      else if (index($0, "$(DEF)") != 0)
         {
         if (deffile != "")
            printf "/DEF:%s\n", deffile >lnkrspfile
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
#         if (symbolicinfo == "/d")
#            gsub(/\$\(DEBUG\)/, "/DEBUG:FULL /DEBUGTYPE:CV", $0)
#         else
#            gsub(/\$\(DEBUG\)/, "/DEBUG:NONE", $0)

         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "/DEBUG:FULL /DEBUGTYPE:CV", $0)
         else
            gsub(/\$\(DEBUG\)/, "/DEBUG /DEBUGTYPE:BOTH /OPT:REF", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile

         printf "/PDB:NONE\n" >lnkrspfile
         }

      else if (index($0, "$(") != 0)
         {
         error("Wrong option")
         }

      else
         {
         if (index(tolower($0), "\.obj") != 0)
            {
            for (ndx=0; ndx<nb_obj_elem; ndx++)
               {
               if (tolower($2) == tolower(obj_list[ndx]))
                  break    # Duplicate between response file and link list
               }

            # if no duplicate, add OBJECT file to response file
            if (ndx == nb_obj_elem)
               printf "%s\n", $0 >lnkrspfile
            }
         else if (index(tolower($0), "\.lib") != 0)
            {
            for (ndx=0; ndx<nb_lib_elem; ndx++)
               {
               if (tolower($2) == tolower(lib_list[ndx]))
                  break    # Duplicate between response file and link list
               }

            # if no duplicate, add LIBRARY file to response file
            if (ndx == nb_lib_elem)
               printf "%s\n", $0 >lnkrspfile
            }
         else
            printf "%s\n", $0 >lnkrspfile
         }
      }
}


# --------------------------------------------------------------------------
function WATCOMlink()
{
   # Create batch to link for WATCOM

   lastChar = ""

   if (((pcOS = tolower(GetEnviron("OS"))) != "windows_nt") && (pcOS != "windows_98"))
      {
      # Probably DOS,
      # If targetfile is in current directory remove full path
      if (tolower(getcwd()) == substr(targetfile, 1, index(targetfile, "$")-2))
         targetfile = substr(targetfile, index(targetfile, "$"))
      }

   if (targettype == "bin" && match(tolower(GetEnviron("DOS4GPATH")), /4gwpro/) && length(substr(targetfile, index(targetfile, ")")+1)) == 8)
      {
      # Remove char at position 8 for _ prefix
      lastChar = substr(targetfile, length(targetfile), 1)
      targetfile = substr(targetfile, 1, length(targetfile)-1)
      }

   if (targettype == "bin")
      {
      targetname = targetfile""lastChar".exe"
      _targetname = targetfile".exe"
      }
   else if (targettype == "dll")
      {
      targetname = targetfile".dll"
      _targetname = targetname
      }
   else if (targettype == "lib")
      {
      targetname = targetfile".lib"
      _targetname = targetname
      }

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin" && match(tolower(GetEnviron("DOS4GPATH")), /4gwpro/))
      {
      gsub(/\$\(SPECIAL_CASE\)/, "", targetname)
      gsub(/\$\(SPECIAL_CASE\)/, "_", _targetname)
      }
   else
      {
      gsub(/\$\(SPECIAL_CASE\)/, "", targetname)
      gsub(/\$\(SPECIAL_CASE\)/, "", _targetname)
      }

   if (dolnk != "CON")
      {
      printf "wlink.exe @%s >%s\n", lnkrspfile, logFile >dolnk
      if (targettype == "bin" && match(tolower(GetEnviron("DOS4GPATH")), /4gwpro/))
         {
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         printf "4gwbind 4gwpro.exe %s %s -v\n", _targetname, targetname >dolnk
         printf ":EXIT_ERR\n" >dolnk
         }
      }

   # SYSTEM dos4g
   # $(DEBUG)
   # $(OBJ)
   # $(BIN)
   # $(LIB)
   # $(MAP)
   # OPTION STUB=$(wstub)
   # OPTION STACK=8000

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         for (ndx=0; ndx<nb_obj_elem; ndx++)
            printf "FILE %s\n", obj_list[ndx] >lnkrspfile
         }

      else if (index($0, "$(LIB)") != 0)
         {
         for (ndx=0; ndx<nb_lib_elem; ndx++)
            printf "LIBRARY %s\n", lib_list[ndx] >lnkrspfile
         }

      else if (index($0, "$(BIN)") != 0)
         {
         if (targettype == "bin" && match(tolower(GetEnviron("DOS4GPATH")), /4gwpro/))
            printf "NAME %s\n", _targetname >lnkrspfile
         else
            printf "NAME %s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "OPTION MAP=%s.map\n", targetfile""lastChar >lnkrspfile
         }

      else if ((index($0, "$(DEF)") != 0) || (index($0, "$(LCF)") != 0))
         {
         error("Wrong option")
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "DEBUG WATCOM ALL", $0)
         else
            gsub(/\$\(DEBUG\)/, "", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(wstub)") != 0)
         {
         if (GetEnviron("WSTUB") != "")
            {
            gsub(/\$\(wstub\)/, GetEnviron("WSTUB"), $0)

            if ($0 != "")
               printf "%s\n", $0 >lnkrspfile
            }
         }

      else if (index($0, "$(") != 0)
         {
         error("Wrong option")
         }

      else
         {
         if (index($0, "FILE") != 0)
            {
            for (ndx=0; ndx<nb_obj_elem; ndx++)
               {
               if (tolower($2) == tolower(obj_list[ndx]))
                  break    # Duplicate between response file and link list
               }

            # if no duplicate, add OBJECT file to response file
            if (ndx == nb_obj_elem)
               printf "%s\n", $0 >lnkrspfile
            }
         else if (index($0, "LIBRARY") != 0)
            {
            for (ndx=0; ndx<nb_lib_elem; ndx++)
               {
               if (tolower($2) == tolower(lib_list[ndx]))
                  break    # Duplicate between response file and link list
               }

            # if no duplicate, add LIBRARY file to response file
            if (ndx == nb_lib_elem)
               printf "%s\n", $0 >lnkrspfile
            }
         else
            printf "%s\n", $0 >lnkrspfile
         }
      }
}

# --------------------------------------------------------------------------
function C80link(mapFileName)
{
   # Create batch to link for C80

   if (GetEnviron("RAMX_SIZE") != "")
      RAMX_SIZE = GetEnviron("RAMX_SIZE")    # User defined
   else
      RAMX_SIZE = 2097152                    # 0x200000

   RAM_SIZE  = 67108864 - RAMX_SIZE          # 0x04000000 - RAMX_SIZE = 65011712 : 0x3e00000
   RAMX      = (4294967295 - RAMX_SIZE) + 1  # ((0xffffffff - RAMX_SIZE) + 1) = 4292870144 : 0xffe00000

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".out"
   else if (targettype == "dll")
      targetname = targetfile".out"
   else if (targettype == "lib")
      targetname = targetfile".out"

   if (dolnk != "CON" && (twoPass == 0 || twoPass == "yes"))
      {
      if (os == "/u")
         {
         printf "%sDOS2UNIX %s %s\\tmp.lnk\n", GetEnviron("RAMDRIVE"), lnkrspfile, GetEnviron("PATH_HOME_DRIVE") >dolnk
         printf "call %smvp_lnk ~/tmp.lnk %s\n", GetEnviron("RAMDRIVE"), logFile >dolnk
         if (twoPass == "yes")
            {
            printf "%sgawk -f %slnklst.awk @%sobj\\%s\\lnk.rul /twopass %s\n", GetEnviron("RAMDRIVE"), GetEnviron("RAMDRIVE"), GetEnviron("RAMDRIVE"), GetEnviron("OBJDIR"), mapFileName".map" >dolnk
            printf "%sDOS2UNIX %s %s\\tmp.lnk\n", GetEnviron("RAMDRIVE"), lnkrspfile, GetEnviron("PATH_HOME_DRIVE") >dolnk
            printf "call %smvp_lnk ~/tmp.lnk %s\n", GetEnviron("RAMDRIVE"), logFile >dolnk
            }
         }
      else
         {
         printf "mvplnk.exe %s >%s\n", lnkrspfile, logFile >dolnk
         if (twoPass == "yes")
            {
            printf "%sgawk -f %slnklst.awk @%sobj\\%s\\lnk.rul /twopass %s\n", GetEnviron("RAMDRIVE"), GetEnviron("RAMDRIVE"), GetEnviron("RAMDRIVE"), GetEnviron("OBJDIR"), mapFileName".map" >dolnk
            printf "mvplnk.exe %s >%s\n", lnkrspfile, logFile >dolnk
            }
         }

      printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
      printf "%sifexist %s\\.\n", GetEnviron("RAMDRIVE"), GetEnviron("PATH_PC_EMU") >dolnk
      printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
      printf "copy %s %s\\. >NUL\n", mapFileName".out", GetEnviron("PATH_PC_EMU") >dolnk
      printf ":EXIT_ERR\n" >dolnk

      printf "%schkerr %s\n", GetEnviron("RAMDRIVE"), logFile >dolnk
      }

   if (twoPass != 0 && twoPass != "yes")
      {
      printf "Second link pass, search end of code ...\n"
      mapFile = mapFileName".map"

      while (getline<mapFile >0)
         {
         if (index($0, " end") != 0)
            break
         }

      codeShift = asciiToVal("0x"$1)

      # 4294966272 = 0xfffffc00
      codeShift =  4294966272 - codeShift

      codeShift = (int(codeShift / 256)) * 256

      RAM_SIZE  += codeShift
      RAMX      += codeShift
      RAMX_SIZE -= codeShift

      printf "done, shift code up by %d bytes\n", codeShift
      printf "Do optimize link now ...\n"
      }

   # $(OBJ)
   # $(BIN)
   # $(MAP)
   # $(LIB)
   # $(DEBUG)
   # -c
   # -x
   # -v0
   # -heap 0x100000
   # -stack 0x11000
   #
   # MEMORY
   # {
   # ...
   #     $(RAM_SIZE)
   #     $(RAMX) ... $(RAMX_SIZE)
   # }
   #
   # SECTIONS
   # {
   # ...
   # }

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         for (ndx=0; ndx<nb_obj_elem; ndx++)
            printf "%s\n", obj_list[ndx] >lnkrspfile
         }

      else if (index($0, "$(LIB)") != 0)
         {
         for (ndx=0; ndx<nb_lib_elem; ndx++)
            {
            # Rename library to little if little tools used
            thisLibName = lib_list[ndx]

            if (match(auto_obj, /little/) != 0)
               {
               lenLibName = length(thisLibName)

               if (lenLibName < 12)
                  # Append extra l
                  gsub(/\.lib/, "l.lib", thisLibName)

               else if (lenLibName == 12)
                  # Remove last char and append extra l
                  gsub(/.\.lib/, "l.lib", thisLibName)

               else
                  {
                  # probably directory separator: \ for DOS, / for UNIX
                  nbf = split(thisLibName, tmpLibList, "[\/\\\\]")

                  # remove lib for now
                  gsub(tmpLibList[nbf], "", thisLibName)

                  lenLibName = length(tmpLibList[nbf])

                  if (lenLibName < 12)
                     # Append extra l
                     gsub(/\.lib/, "l.lib", tmpLibList[nbf])

                  else if (lenLibName == 12)
                     # Remove last char and append extra l
                     gsub(/.\.lib/, "l.lib", tmpLibList[nbf])

                  thisLibName = thisLibName""tmpLibList[nbf]
                  }
               }

            printf "-l %s\n", thisLibName >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         printf "-o %s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "-m %s.map\n", targetfile >lnkrspfile
         }

      else if ((index($0, "$(DEF)") != 0) || (index($0, "$(LCF)") != 0))
         {
         error("Wrong option")
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "", $0)
         else
            gsub(/\$\(DEBUG\)/, "-s", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(RAM_SIZE)") != 0)
         {
         thisValue = sprintf("0x%x", RAM_SIZE)
         gsub(/\$\(RAM_SIZE\)/,  thisValue, $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(RAMX)") != 0)
         {
         thisValue = sprintf("0x%x", RAMX)
         gsub(/\$\(RAMX\)/,      thisValue, $0)
         thisValue = sprintf("0x%x", RAMX_SIZE)
         gsub(/\$\(RAMX_SIZE\)/, thisValue, $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(") != 0)
         {
         # replace $(release.obj) by absolute path of file
         nbf = split($0, tmpstr, "[\(\)]")

         for (ndx=1; ndx<=nbf; ndx++)
            if (index(tmpstr[ndx], "$") != 0)
               break

         obj_to_replace = tolower(tmpstr[++ndx])
         subst_st = sprintf("\\$\\(%s\\)", obj_to_replace)

         for (ndx=0; ndx<nb_obj_elem; ndx++)
            if (index(obj_list[ndx], obj_to_replace) != 0)
               break

         gsub(subst_st, obj_list[ndx], $0)

         printf "%s\n", $0 >lnkrspfile
         }

      else
         printf "%s\n", $0 >lnkrspfile
      }

   for (ndx in tmpstr)
      delete tmpstr[ndx]
}

# --------------------------------------------------------------------------
function PowerPClink()
{
   # Create batch to link for PPC

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".elf"
   else if (targettype == "dll")
      targetname = targetfile".elf"
   else if (targettype == "lib")
      targetname = targetfile".elf"

   symbolfile = targetname
   gsub(/\.elf/, ".ab", symbolfile)

   if (dolnk != "CON")
      {
      printf "mwldeppc @%s >%s\n", lnkrspfile, logFile >dolnk
      if (symbolicinfo == "/d")
         {
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         if (GetEnviron("PPC_EMU") != "")
            printf "%sconvert.exe -w %s -c %s -t ppc\n", GetEnviron("PPC_EMU"), targetname, symbolfile >dolnk
         printf ":EXIT_ERR\n" >dolnk
         }
      }

   # $(OBJ)
   # $(BIN)
   # $(LIB)
   # $(DEBUG)
   # $(LCF)
   # $(MAP)
   # -version
   # -fp hard
   # -little
   # -proc 7400
   # -m _ReleaseId
   # -stacksize 0
   # -heapsize 0

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         for (ndx=0; ndx<nb_obj_elem; ndx++)
            printf "%s\n", obj_list[ndx] >lnkrspfile
         }

      else if (index($0, "$(LIB)") != 0)
         {
         for (ndx=0; ndx<nb_lib_elem; ndx++)
            {
            # Rename library to little if little tools used
            thisLibName = lib_list[ndx]

            if (match(auto_obj, /lppc/) != 0)
               {
               lenLibName = length(thisLibName)

               if (lenLibName < 12)
                  # Append extra l
                  gsub(/\.lib/, "l.lib", thisLibName)

               else if (lenLibName == 12)
                  # Remove last char and append extra l
                  gsub(/.\.lib/, "l.lib", thisLibName)

               else
                  {
                  # probably directory separator: \ for DOS, / for UNIX
                  nbf = split(thisLibName, tmpLibList, "[\/\\\\]")

                  # remove lib for now
                  gsub(tmpLibList[nbf], "", thisLibName)

                  lenLibName = length(tmpLibList[nbf])

                  if (lenLibName < 12)
                     # Append extra l
                     gsub(/\.lib/, "l.lib", tmpLibList[nbf])

                  else if (lenLibName == 12)
                     # Remove last char and append extra l
                     gsub(/.\.lib/, "l.lib", tmpLibList[nbf])

                  thisLibName = thisLibName""tmpLibList[nbf]
                  }
               }

            printf "%s\n", thisLibName >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         printf "-o %s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
         printf "-map %s.map\n", targetfile >lnkrspfile
         }

      else if (index($0, "$(DEF)") != 0)
         {
         error("Wrong option")
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
            gsub(/\$\(DEBUG\)/, "-g", $0)
         else
            gsub(/\$\(DEBUG\)/, "-sym off", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(LCF)") != 0)
         {
         lcffile = fmtfile
         gsub(/\.fmt/, ".lcf", lcffile)
         nbfield = split(lcffile, splitlcf, "\\")
         thislcf = GetEnviron("RAMDRIVE")"obj\\"GetEnviron("OBJDIR")"\\"splitlcf[nbfield]
         printf "-lcf %s\n", thislcf >lnkrspfile

         while (getline<lcffile >0)
            {
            if (index($0, "CREATION_DATE") == 0)   # Strip default creation date
               print $0 > thislcf
            }

         printf "\nCREATION_DATE=%d;\n", systime() > thislcf

         close(lcffile)
         }

      else
         printf "%s\n", $0 >lnkrspfile
      }

   for (ndx in tmpstr)
      delete tmpstr[ndx]
}

# --------------------------------------------------------------------------
function PowerPClinkMetaware()
{
   # Create batch to link for PPC

   gsub(/\$\(SPECIAL_CASE\)/, "", targetfile)

   if (targettype == "bin")
      targetname = targetfile".elf"
   else if (targettype == "dll")
      targetname = targetfile".elf"
   else if (targettype == "lib")
      targetname = targetfile".elf"

   symbolfile = targetname
   gsub(/\.elf/, ".ab", symbolfile)

   domap = "NO"
   if (dolnk != "CON")
      {
      printf "ldppc @%s >%s.map 2>%s\n", lnkrspfile, targetfile, logFile >dolnk
      if (symbolicinfo == "/d")
         {
         printf "if errorlevel 1 goto :EXIT_ERR\n" >dolnk
         if (GetEnviron("PPC_EMU") != "")
            printf "%sconvert.exe -w %s -c %s -t ppc\n", GetEnviron("PPC_EMU"), targetname, symbolfile >dolnk
         printf ":EXIT_ERR\n" >dolnk
         }
      }

   # $(OBJ)
   # $(BIN)
   # $(MAP)
   # $(LIB)
   # $(DEBUG)
   # $(LCF)
   # -fp hard
   # -little
   # -m _ReleaseId
   # -stacksize 0
   # -heapsize 0
   printf "-L %s\\lib\\altivec\\le\\fp\n", GetEnviron("HCDIR") > lnkrspfile

   while (getline<fmtfile >0)
      {
      if (index($0, "#") == 1)
         printf "" >lnkrspfile

      else if (index($0, "$(OBJ)") != 0)
         {
         for (ndx=0; ndx<nb_obj_elem; ndx++)
            printf "%s\n", obj_list[ndx] >lnkrspfile
         }

      else if (index($0, "$(LIB)") != 0)
         {
         for (ndx=0; ndx<nb_lib_elem; ndx++)
            {
            # Rename library to little if little tools used
            thisLibName = lib_list[ndx]

            if (match(auto_obj, /lmwppc/) != 0)
               {
               lenLibName = length(thisLibName)

               if (lenLibName < 12)
                  # Append extra l
                  gsub(/\.lib/, "l.lib", thisLibName)

               else if (lenLibName == 12)
                  # Remove last char and append extra l
                  gsub(/.\.lib/, "l.lib", thisLibName)

               else
                  {
                  # probably directory separator: \ for DOS, / for UNIX
                  nbf = split(thisLibName, tmpLibList, "[\/\\\\]")

                  # remove lib for now
                  gsub(tmpLibList[nbf], "", thisLibName)

                  lenLibName = length(tmpLibList[nbf])

                  if (lenLibName < 12)
                     # Append extra l
                     gsub(/\.lib/, "l.lib", tmpLibList[nbf])

                  else if (lenLibName == 12)
                     # Remove last char and append extra l
                     gsub(/.\.lib/, "l.lib", tmpLibList[nbf])

                  thisLibName = thisLibName""tmpLibList[nbf]
                  }
               }

            printf "%s\n", thisLibName >lnkrspfile
            }
         }

      else if (index($0, "$(BIN)") != 0)
         {
         printf "-o %s\n", targetname >lnkrspfile
         }

      else if (index($0, "$(MAP)") != 0)
         {
		 domap = "YES"
         printf "-m \n" >lnkrspfile
         }

      else if (index($0, "$(DEF)") != 0)
         {
         error("Wrong option")
         }

      else if (index($0, "$(DEBUG)") != 0)
         {
         if (symbolicinfo == "/d")
		    gsub(/\$\(DEBUG\)/, " ", $0)
		 else
            gsub(/\$\(DEBUG\)/, "-s", $0)

         if ($0 != "")
            printf "%s\n", $0 >lnkrspfile
         }

      else if (index($0, "$(LCF)") != 0)
         {
         lcffile = fmtfile
         gsub(/\.fmt/, ".lcf", lcffile)
         nbfield = split(lcffile, splitlcf, "\\")
         thislcf = GetEnviron("RAMDRIVE")"obj\\"GetEnviron("OBJDIR")"\\"splitlcf[nbfield]
         printf "%s\n", thislcf >lnkrspfile

         while (getline<lcffile >0)
            {
            if (index($0, "CREATION_DATE") == 0)   # Strip default creation date
               print $0 > thislcf
            }   

         printf "\nCREATION_DATE=%d;\n", systime() > thislcf
         printf "\nINITDATA .bss,.sbss\n" > thislcf

         close(lcffile)
         }

      else
         printf "%s\n", $0 >lnkrspfile
      }

      if ( domap != "YES")
      {
         printf "del %s.map\n",  targetfile >dolnk
      }

   for (ndx in tmpstr)
      delete tmpstr[ndx]
}

BEGIN {
   if (ARGC < 2)
      {
      printf "Usage: gawk -f lnklst.awk [@options_list_file] [options_list]\n"
      printf "       See imlk.hlp for more details.\n"
      exit 0
      }

   err            = 0
   nb_rd_elem     = 0
   nb_obj_elem    = 0
   nb_lib_elem    = 0
   nb_g_list      = 0
   os             = ""
   drive          = GetEnviron("PATH_PROJECT")
   release        = ""
   targettype     = "bin"
   targetfile     = "noname"
   deffile        = ""
   symbolicinfo   = "/d"
   lnkrspfile     = "CON"
   dupfile        = "CON"
   dolnk          = "CON"
   definedObj[0]  = ""
   obj_list[0]    = ""
   lib_list[0]    = ""
   twoPass        = 0

   for (ndx=1; ndx<ARGC; ndx++)
      {
      if (index(ARGV[ndx], "@") != 0)
         {
         curArgNdx = ndx
         curArgc = ARGC
         split(ARGV[ndx], awkrspfile, "@")

         checkFile(awkrspfile[2], "response file for GAWK")

         while (getline<awkrspfile[2] > 0)
            {
            ndf = split($0, rsp, " ")
            for (ii=1; ii<=ndf; ii++)
               {
               ARGV[ARGC++] = rsp[ii]
               }
            }

         close(awkrspfile[2])

         ARGV[curArgNdx] = ""
         for (ii=curArgNdx+1; ii<curArgc; ii++)
            {
            ARGV[ARGC++] = ARGV[ii]
            ARGV[ii] = ""
            }
         }

      if (tolower(ARGV[ndx]) == "/d")
         {
         ARGV[ndx++] = ""
         if (tolower(ARGV[ndx]) == "yes")
            symbolicinfo = "/d"
         else if (tolower(ARGV[ndx]) == "no")
            symbolicinfo = ""
         }

      if (tolower(ARGV[ndx]) == "/rev")
         {
         ARGV[ndx++] = ""
         release = ARGV[ndx]"\\"
         }

      if (tolower(ARGV[ndx]) == "/obj")
         {
         ARGV[ndx++] = ""
         auto_obj = tolower(ARGV[ndx])
         gsub(/\\/, "/", auto_obj)     # \ could be confusing in gsub() calls, not /
                                       # / will be changed in toDos()
         }

      if (tolower(ARGV[ndx]) == "/l")
         {
         ARGV[ndx++] = ""
         filelist[nb_g_list++] = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/bin")
         {
         ARGV[ndx++] = ""
         targettype = "bin"
         targetfile = normalizeName(ARGV[ndx])
         }

      if (tolower(ARGV[ndx]) == "/lib")
         {
         ARGV[ndx++] = ""
         targettype = "lib"
         targetfile = normalizeName(ARGV[ndx])
         }

      if (tolower(ARGV[ndx]) == "/dll")
         {
         ARGV[ndx++] = ""
         targettype = "dll"
         targetfile = normalizeName(ARGV[ndx])
         }

      if (tolower(ARGV[ndx]) == "/def")
         {
         ARGV[ndx++] = ""
         deffile = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/fmt")
         {
         ARGV[ndx++] = ""
         fmtfile = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/rsp")
         {
         ARGV[ndx++] = ""
         lnkrspfile = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/dup")
         {
         ARGV[ndx++] = ""
         dupfile = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/dolnk")
         {
         ARGV[ndx++] = ""
         dolnk = ARGV[ndx]
         }

      if (tolower(ARGV[ndx]) == "/dig")
         {
         ARGV[ndx++] = ""
         DigDirPath = ARGV[ndx]
         }
      else
         DigDirPath = ""

      if (tolower(ARGV[ndx]) == "/twopass")
         {
         ARGV[ndx++] = ""
         twoPass = tolower(ARGV[ndx])

         if (twoPass == "no")
            twoPass = 0
         }

      ARGV[ndx] = ""
      }

   for (ndx in awkrspfile)
      delete awkrspfile[ndx]

   for (ndx in ARGV)
      delete ARGV[ndx]

   for (ndx in rsp)
      delete rsp[ndx]

   # Only drive letter is required
   split(drive, tmpstr, ":")
   drive = tmpstr[1]":"

   for (ndx in tmpstr)
      delete tmpstr[ndx]


   # Transform target file to 'drive:\path\target' (no extension)
   for (chNdx=length(targetfile); chNdx>0 && chNdx > length(targetfile) - 4; chNdx--)
      {
      if (match(substr(targetfile, chNdx), /\./) != 0)
         break
      }

   if (chNdx == length(targetfile) - 4)
      chNdx = length(targetfile)
   else
      chNdx--

   targetfile = substr(targetfile,1,chNdx)

   split(tolower(getcwd()), currentDrive, ":")
   if (currentDrive[2] == "\\")
      currentDrive[2] = ""

   if (index(targetfile, ":\\") != 0)
      targetfile = targetfile""
   else if (index(targetfile, ":") != 0)
      {
      split(targetfile, tmpstr, ":")
      curdir = "cd "tmpstr[1]":"
      curdir|getline
      close(curdir)
      split(tolower($0), currentDrive, ":")
      if (currentDrive[2] == "\\")
         currentDrive[2] = ""
      targetfile = tmpstr[1]":"currentDrive[2]"\\"tmpstr[2]

      split(tolower(getcwd()), currentDrive, ":")
      if (currentDrive[2] == "\\")
         currentDrive[2] = ""

      for (ndx in tmpstr)
         delete tmpstr[ndx]
      }
   else if (index(targetfile, "\\") != 0)
      {
      tmp_str = currentDrive[1]":"targetfile
      targetfile = tmp_str
      }
   else
      {
      tmp_str = currentDrive[1]":"currentDrive[2]"\\"targetfile
      targetfile = tmp_str
      }


   if (nb_g_list >= 1)
      {
      # Read all available list
      for (ndx_g_list=0; ndx_g_list<nb_g_list; ndx_g_list++)
         {
         getListe(filelist[ndx_g_list])
         }

      for (ndx in definedObj)
         delete definedObj[ndx]

      for (ndx in filelist)
         delete filelist[ndx]

      # If a format file is defined we can proceed with link
      gsub(/\.fmt\.fmt/, ".fmt", fmtfile)

      if (fmtfile != "")
         {
         checkFile(fmtfile, "format file")

         # Get format type from 1st line of format file
         if (getline<fmtfile > 0)
            {
            logFile = GetEnviron("RAMDRIVE")"obj\\"GetEnviron("OBJDIR")"\\lnk.log"

            # Link for the format specified
            if (index($0, "BORLAND") != 0)
               {
               setDrive(drive)
               toDos()
               BORLANDlink()
               }
            if (index($0, "BC45") != 0)
               {
               setDrive(drive)
               toDos()
               BC45link()
               }
            else if (index($0, "MICROSOFT") != 0)
               {
               setDrive(drive)
               toDos()
               MICROSOFTlink()
               }
            else if (index($0, "WATCOM") != 0)
               {
               setDrive(drive)
               toDos()
               WATCOMlink()
               }
            else if (index($0, "PPC") != 0)
               {
               setDrive(drive)
               toDos()
               PowerPClink()
               }
            else if (index($0, "METAWARE") != 0)
               {
               setDrive(drive)
               toDos()
               PowerPClinkMetaware()
               }
            else if (index($0, "C80") != 0)
               {
               mapFileName = targetfile
               gsub(/\$\(SPECIAL_CASE\)/, "", mapFileName)
               if (GetEnviron("PATH_PROJECT_UNX") != "")
                  {
                  os = "/u"
                  drive = GetEnviron("PATH_PROJECT_UNX")
                  setDrive(drive)
                  toUnix()
                  C80link(mapFileName)
                  }
               else
                  {
                  setDrive(drive)
                  toDos()
                  C80link(mapFileName)
                  }
               }

            close(fmtfile)

            mirrorsite = GetEnviron("MIRROR_BIN_TO")
            if ((twoPass == 0 || twoPass == "yes") && mirrorsite != "")
               {
               printf "if errorlevel 1 goto :END\n" >dolnk

               nbf = split(mirrorsite, mirrorlist, ";")
               split(targetname, mirrorname, ":")

               for (ndx=1; ndx<=nbf; ndx++)
                  {
                  printf "ifexist %s\n", mirrorlist[ndx] >dolnk
                  printf "if not errorlevel 1 copy %s %s > NUL\n", targetname, mirrorlist[ndx]""mirrorname[2] >dolnk
                  }

               printf "ifexist .\n" >dolnk

               for (ndx in mirrorname)
                  delete mirrorname

               for (ndx in mirrorlist)
                  delete mirrorlist

               printf ":END\n" >dolnk
               }

            close(dolnk)
            }
         else
            error("Invalid or unknown format file")
         }
      else
         error("No format file specified")

      for (ndx in currentDrive)
         delete currentDrive[ndx]

      for (ndx in mirrorname)
         delete mirrorname[ndx]
      }
   else
      error("No link list specified")
}
